This file contains information about GCC releases which has been generated
automatically from the online release notes.  It covers releases of GCC
(and the former EGCS project) since EGCS 1.0, on the line of development
that led to GCC 3. For information on GCC 2.8.1 and older releases of GCC 2,
see ONEWS.

======================================================================
http://gcc.gnu.org/gcc-16/index.html
                             GCC 16 Release Series

   April 30, 2026

   The GCC developers are pleased to announce the release of GCC 16.1.

   This release is a major release, containing new features (as well as
   many other improvements) relative to GCC 15.x.

Release History

   GCC 16.1
          April 30, 2025 ([1]changes, [2]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [3]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [4]GCC project
   web site or contact the [5]GCC development mailing list.

   To obtain GCC please use [6]our mirror sites or [7]our version control
   system.


    For questions related to the use of GCC, please consult these web
    pages and the [8]GCC manuals. If that fails, the
    [9]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [10]gcc@gcc.gnu.org. All of [11]our lists have public
    archives.

   Copyright (C) [12]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [13]maintained by the GCC team. Last modified
   2026-04-30.

References

   1. https://gcc.gnu.org/gcc-16/changes.html
   2. http://gcc.gnu.org/onlinedocs/16.1.0/
   3. http://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/Contributors.html
   4. https://gcc.gnu.org/index.html
   5. mailto:gcc@gcc.gnu.org
   6. https://gcc.gnu.org/mirrors.html
   7. https://gcc.gnu.org/git.html
   8. https://gcc.gnu.org/onlinedocs/
   9. mailto:gcc-help@gcc.gnu.org
  10. mailto:gcc@gcc.gnu.org
  11. https://gcc.gnu.org/lists.html
  12. https://www.fsf.org/
  13. https://gcc.gnu.org/about.html
======================================================================
http://gcc.gnu.org/gcc-16/changes.html
                             GCC 16 Release Series
                        Changes, New Features, and Fixes

   This page is a "brief" summary of some of the huge number of
   improvements in GCC 16. You may also want to check out our [1]Porting
   to GCC 16 page and the [2]full GCC documentation.

Caveats

     * int8_t etc. are now signed char on Solaris for conformance with the
       C99 standard. However, this is an incompatible change. See [3]the
       porting notes for more information.
     * The -pthread option no longer predefines _REENTRANT on Solaris. See
       [4]the porting notes for more information.
     * The so-called "json" format for [5]-fdiagnostics-format= has been
       removed in this release. Users seeking machine-readable diagnostics
       from GCC should use [6]SARIF.

[7]General Improvements

  [8]Documentation

     * The documentation for [9]GCC Command Options and the [10]option
       index have been corrected to include many previously missing
       options.
     * The documentation for [11]GCC-specific attributes has been
       modernized to put more emphasis on the standard attribute syntax,
       which GCC accepts in all supported dialects of C and C++. The
       material has also been reorganized to be less repetitive, and there
       is a new [12]index for attributes.
     * Documentation for parameters and option spec files has been moved
       from the main GCC manual to the [13]GCC internals manual. These
       features are intended for use by GCC developers and those who need
       to build custom GCC configurations.

[14]New Languages and Language specific improvements

  [15]OpenMP

   See the [16]GNU Offloading and Multi-Processing Project (GOMP) page for
   general information.
     * The [17]memory allocation support has been enhanced: for allocators
       with the pinned trait, including ompx_gnu_pinned_mem_alloc, the
       [18]CUDA API (if available) is used; this improves the performance
       when accessing this memory on Nvidia GPUs. The newly added
       ompx_gnu_managed_mem_alloc allocator and the
       ompx_gnu_managed_mem_space (both GNU extensions) allocate
       device-accessible memory on the host. Such memory is device
       accessible even when unified-shared memory is not supported and
       might have different page-migration behavior than other memory on
       systems even if all host memory is device accessible.
     * OpenMP 5.0: Limited support for declare mapper has been added for C
       and C++, only. The uses_allocators clause is now supported,
       including the OpenMP 5.2 syntax changes and supporting semicolons
       (OpenMP 6.0); for now, only predefined allocators are supported.
     * OpenMP 5.1: Initial support for the iterator modifier in map
       clauses and the target update construct has been added for C and
       C++.
     * OpenMP 5.2: The begin declare variant directive for C and C++ is
       now supported.
     * OpenMP 6.0: The [19]omp_target_memset and
       [20]omp_target_memset_async API routines have been added. The
       no_openmp_constructs assumptions clause can now be used.
     * OpenMP Technical Report 14 (TR14): The named omp_default_device
       constant has been added to denote the default-device number.
     * For OpenMP directives and clauses that have been deprecated in
       OpenMP 5.0, 5.1, or 5.2, a deprecation warning is shown, hinting at
       the to-be-used syntax; the warning is on by default and can be
       silenced using -Wno-deprecated-openmp. Additionally, a deprecation
       warning is shown when using a deprecated named constant or API
       routine; this warning can be silenced using
       -Wno-deprecated-declarations.

  [21]OpenACC

   See the GCC [22]OpenACC wiki page for general information.
     * The [23]acc_memcpy_device and acc_memcpy_device_async API routines
       have been added for C, C++ and Fortran.
     * OpenACC 3.0: The wait directive now accepts the if clause.
     * OpenACC 3.3: The Fortran API routines [24]acc_attach and
       [25]acc_detach now augment their OpenACC 2.6 C/C++ counterparts.
     * OpenACC 3.4: In Fortran, named constants (PARAMETER) used as var in
       data clauses are now permitted by the specification and GCC for
       better compatibility with existing code; however, with GCC,
       specifying them in data clauses affects neither compile-time nor
       runtime behavior.

  [26]Ada

    GNAT Extensions

     * The [27]Constructor [28][RFC] and [29]Destructor [30][RFC]
       extensions add new construction/finalization mechanisms that differ
       significantly from standard Ada. Those features are inspired by
       object-oriented programming in other widely used languages (such as
       C++).
     * [31]Implicit with allows a stand-alone use clause in the context
       clause of a compilation unit to imply an implicit with of the same
       library unit where an equivalent with clause would be allowed.
     * [32]Structural Generic instantiation [33][RFC] allows reference to
       an implicit instance of a generic unit, that is denoted directly by
       the unit’s name and actual parameters, rather than by a separately
       declared name.
     * The [34]Extended_Access aspect can be specified on a general access
       type declaration designating an unconstrained array subtype. It
       changes the pointer representation and allows easier interfacing
       with foreign languages when memory for the designated object is not
       allocated by Ada. In particular, it allows the creation of
       [35]access to an array slice [36][RFC].

    Other

     * VAST (Verifier for the Ada Semantic Tree), enabled with -gnatd_V
       (or -gnatd_W for verbose mode), can be used to debug the compiler.
       It checks various properties of the produced Ada Semantic Tree and
       reports detected violations.
     * The semantic analysis of Ada 2022’s Reduction Expressions has been
       enhanced.
     * The Ada.Containers.Bounded_Indefinite_Holders unit has been added.
     * Various loopholes in the implementation of accessibility rules have
       been plugged.
     * Android support has been improved.

  [37]C++

     * C++20 by default: GCC 16 changes the default language version for
       C++ compilation from [38]-std=gnu++17 to [39]-std=gnu++20. If your
       code relies on older versions of the C++ standard, you will need to
       either add [40]-std= to your build flags, or port your code; see
       [41]the porting notes. N.B. C++20 modules support is still
       experimental and must be enabled by [42]-fmodules.
     * Several C++26 features have been implemented:
          + [43]P2996R13, Reflection ([44]PR120775, enabled by -std=c++26
            -freflection)
          + [45]P3394R4, Annotations for Reflection
          + [46]P3293R3, Splicing a base class subobject
          + [47]P3096R12, Function Parameter Reflection
          + [48]P3491R3, define_static_{string,object,array}
            ([49]PR120783)
          + [50]P3560R2, Error Handling in Reflection
          + [51]P1306R5, Expansion statements ([52]PR120776)
          + [53]P2900R14, Contracts ([54]PR119061)
          + [55]P2795R5, Erroneous behavior for uninitialized reads
            ([56]PR114457)
          + [57]P1061R10, Structured bindings can introduce a pack
            ([58]PR117783)
          + [59]P3068R5, constexpr exceptions ([60]PR117785)
          + [61]P3533R2, constexpr virtual inheritance ([62]PR120777)
          + [63]P1494R5, Partial program correctness ([64]PR119060)
          + [65]P3618R0, Allow attaching main to the global module
            ([66]PR120773)
          + [67]P2843R3, Preprocessing is never undefined ([68]PR120778)
          + [69]P2686R4, constexpr structured bindings and references to
            constexpr variables ([70]PR117784, only partially, structured
            bindings can be constexpr but references to constexpr
            automatic variables still not allowed)
     * Several C++23 features have been implemented:
          + [71]P2036R3, Change scope of lambda trailing-return-type
            ([72]PR102610)
          + [73]P2590R2, Explicit lifetime management ([74]PR106658)
          + [75]P2246R1, Character encoding of diagnostic text
            ([76]PR102613)
     * Various C++ error messages (such as for problems involving
       templates) now have a hierarchical structure. This nesting of
       messages is presented using indentation and bullet points. The old
       behavior can be restored via [77]-fno-diagnostics-show-nesting or
       [78]-fdiagnostics-plain-output.
     * Improved experimental C++20 modules support:
          + New command line option --compile-std-module that conveniently
            builds the <bits/stdc++.h> header unit and the std and
            std.compat modules before compiling any source files
            explicitly specified on the command line.
          + Whenever the <bits/stdc++.h> header unit has been built, GCC
            now transparently translates an #include of any importable
            standard library header into an import of <bits/stdc++.h>.
          + Many reported bugs have been fixed, thanks to Nathaniel Shead.
     * Constraint failure diagnostics for standard library type traits
       such as is_constructible_v and is_invocable_v are improved to
       further elaborate why the trait is false instead of just reporting
       expression is_foo_v<...> evaluated to false, thanks to Nathaniel
       Shead.

    [79]Runtime Library (libstdc++)

     * For targets that support [80]128-bit integers,
       std::is_integral<__int128> and similar traits are always true.
       Previously this was only the case when compiling with GNU dialects
       (-std=gnu++17, -std=gnu++14, etc.) and not with strict dialects
       (-std=c++17, etc.)
     * The proposal [81]P0952R2: A new specification for
       std::generate_canonical was implemented in all affected modes
       (since C++11), impacting the observed output. The previous behavior
       can be restored by defining _GLIBCXX_USE_OLD_GENERATE_CANONICAL.
     * The std::variant ABI was updated to make it conforming and
       consistent with C++20 and later modes. This impacts the layout of
       classes which have a std::variant as the first member and a base
       class of the same type as one of the variant's alternatives, if
       that type is an empty class and has a non-trivial destructor:
struct E { ~E(); };
struct Affected : E
{
  std::variant<E, int> mem; // previously stored at offset zero,
                            // uses non-zero offset now
};
       The previous behavior can be restored by defining
       _GLIBCXX_USE_VARIANT_CXX17_OLD_ABI. This impacts only C++17 mode.
     * std::regex execution has been rewritten to use a heap-based stack
       instead of the system stack, avoiding stack overflows when matching
       larger strings.
     * Improved support for C++20, including:
          + The C++20 implementation is no longer experimental.
          + Working std::chrono::current_zone() on Windows (thanks to
            Björn Schäpers).
     * There are several changes to C++20 components which are
       incompatible with the experimental C++20 support in previous
       releases. The following C++20 components have ABI changes in GCC
       16:
          + Atomic waiting/notifying functions in <atomic> and semaphore
            types in <semaphore>. Synchronization for <syncstream>.
          + The representation of std::format args and std::formatter
            specializations.
          + The representation of the std::partial_ordering type in
            <compare>.
          + Semantics of std::variant with std::jthread, std::stop_token,
            and std::stop_source alternatives.
          + Representation of some range adaptors in <ranges>.
       This list is not necessarily complete. As C++20 support was
       experimental before GCC 16, programs using C++20 components should
       assume that those components are not compatible with older
       releases.
     * Improved experimental support for C++23, including:
          + std::mdspan, thanks to Luc Grosheintz.
          + ranges::starts_with and ranges::ends_with.
          + ranges::shift_left and ranges::shift_right.
          + std::allocator_traits::allocate_at_least.
     * Improved experimental support for C++26, including:
          + std::simd.
          + std::inplace_vector.
          + std::optional<T&>.
          + std::copyable_function and std::function_ref.
          + std::indirect and std::polymorphic.
          + std::owner_equal for shared pointers, thanks to Paul Keir.
          + <debugging> header and contents.
          + New std::stringstream and std::bitset member functions
            accepting std::string_view arguments, thanks to Nathan Myers.
          + Padded mdspan layouts, aligned accessor, std::dims,
            std::constant_wrapper, and std::submdspan thanks to Luc
            Grosheintz.
          + std::philox_engine, thanks to 1nfocalypse.
          + std::atomic_ref::address(), thanks to Yuao Ma.

  [82]Fortran

     * Coarrays using native shared memory mulithreading on single node
       machines and handling Fortran 2018's TEAM feature.
     * Fortran 2003: Parameterized Derived Types support is improved.
       Handling of LEN parameters works but still requires a future change
       of representation (see PR82649).
     * Fortran 2018: Support the extensions to the IMPORT statement, the
       REDUCE intrinsic and the new GENERIC statement.
     * The Fortran 2023 additions to the trigonometric functions are now
       supported (such as the sinpi intrinsic).
     * Fortran 2023: The split intrinsic subroutine is now supported and
       c_f_pointer now accepts an optional lower bound as a argument.
     * The -fexternal-blas64 option has been added to call external BLAS
       routines with 64-bit integer arguments for MATMUL. This option is
       only valid for 64-bit systems and when -ffrontend-optimize is in
       effect.

  [83]Modula-2

     * Spelling hints have been implemented. Currently spelling hints are
       issued when processing: import lists, module names and all symbols
       within nested scopes.
     * A new implementation of wide set is used and this is accompanied
       with a library module M2WIDESET. This has changed the ABI and may
       lead to link-time errors with object files generated with a
       previous GCC version.
     * A binary dictionary module BinDict has been added to the base
       libraries.
     * The procedures Write and WriteLn are available in the modules:
       ARRAYOFCHAR, CFileSysOp, CHAR, FileSysOp, String and
       StringFileSysOp.
     * The -fm2-pathname-root= option has been added to improve access to
       external library modules.

  [84]Algol 68

     * GCC now includes an experimental Algol 68 compiler, ga68. It aims
       to implement the language described by the Revised Report,
       including all errata approved by the Algol 68 Support subcommittee
       of IFIP WG2.1. Some GNU extensions and a POSIX prelude are also
       implemented.
       More information about the language can be found on [85]the Algol
       68 website.
       More information about the front end can be found on [86]the wiki.

[87]New Targets and Target Specific Improvements

  [88]IA-32/x86-64

     * GCC now supports AMD CPUs based on the Zen6 core via -march=znver6.
       This switch enables the AVX512_BMM, AVX_NE_CONVERT, AVX_IFMA,
       AVX_VNNI_INT8 and AVX512_FP16 ISA extensions on top of ISA
       extensions enabled for Zen5.
     * Auto-vectorization will now try to use a masked vector epilog when
       AVX512 support is enabled and tuning for znver4, znver5 or znver6,
       saving code size and improving performance.
     * GCC now supports the Intel CPU named Wildcat Lake through
       -march=wildcatlake. Wildcat Lake is based on Panther Lake.
     * GCC now supports the Intel CPU named Nova Lake through
       -march=novalake. Based on ISA extensions enabled on Panther Lake,
       the switch in addition enables the APX_F, AVX10.1, AVX10.2 and
       PREFETCHI ISA extensions.
     * Since GCC 16, AMX-TRANSPOSE and USER_MSR are not enabled through
       the compiler switch -march=diamondrapids any longer. CLDEMOTE is
       not enabled through the compiler switches -march=alderlake,
       -march=arrowlake, -march=arrowlake-s, -march=gracemont,
       -march=lunarlake, -march=meteorlake, -march=pantherlake and
       -march=raptorlake any longer. KL and WIDEKL are not enabled through
       the compiler switches -march=clearwaterforest and
       -march=pantherlake any longer. PREFETCHI is not enabled through the
       compiler switch -march=pantherlake any longer.
     * -mavx10.1-256, -mavx10.1-512, and -mevex512 were removed together
       with the warning for the behavior change on -mavx10.1. -mavx10.1
       has enabled AVX10.1 intrinsics with 512-bit vector support since
       GCC 15.
     * Support for AMX-TRANSPOSE was removed in GCC 16. GCC will no longer
       accept -mamx-transpose,
     * The new --enable-x86-64-mfentry configure option enables -mfentry
       which uses __fentry__, instead of mcount for profiling on x86-64.
       This option is enabled by default for glibc targets.
     * --enable-tls=DIALECT is now supported to control the default TLS
       dialect. The default remains gnu. The accepted values are gnu and
       gnu2 (for TLS descriptors).

  [89]AMD GPU (GCN)

     * For offloading to AMD GPUs: The launch overhead of OpenMP target
       regions and OpenACC compute regions has been drastically reduced.
     * Experimental support for AMD Instinct MI300 (gfx942) devices has
       been added, including the generic gfx9-4-generic and mostly
       compatible gfx950.
     * By default, the following multilibs are now built: gfx908, gfx90a,
       gfx9-generic, gfx9-4-generic, gfx10-3-generic, and gfx11-generic.
       Multilibs for specific devices are no longer built by default if a
       generic arch exists. Note:
          + When compiling for a specific arch and the multilib only
            exists for the associated generic arch, GCC's error message
            suggests the command-line option to do so.
          + Generic architectures require ROCm 6.4.0 or newer.
          + The new default-built set of multilibs now requires the
            assembler and linker of LLVM 20 or newer.
          + Consult GCC's [90]AMD installation notes and [91]configuration
            notes for setting the multilibs to be build.

  [92]LoongArch

     * Bit-precise integer types (_BitInt (N) and unsigned _BitInt (N))
       are supported.
     * Added FunctionMulti-Versioning (FMV) support. The [93]target_clones
       attribute can be used to generate multiple function versions for
       different LoongArch CPU features (e.g., lsx, lasx), with automatic
       runtime selection of the optimal version based on CPU capabilities.
     * Added support for the LoongArch32 architecture, including the
       ilp32d (default), ilp32f, and ilp32s ABIs.
       This covers both the standard 32-bit version (LA32) and the reduced
       32-bit version (LA32R), enabling GCC to generate 32-bit target code
       for a wider range of embedded applications.
       (Note: This feature depends on corresponding Binutils and glibc
       support.)

  [94]S/390, System z, IBM z Systems

     * Bit-precise integer types (_BitInt (N) and unsigned _BitInt (N))
       are supported, now.
     * Floating-point type _Float16 is supported. All operations are
       carried out in software or by float instructions.
     * Global stack protector support has been added and exported via
       -mstack-protector-guard=global. Option
       -mstack-protector-guard-record was added, too. The primary use is
       for the Linux kernel in order to support run-time patching of the
       address loading of the canary.
     * Support for -m31 is deprecated and will be removed in a future
       release.

[95]Operating Systems

  [96]Solaris

     * GCC now supports the easy generation of Solaris CTF (Compact C Type
       Format) with the -gsctf option. More information can be found in
       the ctf(5) manual page.

  [97]Windows

     * GCC now supports native TLS (Thread-Local Storage) on Windows. In
       order to enable it, --enable-tls must be specified at configure
       time and recent GNU binutils must be used (version 2.44 or later).

[98]Improvements to GCC Diagnostics

     * GCC can now output diagnostics in HTML form via
       [99]-fdiagnostics-add-output=experimental-html
     * GCC's SARIF output now respects the [100]dump directory. For
       example, given
      gcc \
        -o build-dir/foo.o \
        -fdiagnostics-add-output=sarif
        foo.c

       GCC 15 would write the SARIF to foo.c.sarif, whereas GCC 16 now
       writes it to build-dir/foo.c.sarif.
     * GCC's SARIF output now captures the nesting of logical locations.
     * In GCC's SARIF output, fix objects now contain description
       properties in many cases.
     * GCC's SARIF output has gained 5 new values for the [101]§3.38.8
       kinds property of threadFlowLocation, for expressing non-standard
       control flow:
          + throw for throwing an exception
          + catch for catching an exception
          + unwind for unwinding stack frame(s) during exception-handling
          + setjmp for calls to setjmp
          + longjmp for calls to longjmp that rewind the program
            counter/stack to the location of a previous setjmp call
     * GCC diagnostics can now have directed graphs associated with them,
       and can also report "global" directed graphs. Graphs are ignored by
       text sinks, but are captured by SARIF sinks, and the
       "experimental-html" renders any such graphs in SVG-based form using
       dot. For example, setting cfgs=yes on a SARIF or HTML diagnostic
       sink will enable capturing GCC's intermediate representation of
       every function at every optimization pass.
     * GCC diagnostics can now refer to logical locations inside XML and
       JSON files (such as via libgdiagnostics). The sarif-replay tool now
       uses this to provide JSON pointers when it reports on issues in its
       SARIF input.
     * If [102]GCC_DIAGNOSTICS_LOG is set in the environment, GCC's
       diagnostic subsystem will emit a text log to stderr (or a named
       file) to track what it's doing and the decisions it's making (e.g.
       exactly when and why a diagnostic is being rejected).
     * If [103]EXPERIMENTAL_SARIF_SOCKET is set in the environment, GCC
       will attempt to connect to that socket on startup and send JSON-RPC
       notifications to it for every diagnostic emitted.

[104]Improvements for plugin authors

     * GCC has gained a "publish/subscribe" framework, allowing for
       loosely-coupled senders and receivers, with strongly-typed messages
       passing between them. In this release the only topics for plugins
       to subscribe to are:
          + events relating to optimization passes starting/stopping on
            particular functions
          + events relating to the static analyzer
     * GCC diagnostic sinks can now have extension objects associated with
       them, with a finalizer hook. Plugins can use this to capture
       additional information in SARIF output files.
     * GCC's diagnostic machinery has been substantially cleaned up in GCC
       16. This should not affect plugins that use just the
       diagnostic-core.h header, but maintainers of plugins making more
       sophisticated uses of diagnostics may need to refer to the
       [105]porting guide.

[106]Improvements to Static Analyzer

     * The analyzer is now usable on simple C++ examples, as it now
       handles C++'s Named Return Value Optimization and has some initial
       support for exceptions. However due to scaling issues it is not
       likely to be usable on production C++ code in this release.
     * With the added support for exception-handling, -fanalyzer assumes
       that a call to an external function not marked with attribute
       nothrow could throw an exception if -fexceptions is enabled. GCC 16
       adds a new option [107]-fanalyzer-assume-nothrow, for disabling
       this assumption. This is intended as a workaround for projects
       where the exception-handling generates large numbers of new
       warnings, such as C code where -fexceptions is used for
       interoperability with C++ but where the C APIs in use are unlikely
       to throw exceptions.
     * The data structure used by -fanalyzer for representing the user's
       code has been rewritten in a way that makes it easier to understand
       and debug, and slightly improves locations used when reporting
       diagnostics. This comes at the cost of increasing the memory usage
       of the analyzer.
     * The data structure used by -fanalyzer for simulating the contents
       of memory in the user's program has been reimplemented. The new
       implementation is faster and easier to maintain.
     * The analyzer has started to make use of GCC's value_range
       machinery, eliminating some false positives.

[108]Improvements to libgdiagnostics

   [109]libgdiagnostics has gained 37 entrypoints:
     * 5 new entrypoints for working with logical locations
          + [110]diagnostic_logical_location_get_kind()
          + [111]diagnostic_logical_location_get_parent()
          + [112]diagnostic_logical_location_get_short_name()
          + [113]diagnostic_logical_location_get_fully_qualified_name()
          + [114]diagnostic_logical_location_get_decorated_name()
     * 2 new entrypoints for supporting command-line options and SARIF
       playback
          + [115]diagnostic_manager_add_sink_from_spec()
          + [116]diagnostic_manager_set_analysis_target()
     * 12 new entrypoints for working with directed graphs:
          + [117]diagnostic_manager_new_graph()
          + [118]diagnostic_manager_take_global_graph()
          + [119]diagnostic_take_graph()
          + [120]diagnostic_graph_release()
          + [121]diagnostic_graph_set_description()
          + [122]diagnostic_graph_add_node()
          + [123]diagnostic_graph_add_edge()
          + [124]diagnostic_graph_get_node_by_id()
          + [125]diagnostic_graph_get_edge_by_id()
          + [126]diagnostic_node_set_label()
          + [127]diagnostic_node_set_location()
          + [128]diagnostic_node_set_logical_location()
     * 17 new entrypoints for building up text for a diagnostic via a
       buffer:
          + [129]diagnostic_message_buffer_new()
          + [130]diagnostic_message_buffer_release()
          + [131]diagnostic_message_buffer_append_str()
          + [132]diagnostic_message_buffer_append_text()
          + [133]diagnostic_message_buffer_append_byte()
          + [134]diagnostic_message_buffer_append_printf()
          + [135]diagnostic_message_buffer_append_event_id()
          + [136]diagnostic_message_buffer_begin_url()
          + [137]diagnostic_message_buffer_end_url()
          + [138]diagnostic_message_buffer_begin_quote()
          + [139]diagnostic_message_buffer_end_quote()
          + [140]diagnostic_message_buffer_begin_color()
          + [141]diagnostic_message_buffer_end_color()
          + [142]diagnostic_message_buffer_dump()
          + [143]diagnostic_finish_via_msg_buf()
          + [144]diagnostic_add_location_with_label_via_msg_buf()
          + [145]diagnostic_execution_path_add_event_via_msg_buf()
     * [146]diagnostic_manager_set_debug_physical_locations()

Other significant improvements

[147]GCC 16.1

   This is the [148]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 16.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).


    For questions related to the use of GCC, please consult these web
    pages and the [149]GCC manuals. If that fails, the
    [150]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [151]gcc@gcc.gnu.org. All of [152]our lists have public
    archives.

   Copyright (C) [153]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [154]maintained by the GCC team. Last modified
   2026-04-30.

References

   1. https://gcc.gnu.org/gcc-16/porting_to.html
   2. https://gcc.gnu.org/onlinedocs/index.html#current
   3. https://gcc.gnu.org/gcc-16/porting_to.html#solaris
   4. https://gcc.gnu.org/gcc-16/porting_to.html#solaris
   5. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-format
   6. https://gcc.gnu.org/wiki/SARIF
   7. https://gcc.gnu.org/gcc-16/changes.html#general
   8. https://gcc.gnu.org/gcc-16/changes.html#documentation
   9. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/Invoking-GCC.html
  10. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/Option-Index.html
  11. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/Attributes.html
  12. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/Attribute-Index.html
  13. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gccint/
  14. https://gcc.gnu.org/gcc-16/changes.html#languages
  15. https://gcc.gnu.org/gcc-16/changes.html#openmp
  16. https://gcc.gnu.org/projects/gomp/
  17. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgomp/Memory-allocation.html
  18. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgomp/nvptx.html
  19. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgomp/omp_005ftarget_005fmemset.html
  20. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgomp/omp_005ftarget_005fmemset_005fasync.html
  21. https://gcc.gnu.org/gcc-16/changes.html#openacc
  22. https://gcc.gnu.org/wiki/OpenACC
  23. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgomp/acc_005fmemcpy_005fdevice.html
  24. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgomp/acc_005fattach.html
  25. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgomp/acc_005fdetach.html
  26. https://gcc.gnu.org/gcc-16/changes.html#ada
  27. https://github.com/AdaCore/ada-spark-rfcs/blob/master/features/rfc-oop-constructors.rst
  28. https://github.com/AdaCore/ada-spark-rfcs/blob/master/features/rfc-oop-constructors.rst
  29. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gnat_rm/Destructors.html
  30. https://github.com/AdaCore/ada-spark-rfcs/blob/master/features/rfc-oop-destructors.rst
  31. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gnat_rm/Implicit-With.html
  32. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gnat_rm/Structural-Generic-Instantiation.html
  33. https://github.com/AdaCore/ada-spark-rfcs/blob/master/features/rfc-partial-generic-instantiations.md
  34. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gnat_rm/Aspect-Extended_005fAccess.html
  35. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gnat_rm/Aspect-Extended_005fAccess.html
  36. https://github.com/AdaCore/ada-spark-rfcs/blob/master/features/array_slice_access.md
  37. https://gcc.gnu.org/gcc-16/changes.html#cxx
  38. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/C-Dialect-Options.html#index-std-1
  39. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/C-Dialect-Options.html#index-std-1
  40. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/C-Dialect-Options.html#index-std-1
  41. https://gcc.gnu.org/gcc-16/porting_to.html#cpp
  42. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/C_002b_002b-Dialect-Options.html#index-fmodules
  43. https://wg21.link/P2996R13
  44. https://gcc.gnu.org/PR120775
  45. https://wg21.link/P3394R4
  46. https://wg21.link/P3293R3
  47. https://wg21.link/P3096R12
  48. https://wg21.link/P3491R3
  49. https://gcc.gnu.org/PR120783
  50. https://wg21.link/P3560R2
  51. https://wg21.link/P1306R5
  52. https://gcc.gnu.org/PR120776
  53. https://wg21.link/P2900R14
  54. https://gcc.gnu.org/PR119061
  55. https://wg21.link/P2795R5
  56. https://gcc.gnu.org/PR114457
  57. https://wg21.link/P1061R10
  58. https://gcc.gnu.org/PR117783
  59. https://wg21.link/P3068R5
  60. https://gcc.gnu.org/PR117785
  61. https://wg21.link/P3533R2
  62. https://gcc.gnu.org/PR120777
  63. https://wg21.link/P1494R5
  64. https://gcc.gnu.org/PR119060
  65. https://wg21.link/P3618R0
  66. https://gcc.gnu.org/PR120773
  67. https://wg21.link/P2843R3
  68. https://gcc.gnu.org/PR120778
  69. https://wg21.link/P2686R4
  70. https://gcc.gnu.org/PR117784
  71. https://wg21.link/P2036R3
  72. https://gcc.gnu.org/PR102610
  73. https://wg21.link/P2590R2
  74. https://gcc.gnu.org/PR106658
  75. https://wg21.link/P2246R1
  76. https://gcc.gnu.org/PR102613
  77. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fno-diagnostics-show-nesting
  78. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-plain-output
  79. https://gcc.gnu.org/gcc-16/changes.html#libstdcxx
  80. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/_005f_005fint128.html
  81. https://www.open-std.org/jtc1/sc22/wg21/docs/papers/2023/p0952r2.html
  82. https://gcc.gnu.org/gcc-16/changes.html#fortran
  83. https://gcc.gnu.org/gcc-16/changes.html#modula2
  84. https://gcc.gnu.org/gcc-16/changes.html#algol68
  85. https://algol68-lang.org/
  86. https://gcc.gnu.org/wiki/Algol68FrontEnd
  87. https://gcc.gnu.org/gcc-16/changes.html#targets
  88. https://gcc.gnu.org/gcc-16/changes.html#x86
  89. https://gcc.gnu.org/gcc-16/changes.html#amdgcn
  90. https://gcc.gnu.org/install/specific.html#amdgcn-x-amdhsa
  91. https://gcc.gnu.org/install/configure.html#:~:text=--with-multilib-list
  92. https://gcc.gnu.org/gcc-16/changes.html#loongarch
  93. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/LoongArch-Attributes.html#index-target_005fclones_002c-LoongArch
  94. https://gcc.gnu.org/gcc-16/changes.html#s390
  95. https://gcc.gnu.org/gcc-16/changes.html#os
  96. https://gcc.gnu.org/gcc-16/changes.html#solaris
  97. https://gcc.gnu.org/gcc-16/changes.html#windows
  98. https://gcc.gnu.org/gcc-16/changes.html#diagnostics
  99. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-add-output_003dexperimental-html
 100. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/Overall-Options.html#index-dumpdir
 101. https://docs.oasis-open.org/sarif/sarif/v2.1.0/errata01/os/sarif-v2.1.0-errata01-os-complete.html#_Toc141791009
 102. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/Environment-Variables.html#index-GCC_005fDIAGNOSTICS_005fLOG
 103. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/Environment-Variables.html#index-EXPERIMENTAL_005fSARIF_005fSOCKET
 104. https://gcc.gnu.org/gcc-16/changes.html#plugins
 105. https://gcc.gnu.org/gcc-16/porting_to.html#plugins
 106. https://gcc.gnu.org/gcc-16/changes.html#analyzer
 107. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/gcc/Static-Analyzer-Options.html#index-fanalyzer-assume-nothrow
 108. https://gcc.gnu.org/gcc-16/changes.html#libgdiagnostics
 109. https://gcc.gnu.org/wiki/libgdiagnostics
 110. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/logical-locations.html#c.diagnostic_logical_location_get_kind
 111. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/logical-locations.html#c.diagnostic_logical_location_get_parent
 112. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/logical-locations.html#c.diagnostic_logical_location_get_short_name
 113. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/logical-locations.html#c.diagnostic_logical_location_get_fully_qualified_name
 114. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/logical-locations.html#c.diagnostic_logical_location_get_decorated_name
 115. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/diagnostic-manager.html#c.diagnostic_manager_add_sink_from_spec
 116. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/diagnostic-manager.html#c.diagnostic_manager_set_analysis_target
 117. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/graphs.html#c.diagnostic_manager_new_graph
 118. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/graphs.html#c.diagnostic_manager_take_global_graph
 119. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/graphs.html#c.diagnostic_take_graph
 120. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/graphs.html#c.diagnostic_graph_release
 121. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/graphs.html#c.diagnostic_graph_set_description
 122. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/graphs.html#c.diagnostic_graph_add_node
 123. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/graphs.html#c.diagnostic_graph_add_edge
 124. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/graphs.html#c.diagnostic_graph_get_node_by_id
 125. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/graphs.html#c.diagnostic_graph_get_edge_by_id
 126. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/graphs.html#c.diagnostic_node_set_label
 127. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/graphs.html#c.diagnostic_node_set_location
 128. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/graphs.html#c.diagnostic_node_set_logical_location
 129. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/message-buffers.html#c.diagnostic_message_buffer_new
 130. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/message-buffers.html#c.diagnostic_message_buffer_release
 131. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/message-buffers.html#c.diagnostic_message_buffer_append_str
 132. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/message-buffers.html#c.diagnostic_message_buffer_append_text
 133. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/message-buffers.html#c.diagnostic_message_buffer_append_byte
 134. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/message-buffers.html#c.diagnostic_message_buffer_append_printf
 135. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/message-buffers.html#c.diagnostic_message_buffer_append_event_id
 136. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/message-buffers.html#c.diagnostic_message_buffer_begin_url
 137. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/message-buffers.html#c.diagnostic_message_buffer_end_url
 138. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/message-buffers.html#c.diagnostic_message_buffer_begin_quote
 139. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/message-buffers.html#c.diagnostic_message_buffer_end_quote
 140. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/message-buffers.html#c.diagnostic_message_buffer_begin_color
 141. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/message-buffers.html#c.diagnostic_message_buffer_end_color
 142. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/message-buffers.html#c.diagnostic_message_buffer_dump
 143. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/diagnostics.html#c.diagnostic_finish_via_msg_buf
 144. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/physical-locations.html#c.diagnostic_add_location_with_label_via_msg_buf
 145. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/execution-paths.html#c.diagnostic_execution_path_add_event_via_msg_buf
 146. https://gcc.gnu.org/onlinedocs/gcc-16.1.0/libgdiagnostics/topics/physical-locations.html#c.diagnostic_manager_set_debug_physical_locations
 147. https://gcc.gnu.org/gcc-16/changes.html#16.1
 148. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=16.0
 149. https://gcc.gnu.org/onlinedocs/
 150. mailto:gcc-help@gcc.gnu.org
 151. mailto:gcc@gcc.gnu.org
 152. https://gcc.gnu.org/lists.html
 153. https://www.fsf.org/
 154. https://gcc.gnu.org/about.html
======================================================================
http://gcc.gnu.org/gcc-15/index.html
                             GCC 15 Release Series

   August 8, 2025

   The GCC developers are pleased to announce the release of GCC 15.2.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 15.1 relative to previous releases of GCC.

Release History

   GCC 15.2
          August 8, 2025 ([1]changes, [2]documentation)

   GCC 15.1
          April 25, 2025 ([3]changes, [4]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [5]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [6]GCC project
   web site or contact the [7]GCC development mailing list.

   To obtain GCC please use [8]our mirror sites or [9]our version control
   system.


    For questions related to the use of GCC, please consult these web
    pages and the [10]GCC manuals. If that fails, the
    [11]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [12]gcc@gcc.gnu.org. All of [13]our lists have public
    archives.

   Copyright (C) [14]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [15]maintained by the GCC team. Last modified
   2025-08-08.

References

   1. https://gcc.gnu.org/gcc-15/changes.html
   2. https://gcc.gnu.org/onlinedocs/15.2.0/
   3. https://gcc.gnu.org/gcc-15/changes.html
   4. https://gcc.gnu.org/onlinedocs/15.1.0/
   5. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/Contributors.html
   6. https://gcc.gnu.org/index.html
   7. mailto:gcc@gcc.gnu.org
   8. https://gcc.gnu.org/mirrors.html
   9. https://gcc.gnu.org/git.html
  10. https://gcc.gnu.org/onlinedocs/
  11. mailto:gcc-help@gcc.gnu.org
  12. mailto:gcc@gcc.gnu.org
  13. https://gcc.gnu.org/lists.html
  14. https://www.fsf.org/
  15. https://gcc.gnu.org/about.html
======================================================================
http://gcc.gnu.org/gcc-15/changes.html
                             GCC 15 Release Series
                        Changes, New Features, and Fixes

   This page is a "brief" summary of some of the huge number of
   improvements in GCC 15. You may also want to check out our [1]Porting
   to GCC 15 page and the [2]full GCC documentation.

Caveats

     * Support for Nios II targets, which was marked obsolete in GCC 14,
       has now been removed entirely.
     * In the AArch64 port, support for ILP32 (-mabi=ilp32) has been
       deprecated and will be removed in a future release.
     * Support for Solaris 11.3 (*-*-solaris2.11.3) has been removed.
       Details can be found in the [3]obsoletion announcement.
     * This is the last release supporting the old reload local register
       allocation code. It will be removed for GCC 16, causing targets
       that do not support the new LRA local register allocation code to
       be removed. See the list of supported [4]targets for which ports
       are going to be affected (look for missing a, the ports that do not
       use LRA by default).
     * {0} initializer in C or C++ for unions no longer guarantees
       clearing of the whole union (except for static storage duration
       initialization), it just initializes the first union member to
       zero. If initialization of the whole union including padding bits
       is desirable, use {} (valid in C23 or C++) or use
       -fzero-init-padding-bits=unions option to restore the old GCC
       behavior.
     * [5]-fanalyzer is still only suitable for analyzing C code. In
       particular, using it on C++ is unlikely to give meaningful output.
     * The json format for [6]-fdiagnostics-format= is deprecated and may
       be removed in a future release. Users seeking machine-readable
       diagnostics from GCC should use [7]SARIF.

[8]General Improvements

     * The default vectorizer cost model at -O2 has been enhanced to
       handle an unknown tripcount. It still disables vectorization of
       loops when any run-time check for data dependence or alignment is
       required. It also disables vectorization of epilogue loops, but is
       otherwise equal to the cheap cost model.
     * The vectorizer now supports vectorizing loops with early exits
       where the number of elements for the input pointers are unknown
       through peeling for alignment. This is supported only for loops
       with fixed vector lengths.
     * -ftime-report now only reports monotonic run time instead of system
       and user time. This reduces the overhead of the option
       significantly, making it possible to use in standard build systems.
     * Incremental Link-Time Optimizations significantly reduce average
       recompilation time of LTO when doing small code edits (e.g. editing
       a single function). Enable with [9]-flto-incremental=.
     * For offloading using OpenMP and OpenACC, issues preventing some
       host–device architecture combinations have been resolved. In
       particular, offloading from aarch64 hosts to nvptx devices is now
       supported. Additionally, the support for using C++ in offload
       regions has been extended.
     * Improvements for compiling very large input files. The compile time
       for large input files with -Wmisleading-indentation has been
       significantly improved. The compiler can now track column numbers
       larger than 4096. Very large source files have more accurate
       location reporting.
     * GCC can now emit diagnostics in multiple formats simultaneously,
       via the new option [10]-fdiagnostics-add-output=. For example, use
       [11]-fdiagnostics-add-output=sarif to get both GCC's classic text
       output on stderr and [12]SARIF output to a file. There is also a
       new option [13]-fdiagnostics-set-output= which exposes more control
       than existing options for some experimental cases. These new
       options are an alternative to the existing
       [14]-fdiagnostics-format= which only supports a single output
       format at a time.

[15]New Languages and Language specific improvements

  [16]OpenMP

   See the [17]GNU Offloading and Multi-Processing Project (GOMP) page for
   general information.
     * Support for unified-shared memory has been added for some AMD and
       Nvidia GPU devices, enabled when using the unified_shared_memory
       clause to the requires directive. The OpenMP 6.0 self_maps clause
       is also now supported. For details, see the offload-target
       specifics section in the [18]GNU Offloading and Multi Processing
       Runtime Library Manual.
     * GCC added ompx_gnu_pinned_mem_alloc as a [19]predefined allocator
       and, for C++, allocator class templates in the omp::allocator
       namespace for the predefined allocators as specified in the OpenMP
       specification 5.0, including omp::allocator::null_allocator of
       OpenMP 6.0 and ompx::allocator::gnu_pinned_mem; the allocator
       templates can be used with C++ containers such as std::vector.
     * In C and Fortran, the allocate directive now supports static
       variables; stack variables were previously supported in those
       languages. C++ support is not available yet.
     * Offloading improvements: On [20]Nvidia GPUs, writing to the
       terminal from OpenMP target regions (but not from OpenACC compute
       regions) is now also supported in Fortran; in C/C++ and on AMD GPUs
       this was already supported before with both OpenMP and OpenACC.
       Constructors and destructors on the device side for declare target
       static aggregates are now handled.
     * For Fortran, mapping derived-type variables with allocatable
       components is now supported.
     * The OpenMP 5.1 unroll and tile loop-transforming constructs are now
       supported.
     * OpenMP 5.0 metadirectives are now supported, as are OpenMP 5.1
       dynamic selectors in both metadirective and declare variant (the
       latter with some restrictions).
     * The interop construct and the OpenMP interoperability API routines
       for C, C++ and Fortran are now implemented, including the OpenMP
       6.0 additions. This includes foreign-runtime support for [21]Cuda,
       Cuda Driver, and HIP on Nvida GPUs and for [22]HIP and HSA on AMD
       GPUs.
     * The OpenMP 5.1 dispatch construct has been implemented with support
       for the adjust_args and append_args clauses to the declare variant
       directive, including the following OpenMP 6.0 additions: the
       interop clause to dispatch and the syntax extensions to append_args
       are supported.
     * OpenMP 6.0: The [23]get_device_from_uid and
       [24]omp_get_uid_from_device API routines have been added.

  [25]COBOL

     * GCC now includes an ISO COBOL compiler, gcobol. It has been tested
       on x86-64 and AArch64 targets. It is not expected to work on 32-bit
       systems. Efforts are underway to adapt it to other machine
       architectures that support native 128-bit computation.
     * gcobol passes much of the NIST CCVS/85 test suite (except for parts
       that are now obsolete). It uses ISO/IEC 1989:2023 as a reference
       specification. Some parts of that document, notably
       object-orientation features, are yet to be implemented. Beyond ISO,
       gcobol recognizes some syntax common on other compilers, with
       special attention given to IBM.
       More information about GCC COBOL can be found at [26]the COBOLworx
       website.

  [27]Ada

     * GNAT now allows the [28]'Round attribute also for ordinary
       fixed-point types.
     * The new GNAT attribute [29]'Super can be applied to objects of
       tagged types in order to obtain a view conversion to the most
       immediate specific parent type.
     * [30]Mutably tagged types with a defined size are now available
       through the use of Size'Class. This allows defining a maximum size
       for the tagged. Example:
type Base is tagged null record with Size'Class => 16 * 8;
     -- Size in bits (128 bits, or 16 bytes)

type Derived_Type is new Base with record Data_Field : Integer; end record;
     -- ERROR if Derived_Type exceeds 16 bytes

     * New [31]Finalizable aspect. It is a GNAT language extension which
       serves as a lightweight alternative to controlled types.
type T is record
     ...
end record with Finalizable => (Initialize           => Initialize,
                                Adjust               => Adjust,
                                Finalize             => Finalize,
                                Relaxed_Finalization => True);

procedure Adjust     (Obj : in out T);
procedure Finalize   (Obj : in out T);
procedure Initialize (Obj : in out T);

     * The aspect [32]No_Raise has been added, it declares that a
       subprogram cannot raise an exception.
     * The aspect [33]External_Initialization has been added, it allows
       for data to be initialized using an external file which is loaded
       during compilation time.
     * The aspect [34]Exit_Cases has been added to annotate functions and
       procedures with side effects in SPARK (see [35]SPARK reference
       manual) . It can be used to partition the input state into a list
       of cases and specify, for each case, how the subprogram is allowed
       to terminate.
     * Language extensions are enabled through the use of pragma
       Extensions_Allowed (On | Off | All_Extensions); which has had its
       syntax changed. An argument of All_Extensions has the same effect
       as On, except that [36]some extra experimental extensions are
       enabled.
     * Several new compilation flags have been added, some examples
       include [37]-gnatis, [38]-gnatw.n, [39]-gnatw_l and [40]-gnatw.v.
       The internal debugging utilities for the compiler have also
       received a lot of new options, please refer to [41]debug.adb for
       more information.
     * The diagnostics code has seen major refactoring, it now supports
       the sarif format -fdiagnostics-format=sarif-file among other
       improvements. More changes are expected in following releases.
     * System.Image_A has now printing routines to output address
       information in HEX.
     * Several program units have had contracts added to them and SPARK
       analysis has been enabled.
     * Support for FreeBSD, Android and aarch64 targets has been improved.
     * Task priorities on MinGW have been reworked.
     * The documentation has been rearanged for clarity, mainly the
       sections related to tasking and platform dependent information.
     * REMOVAL: Generic_Formal_Hash_Table has been removed, the [42]SPARK
       Library is recommended as a substitute.
     * The new [43]finally [44][RFC] keyword makes it possible to specify
       a sequence of statements that shall be executed when another
       sequence of statements is completed, regardless of whether the
       completion was normal or abnormal.
     * [45]String interpolation [46][RFC], inspired by python f-strings
       (e.g. f"The name is {Name} and the sum is {X + Y}."), has been
       added.

  [47]C family

     * A [48]musttail statement attribute was added to enforce tail calls.
     * [49]Extended inline assembler statements can now be used with some
       limitations outside of functions as well. New constraints have been
       added for defining symbols or using symbols inside of inline
       assembler, and a new generic operand modifier has been added to
       allow printing those regardless of PIC. For example:
struct S { int a, b, c; };
extern foo (void);
extern char var;
int var2;
asm (".text; %cc0: mov %cc2, %%r0; .previous;"
     ".rodata: %cc1: .byte %3; .previous" : :
     ":" (foo), /* Tell compiler asm defines foo function. */
     ":" (&var), /* Tell compiler asm defines var variable.  */
     "-s" (var2), /* Tell compiler asm uses var2 variable.  */
                  /* "s" would work too but might not work with -fpic.  */
     "i" (sizeof (struct S))); /* It is possible to pass constants to toplevel a
sm.  */

     * The "redzone" clobber is now allowed in inline assembler statements
       to describe that the assembler can overwrite memory in the stack
       red zone (e.g. on x86-64 or PowerPC).
     * The [50]nonnull_if_nonzero function attribute has been added to
       describe functions where some pointer parameter may be NULL only if
       some other parameter is zero.
     * The [51]-Wtrailing-whitespace= and [52]-Wleading-whitespace=
       options have been added to diagnose certain whitespace characters
       at the end of source lines or whitespace characters at the start of
       source lines violating certain indentation styles.
     * The [53]-Wheader-guard warning has been added and enabled in -Wall
       to warn about some inconsistencies in header file guarding macros.
     * The C and C++ frontends now provide fix-it hints for some cases of
       missing '&' and '*'. For example, note the ampersand fix-it hint in
       the following:
    demo.c: In function 'int main()':
    demo.c:5:22: error: invalid conversion from 'pthread_key_t' {aka 'unsigned i
nt'}
       to 'pthread_key_t*' {aka 'unsigned int*'} [-fpermissive]
        5 |   pthread_key_create(key, NULL);
          |                      ^~~
          |                      |
          |                      pthread_key_t {aka unsigned int}
    demo.c:5:22: note: possible fix: take the address with '&'
        5 |   pthread_key_create(key, NULL);
          |                      ^~~
          |                      &
    In file included from demo.c:1:
    /usr/include/pthread.h:1122:47: note:   initializing argument 1 of
       'int pthread_key_create(pthread_key_t*, void (*)(void*))'
     1122 | extern int pthread_key_create (pthread_key_t *__key,
          |                                ~~~~~~~~~~~~~~~^~~~~

     * Diagnostic messages referring to attributes now provide URLs to the
       documentation of the pertinent attributes in sufficiently capable
       terminals, and in SARIF output.
     * Diagnostics in which two different things in the source are being
       contrasted (such as type mismatches) now use color to visually
       highlight and distinguish the differences, in both the text message
       of the diagnostic, and the quoted source. For example, in:
       screenshot of a C type error from GCC 15 showing color usage
       the left-hand type is shown in green and the right-hand type in
       dark blue.

  [54]C

     * C23 by default: GCC 15 changes the default language version for C
       compilation from [55]-std=gnu17 to [56]-std=gnu23. If your code
       relies on older versions of the C standard, you will need to either
       add [57]-std= to your build flags, or port your code; see [58]the
       porting notes.
     * Some more C23 features have been implemented:
          + #embed preprocessing directive support.
          + Support for unsequenced and reproducible attributes.
          + __STDC_VERSION__ predefined macro value changed for -std=c23
            or -std=gnu23 to 202311L.
     * To aid the transition to C23, various diagnostics have been
       enhanced to clarify type errors such as incompatible function
       types, incorrect argument counts, and those involving bool.
     * Some new features from the upcoming C2Y revision of the ISO C
       standard are supported with -std=c2y and -std=gnu2y. Some of these
       features are also supported as extensions when compiling for older
       language versions.
          + Generic selection expression with a type operand.
          + Support ++ and -- on complex values.
          + Accessing byte arrays.
          + alignof of an incomplete array type.
          + Obsolete implicitly octal literals and add delimited escape
            sequences (just partially implemented, support for new syntax
            added but nothing deprecated yet).
          + Named loops.
          + More Modern Bit Utilities (addition of
            __builtin_stdc_rotate_left and __builtin_stdc_rotate_right
            builtins for use in future C library <stdbit.h> headers).
          + Case range expressions.
          + if declarations.
          + Introduce complex literals.
          + Abs Without Undefined Behavior (addition of builtins for use
            in future C library <stdlib.h> headers).
          + Allow zero length operations on null pointers (just the
            compiler side, C library headers will need adjustments too if
            using nonnull attribute).

  [59]C++

     * Several C++26 features have been implemented:
          + [60]P2558R2, Add @, $, and ` to the basic character set
            ([61]PR110343)
          + [62]P2552R3, On the ignorability of standard attributes
            ([63]PR110345)
          + [64]P2662R3, Pack indexing ([65]PR113798)
          + [66]P0609R3, Attributes for structured bindings ([67]PR114456)
          + [68]P2573R2, = delete("reason"); ([69]PR114458)
          + [70]P2893R3, Variadic friends ([71]PR114459)
          + [72]P3034R1, Disallow module declarations to be macros
            ([73]PR114461)
          + [74]P2747R2, constexpr placement new ([75]PR115744)
          + [76]P0963R3, Structured binding declaration as a condition
            ([77]PR115745)
          + [78]P3144R2, Deleting a pointer to an incomplete type should
            be ill-formed ([79]PR115747)
          + [80]P3176R0, Oxford variadic comma ([81]PR117786)
          + [82]P2865R5, Removing deprecated array comparisons
            ([83]PR117788)
          + [84]P1967R14, #embed ([85]PR119065)
          + [86]P3247R2, Deprecating the notion of trivial types
            ([87]PR117787)
     * Several C++23 features have been implemented:
          + [88]P2615R1, Meaningful exports ([89]PR107688)
          + [90]P2718R0, Wording for P2644R1 Fix for Range-based for Loop
            ([91]PR107637)
     * Several C++ Defect Reports have been resolved, e.g.:
          + [92]DR 36, using-declarations in multiple-declaration contexts
          + [93]DR 882, Defining main as deleted
          + [94]DR 1363, Triviality vs multiple default constructors
          + [95]DR 1496, Triviality with deleted and missing default
            constructors
          + [96]DR 2387, Linkage of const-qualified variable template
          + [97]DR 2521, User-defined literals and reserved identifiers
          + [98]DR 2627, Bit-fields and narrowing conversions
          + [99]DR 2819, Cast from null pointer value in a constant
            expression (C++26 only)
          + [100]DR 2867, Order of initialization for structured bindings
          + [101]DR 2918, Consideration of constraints for address of
            overloaded function
     * Inline assembler statements now support [102]constexpr generated
       strings, analoguous to static_assert.
     * Qualified name lookup failure into the current instantiation, e.g.
       this->non_existent, is now proactively diagnosed when parsing a
       template.
     * The [103]-fassume-sane-operators-new-delete option has been added
       and enabled by default. This option allows control over some
       optimizations around calls to replaceable global operators new and
       delete. If a program overrides those replaceable global operators
       and the replaced definitions read or modify global state visible to
       the rest of the program, programs might need to be compiled with
       -fno-assume-sane-operators-new-delete.
     * The [104]-Wself-move warning now warns even in a
       member-initializer-list.
     * The support for Concepts TS was removed. -fconcepts-ts has no
       effect anymore.
     * A new option [105]-Wtemplate-body was added, which can be used to
       disable diagnosing errors when parsing a template.
     * C++ Modules have been greatly improved.
     * C++11 attributes are now supported even in C++98.
     * New [106]flag_enum attribute to indicate that the enumerators are
       used in bitwise operations; this suppresses a -Wswitch warning.
     * The [107]-Wdangling-reference warning has been improved: for
       example, it doesn't warn for empty classes anymore.
     * The front end's handling of explicitly-defaulted functions has been
       corrected to properly handle [dcl.fct.def.default]. The new
       [108]-Wdefaulted-function-deleted warning warns when an explicitly
       defaulted function is deleted.
     * The implementation of [109]DR 2789 was refined.
     * Compilation time speed ups, e.g. by improving hashing of template
       specializations.
     * Support for __builtin_operator_new and __builtin_operator_delete
       was added. See [110]the manual for more info.
     * More prvalues are evaluated at compile time ([111]git).
     * A new way of presenting complicated diagnostics (such as C++
       template errors) is available via
       [112]-fdiagnostics-set-output=text:experimental-nesting=yes; an
       example can be seen [113]here. This should be regarded as
       experimental in this release and is subject to change.
     * Various other diagnostic improvements.

    [114]Runtime Library (libstdc++)

     * Debug assertions are now enabled by default for unoptimized builds.
       Use -D_GLIBCXX_NO_ASSERTIONS to override this.
     * Associative containers and lists now use custom pointer types
       internally, instead of only when interacting with their allocator.
     * Improved experimental support for C++26, including:
          + views::concat, views::to_input, views::cache_latest.
          + Sorting algorithms and raw memory algorithms are constexpr so
            can be used during constant evaluation.
          + <stdbit.h> and <stdckdint.h> headers.
          + std::is_virtual_base_of type trait.
          + Member visit.
          + Type-checking std::format args.
     * Improved experimental support for C++23, including:
          + std and std.compat modules (also supported for C++20).
          + std::flat_map and std::flat_set.
          + std::from_range_t constructors added to all containers, as
            well as new member functions such as insert_range.
          + Formatting of ranges and tuples with std::format, as well as
            string escaping for debug formats, thanks to Tomasz Kamiński.
          + Clarify handling of encodings in localized formatting of
            chrono types.

  [115]D

     * Support for the D programming language has been updated to version
       2.111.0 of the language and run-time library. Full changelog for
       this release and previous releases can be found on the
       [116]dlang.org website.
     * On supported targets, the version GNU_CET is now predefined when
       the option -fcf-protection is used. The protection level is also
       set in the traits key __traits(getTargetInfo, "CET").
     * A new option [117]-finclude-imports was added, which tells the
       compiler to include imported modules in the compilation, as if they
       were given on the command-line.

  [118]Fortran

     * Fortran 2018 and 2023 locality specifiers to do concurrent are now
       supported.
     * Experimental support for unsigned modular integers, enabled by
       -funsigned; see [119]gfortran documentation for details. This
       follows ([120]J3/24-116). With this option in force, the
       selected_logical_kind intrinsic function and, in the
       ISO_FORTRAN_ENV module, the named constants logical{8,16,32,64} and
       real16 were added. The ISO_C_BINDING module has been extended
       accordingly.
     * Missing commas separating descriptors in input/output format
       strings are no longer permitted by default and are rejected at
       run-time unless -std=legacy is used when compiling the main program
       unit. See Fortran 2023 constraint C1302.
     * The Fortran module *.mod format generated by GCC 15 is incompatible
       with the module format generated by GCC 8 - 14, but GCC 15 can for
       compatibility still read GCC 8 - 14 created module files.
     * Coarray support has been reworked to allow access to components in
       derived types that have not been compiled with coarray support
       enabled; especially, when the derived type is in a binary only
       module. This has changed the ABI and may lead to link-time errors
       with object files generated with a previous GCC version and to be
       linked to the current caf_single library. If this library is to be
       used, then it is recommended to recompile all artifacts. The
       OpenCoarrays library is not affected, because it provides backwards
       compatibility with the older ABI.
     * The -Wexternal-arguments-mismatch option has been added. This
       checks for mismatches between the argument lists in dummy external
       arguments, and is implied by -Wall and -fc-prototypes-external
       options.
     * The -fc-prototypes option now also generates prototypes for
       interoperable procedures with assumed shape and assumed rank
       arguments that require the header file <ISO_Fortran_binding.h>.

  [121]Modula-2

     * The keyword FORWARD has been implemented in the compiler and is
       available by default in all dialects.
     * The SYSTEM module now exports the datatype COFF_T mapping onto the
       POSIX off_t type. The size of this datatype can be controlled by
       the new option -fm2-file-offset-bits=.
     * Access to the GCC builtins clz, clzll, ctz and ctzll is now
       available from the module Builtins.

  [122]Rust

     * Basic inline assembly support has been added to the frontend, which
       enables us to compile the architecture specific functions of core
       1.49.
     * Support for for-loops has been added.
     * Fixes to our automatic dereferencing algorithm for Deref and
       DerefMut. This makes gccrs more correct and allows handling
       complicated cases where the type-checker would previously fail.
     * Fixes to our indexing and iterator traits handling, which was
       required for for-loops to be properly implemented.
     * Our parser is now fully implemented and fully capable of parsing
       the entirety of core, alloc and std. It was still lacking in some
       areas, especially around unstable features like specialization.
     * Support for the question-mark operator has been added. This enables
       gccrs to handle all the error handling code and machinery often
       used in real world Rust programs, as well as in core.
     * Fixes to our macro expansion pass which now correctly expands all
       of core 1.49. This also includes fixes to our format_args!()
       handling code, which received numerous improvements.
     * Support for let-else has been added. While this is not used in core
       1.49, it is used in the Rust-for-Linux project, our next major
       objective for gccrs.
     * Support for the unstable specialization feature has been added.
       This is required for compiling core 1.49 correctly, in which
       specialization is used to improve the runtime performance of Rust
       binaries.
     * Support for more lang-items has been added.
     * Lowered minimum required Rust version to 1.49. This allows more
       systems to compile the Rust frontend, and also brings us closer to
       gccrs compiling its own dependencies down the line.
     * Rewrite of our name resolution algorithm to properly handle the
       complex import/export structure used in core 1.49.

[123]New Targets and Target Specific Improvements

  [124]AArch64

     * Support has been added for the AArch64 MinGW target
       (aarch64-w64-mingw32). At present, this target supports C and C++
       for base Armv8-A, but with some caveats:
          + Although most variadic functions work, the implementation of
            them is not yet complete.
          + C++ exception handling is not yet implemented.
       Further work is planned for GCC 16.
     * As noted above, support for ILP32 (-mabi=ilp32) has been deprecated
       and will be removed in a future release. aarch64*-elf targets no
       longer build the ILP32 multilibs.
     * The following architecture level is now supported by -march and
       related source-level constructs (GCC identifiers in parentheses):
          + Armv9.5-A (armv9.5-a)
     * The following CPUs are now supported by -mcpu, -mtune, and related
       source-level constructs (GCC identifiers in parentheses):
          + Apple A12 (apple-a12)
          + Apple M1 (apple-m1)
          + Apple M2 (apple-m2)
          + Apple M3 (apple-m3)
          + Arm Cortex-A520AE (cortex-a520ae)
          + Arm Cortex-A720AE (cortex-a720ae)
          + Arm Cortex-A725 (cortex-a725)
          + Arm Cortex-R82AE (cortex-r82ae)
          + Arm Cortex-X925 (cortex-x925)
          + Arm Neoverse N3 (neoverse-n3)
          + Arm Neoverse V3 (neoverse-v3)
          + Arm Neoverse V3AE (neoverse-v3ae)
          + FUJITSU-MONAKA (fujitsu-monaka)
          + NVIDIA Grace (grace)
          + NVIDIA Olympus (olympus)
          + Qualcomm Oryon-1 (oryon-1)
     * The following features are now supported by -march, -mcpu, and
       related source-level constructs (GCC modifiers in parentheses):
          + FEAT_CPA (+cpa), enabled by default for Arm9.5-A and above
          + FEAT_FAMINMAX (+faminmax), enabled by default for Arm9.5-A and
            above
          + FEAT_FCMA (+fcma), enabled by default for Armv8.3-A and above
          + FEAT_FLAGM2 (+flagm2), enabled by default for Armv8.5-A and
            above
          + FEAT_FP8 (+fp8)
          + FEAT_FP8DOT2 (+fp8dot2)
          + FEAT_FP8DOT4 (+fp8dot4)
          + FEAT_FP8FMA (+fp8fma)
          + FEAT_FRINTTS (+frintts), enabled by default for Armv8.5-A and
            above
          + FEAT_JSCVT (+jscvt), enabled by default for Armv8.3-A and
            above
          + FEAT_LUT (+lut), enabled by default for Arm9.5-A and above
          + FEAT_LRCPC2 (+rcpc2), enabled by default for Armv8.4-A and
            above
          + FEAT_SME_B16B16 (+sme-b16b16)
          + FEAT_SME_F16F16 (+sme-f16f16)
          + FEAT_SME2p1 (+sme2p1)
          + FEAT_SSVE_FP8DOT2 (+ssve-fp8dot2)
          + FEAT_SSVE_FP8DOT4 (+ssve-fp8dot4)
          + FEAT_SSVE_FP8FMA (+ssve-fp8fma)
          + FEAT_SVE_B16B16 (+sve-b16b16)
          + FEAT_SVE2p1 (+sve2p1), enabled by default for Armv9.4-A and
            above
          + FEAT_WFXT (+wfxt), enabled by default for Armv8.7-A and above
          + FEAT_XS (+xs), enabled by default for Armv8.7-A and above
       The features listed as being enabled by default for Armv8.7-A or
       earlier were previously only selectable using the associated
       architecture level. For example, FEAT_FCMA was previously selected
       by -march=armv8.3-a and above (as it still is), but it wasn't
       previously selectable independently.
     * -mbranch-protection has been extended to support the Guarded
       Control Stack (GCS) extension. This support is included in
       -mbranch-protection=standard and can be enabled individually using
       -mbranch-protection=gcs.
     * The following additional changes have been made to the command-line
       options:
          + In order to align with other tools, the SME feature modifier
            +sme no longer enables SVE. However, GCC does not yet support
            using SME without SVE and instead rejects such combinations
            with a “not implemented” error.
          + The options -mfix-cortex-a53-835769 and
            -mfix-cortex-a53-843419 are now silently ignored if the
            selected architecture is incompatible with Cortex-A53. This is
            particularly useful for toolchains that are configured to
            apply the Cortex-A53 workarounds by default. For example, all
            other things being equal, a toolchain configured with
            --enable-fix-cortex-a53-835769 now produces the same code for
            -mcpu=neoverse-n2 as a toolchain configured without
            --enable-fix-cortex-a53-835769.
          + -mcpu=native now handles unrecognized heterogeneous systems by
            detecting which individual architecture features are supported
            by the CPUs. This matches the preexisting behavior for unknown
            homogeneous systems.
          + The first scheduling pass (-fschedule-insns) is no longer
            enabled by default at -O2 for AArch64 targets. The pass is
            still enabled by default at -O3 and -Ofast.
     * Support has been added for the following features of the Arm C
       Language Extensions ([125]ACLE):
          + guarded control stacks
          + lookup table instructions with 2-bit and 4-bit indices
            (predefined macro __ARM_FEATURE_LUT, enabled by +lut)
          + floating-point absolute minimum and maximum instructions
            (predefined macro __ARM_FEATURE_FAMINMAX, enabled by
            +faminmax)
          + FP8 conversions (predefined macro __ARM_FEATURE_FP8, enabled
            by +fp8)
          + FP8 2-way dot product to half precision instructions
            (predefined macro __ARM_FEATURE_FP8DOT2, enabled by +fp8dot2)
          + FP8 4-way dot product to single precision instructions
            (predefined macro __ARM_FEATURE_FP8DOT4, enabled by +fp8dot4)
          + FP8 multiply-accumulate to half precision and single precision
            instructions (predefined macro __ARM_FEATURE_FP8FMA, enabled
            by +fp8fma)
          + SVE FP8 2-way dot product to half precision instructions in
            Streaming SVE mode (predefined macro
            __ARM_FEATURE_SSVE_FP8DOT2, enabled by +ssve-fp8dot2)
          + SVE FP8 4-way dot product to single precision instructions in
            Streaming SVE mode (predefined macro
            __ARM_FEATURE_SSVE_FP8DOT4, enabled by +ssve-fp8dot4)
          + SVE FP8 multiply-accumulate to half precision and single
            precision instructions in Streaming SVE mode (predefined macro
            __ARM_FEATURE_SSVE_FP8FMA, enabled by +ssve-fp8fma)
          + SVE2.1 instructions (predefined macro __ARM_FEATURE_SVE2p1,
            enabled by +sve2p1)
          + SVE non-widening bfloat16 instructions (predefined macro
            __ARM_FEATURE_SVE_B16B16, enabled by +sve-b16b16)
          + SME2.1 instructions (predefined macro __ARM_FEATURE_SME2p1,
            enabled by +sme2p1)
          + SME non-widening bfloat16 instructions (predefined macro
            __ARM_FEATURE_SME_B16B16, enabled by +sme-b16b16)
          + SME half-precision instructions (predefined macro
            __ARM_FEATURE_SME_F16F16, enabled by +sme-f16f16)
          + using C and C++ prefix operators, infix operators, and postfix
            operators with scalable SVE ACLE types (predefined macro
            __ARM_FEATURE_SVE_VECTOR_OPERATORS==2, enabled by +sve)
          + __fma (in arm_acle.h)
          + __fmaf (in arm_acle.h)
          + __chkfeat (in arm_acle.h)
     * In addition, the following changes have been made to preexisting
       ACLE features:
          + The macros __ARM_FEATURE_BF16 and __ARM_FEATURE_SVE_BF16 are
            now predefined when the associated support is available.
            Previous versions of GCC provided the associated intrinsics
            but did not predefine the macros.
          + OpenMP tasks can now share scalable SVE vectors and
            predicates. However, offloading of scalable vectors and
            predicates is not supported.
          + ACLE system register functions (such as __arm_rsr and
            __arm_wsr) no longer try to enforce the minimum architectural
            requirement.
          + A warning is reported if code attempts to use the Function
            Multi-Versioning feature. GCC's current implementation of this
            feature is still experimental and it does not conform to the
            ACLE specification.
     * Support has been added for the indirect_return function-type
       attribute, which indicates that a function might return via an
       indirect branch instead of via a normal return instruction.
     * 128-bit atomic operations have been extended to make use of
       FEAT_LRCPC3 instructions, when support for the instructions is
       detected at runtime.
     * There have been many code-generation improvements to the AArch64
       port. Some examples are:
          + automatic use of AArch64 CRC instructions
          + automatic use of AArch64 saturating vector arithmetic
            instructions
          + better code generation of population counts
          + improved handling of floating-point and vector immediates
          + improved handling of vector permutations
          + more use of SVE instructions to optimize Advanced SIMD code
          + more folding and simplification of SVE ACLE intrinsics
          + improved CPU-specific tuning
          + improved register allocation, such as eliminating some vector
            moves

  [126]AMD GPU (GCN)

     * The standard C++ library (libstdc++) is now supported and enabled.
     * Experimental support for supporting generic devices has been added;
       specifying gfx9-generic, gfx10-3-generic, or gfx11-generic to
       [127]-march= will generate code that can run on all devices of a
       series. Additionally, the following specific devices are now have
       experimental support, all of which are compatible with a listed
       generic: gfx902, gfx904, gfx909, gfx1031, gfx1032, gfx1033,
       gfx1034, gfx1035, gfx1101, gfx1102, gfx1150, and gfx1151. To use
       any of the listed new devices including the generic ones, GCC has
       to be configured to build the runtime library for the device. Note
       that generic support requires ROCm 6.4.0 (or newer). For details,
       consult GCC's [128]installation notes.
     * Support for Fiji (gfx803) devices has been removed (this was
       already deprecated in GCC 14).

  [129]AVR

     * Support has been added for the signal(num) and interrupt(num)
       [130]function attributes that allow to specify the interrupt vector
       number num as an argument. It allows to use static functions as
       interrupt handlers, and also functions defined in a C++ namespace.
     * Support has been added for the noblock function attribute. It can
       be specified together with the signal attribute to indicate that
       the interrupt service routine should start with a SEI instruction
       to globally re-enable interrupts. The difference to the interrupt
       attribute is that the noblock attribute just acts like a flag and
       does not impose a specific function name.
     * Support has been added for the __builtin_avr_mask1 [131]built-in
       function. It can be used to compute some bit masks when code like
       1 << offset is not fast enough.
     * Support has been added for a new 24-bit [132]named address space
       __flashx. It is similar to the __memx address space introduced in
       GCC 4.7, but reading is more efficient since it only supports
       reading from program memory. Objects in the __flashx address space
       are located in the .progmemx.data section. The address space is
       available when the feature-test macro __FLASHX is defined.
     * Apart from the built-in types __int24 and __uint24 supported since
       GCC 4.7, support has been added for the signed __int24 and unsigned
       __int24 types.
     * Code generation for the 32-bit integer shifts with constant offset
       has been improved. The code size may slightly increase even when
       optimizing for code size with -Os.
     * Support has been added for a compact vector table as supported by
       some AVR devices. It can be activated by the new command-line
       option [133]-mcvt. It links crtmcu-cvt.o as startup code which is
       supported since AVR-LibC v2.3.
     * Support has been added for the new option [134]-mno-call-main.
       Instead of calling main, it will be located in section .init9.
     * New AVR specific optimizations have been added. They can be
       controlled by the new command-line options [135]-mfuse-move,
       [136]-msplit-ldst, [137]-msplit-bit-shift and
       [138]-muse-nonzero-bits.
     * Support for the following devices has been added in GCC 15.2:
          + AVR32DA28S, AVR32DA32S, AVR32DA48S, AVR64DA28S, AVR64DA32S,
            AVR64DA48S AVR64DA64S, AVR128DA28S, AVR128DA32S, AVR128DA48S,
            AVR128DA64S.
     * Support for the following devices has been added in GCC 15.3:
          + AVR32EB14, AVR32EB20, AVR32EB28, AVR32EB32, AVR16LA14,
            AVR16LA20, AVR16LA28, AVR16LA32, AVR32LA14, AVR32LA20,
            AVR32LA28, AVR32LA32.
     * Support for the IEEE double functions sincos and sincosl has been
       added in GCC 15.3.

  [139]IA-32/x86-64

     * New ISA extension support for Intel AMX-AVX512 was added.
       AMX-AVX512 intrinsics are available via the -mamx-avx512 compiler
       switch.
     * New ISA extension support for Intel AMX-FP8 was added. AMX-FP8
       intrinsics are available via the -mamx-fp8 compiler switch.
     * New ISA extension support for Intel AMX-MOVRS was added. AMX-MOVRS
       intrinsics are available via the -mamx-movrs compiler switch.
     * New ISA extension support for Intel AMX-TF32 was added. AMX-TF32
       intrinsics are available via the -mamx-tf32 compiler switch.
     * New ISA extension support for Intel AMX-TRANSPOSE was added.
       AMX-TRANSPOSE intrinsics are available via the -mamx-transpose
       compiler switch.
     * All of new feature support for Intel APX except for CFCMOV was
       added, including CCMP/CTEST, NF and ZU. APX support is available
       via the -mapxf compiler switch.
     * New ISA extension support for Intel AVX10.2 was added. AVX10.2
       intrinsics are available via the -mavx10.2 compiler switch.
     * New ISA extension support for Intel MOVRS was added. MOVRS
       intrinsics are available via the -mmovrs compiler switch. MOVRS
       vector intrinsics are available via the -mmovrs -mavx10.2 compiler
       switches.
     * EVEX version support for Intel SM4 was added. New 512-bit SM4
       intrinsics are available via the -msm4 -mavx10.2 compiler switches.
     * GCC now supports the Intel CPU named Diamond Rapids through
       -march=diamondrapids. Based on ISA extensions enabled on Granite
       Rapids D, the switch in addition further enables the AMX-AVX512,
       AMX-FP8, AMX-MOVRS, AMX-TF32, AMX-TRANSPOSE, APX_F, AVX10.2,
       AVX-IFMA, AVX-NE-CONVERT, AVX-VNNI-INT16, AVX-VNNI-INT8, CMPccXADD,
       MOVRS, SHA512, SM3, SM4, and USER_MSR ISA extensions. Since GCC
       15.2, AMX-TRANSPOSE and USER_MSR are not enabled any longer.
     * Since GCC 15.2, CLDEMOTE is not enabled through the compiler
       switches -march=alderlake, -march=arrowlake, -march=arrowlake-s,
       -march=gracemont, -march=lunarlake, -march=meteorlake,
       -march=pantherlake and -march=raptorlake any longer. KL and WIDEKL
       are not enabled through the compiler switches
       -march=clearwaterforest and -march=pantherlake any longer.
       PREFETCHI is not enabled through the compiler switch
       -march=pantherlake any longer.
     * Support for Xeon Phi CPUs (a.k.a. Knight Landing and Knight Mill)
       were removed in GCC 15. GCC will no longer accept -march=knl,
       -march=knm, -mavx5124fmaps, -mavx5124vnniw, -mavx512er, -mavx512pf,
       -mprefetchwt1, -mtune=knl, and -mtune=knm compiler switches.
     * -mavx10.1-256, -mavx10.1-512, and -mevex512 are deprecated.
       Meanwhile, -mavx10.1 enables AVX10.1 intrinsics with 512-bit vector
       support, while in GCC 14.1 and GCC 14.2, it only enables 256-bit
       vector support. GCC will emit a warning when using these compiler
       switches. -mavx10.1-256, -mavx10.1-512, and -mevex512 will be
       removed in GCC 16 together with the warning for the behavior change
       on -mavx10.1.
     * With the -mveclibabi compiler switch GCC is able to generate
       vectorized calls to external libraries. GCC 15 newly supports
       generating vectorized math calls to the math library from AMD
       Optimizing CPU Libraries (AOCL LibM). This option is available
       through -mveclibabi=aocl. GCC still supports generating calls to
       AMD Core Math Library (ACML). However, that library is end-of-life
       and AOCL offers many more vectorized functions.

  [140]LoongArch

     * Support has been added for target attributes and pragmas. For more
       details on available attributes and pragmas, including their proper
       usage, please refer to the provided [141]documentation.
     * Support has been added for the new option
       [142]-mannotate-tablejump, which can create an annotation section
       .discard.tablejump_annotate to correlate the jirl instruction and
       the jump table.
     * Add CRC expander to generate faster CRC.
     * Add ABI names for FPR.

  [143]NVPTX

     * The standard C++ library (libstdc++) is now supported and enabled.
     * GCC's nvptx target now supports constructors and destructors. For
       this, a recent version of [144]nvptx-tools is required.

  [145]S/390, System z, IBM z Systems

     * Support for the z17 architecture has been added. When using option
       -march=z17, the compiler will generate code making use of the new
       instructions introduced with the vector enhancement facility 3 and
       the miscellaneous instruction extension facility 4. Option
       -mtune=z17 enables z17 specific instruction scheduling without
       making use of new instructions.
     * Builtins for the new vector instructions have been added and can be
       enabled as before using option -mzvector.
     * Option -mlra and its counterpart -mno-lra have been removed.

  [146]SH

     * Bare metal sh-elf targets are now using the newer soft-fp library
       for improved performance of floating-point emulation on CPUs
       without hardware floating-point support.

[147]Operating Systems

  PowerPC Darwin

     * Fortran's IEEE modules are now supported on Darwin PowerPC.

[148]Improvements to SARIF support

     * GCC's [149]SARIF output has been extended in the following ways
          + GCC's SARIF output now captures all locations and labelled
            source ranges associated with a diagnostic, so that e.g. for
      PATH/missing-semicolon.c: In function 'missing_semicolon':
      PATH/missing-semicolon.c:9:12: error: expected ';' before '}' token
          9 |   return 42
            |            ^
            |            ;
         10 | }
            | ~

            GCC's SARIF output now captures the secondary location (that
            of the trailing close brace), as well as that of the missing
            semicolon.
          + For every location in a diagnostic that isn't in the main
            source file, GCC's SARIF output now captures the chain of
            #include directives that led to that location, using
            locationRelationship objects ([150]§3.34).
          + SARIF [151]message objects now capture embedded URLs in GCC
            diagnostics ([152]§3.11.6). In particular, references to other
            events in diagnostic paths now capture URLs to the pertinent
            threadFlowLocation object for the other event, such as
          "text": "second 'free' here; first 'free' was at [(1)](sarif:/runs/0/r
esults/0/codeFlows/0/threadFlows/0/locations/0)"

          + GCC's SARIF output now captures the command-line arguments
            ([153]§3.20.2), timestamps for the start and end of
            compilation ([154]§§3.20.7-8), and the working directory
            ([155]§3.20.19). It also now sets the roles property for SARIF
            artifact objects ([156]§3.24.6).
          + For warnings where encoding is significant, such as
            [157]-Wbidi-chars for a "trojan source" attack GCC's SARIF
            output gains a rendered property ([158]§3.3.4) that escapes
            non-ASCII text in source snippets, such as:
    "rendered": {"text":

            where "text" has a string value such as:
            "22 |     /* end admins only <U+202E> {{ <U+2066>:*/\n"
            "   |                        ~~~~~~~~   ~~~~~~~~ ^\n"
            "   |                        |          |        |\n"
            "   |                        |          |        end of bidirectiona
l context\n"
            "   |                        |          U+2066 (LEFT-TO-RIGHT ISOLAT
E)\n"
            "   |                        U+202E (RIGHT-TO-LEFT OVERRIDE)\n"}}}},

            (shown here with the JSON string split into multiple lines for
            clarity).
          + Experimental SARIF 2.2 output has been added, via
            [159]-fdiagnostics-add-output=sarif:version=2.2-prerelease.
            Given that the SARIF 2.2 specification is still under
            development, this uses an unofficial draft of the
            specification, and is subject to change.
          + The crash handler has been extended so that it will attempt to
            capture a backtrace of GCC's stack in JSON form within a
            property bag in SARIF output. The precise format of the
            property is subject to change
     * GCC 15 adds a new sarif-replay command-line tool for viewing .sarif
       files. It uses [160]libgdiagnostics to "replay" any diagnostics
       found in the .sarif files in text form as if they were GCC
       diagnostics, with support for details such as fix-it hints,
       underlined ranges, and diagnostic paths.

[161]Improvements to Static Analyzer

     * GCC's logic for printing execution paths has been improved in
       various ways
          + The problematic event in an analyzer path is now highlighted
            with a warning emoji (⚠️), where the locale supports this,
            such as in the examples below.
          + Paths can show control flow using ASCII art, such as:
infinite-loop-linked-list.c: In function ‘while_loop_missing_next’:
infinite-loop-linked-list.c:30:10: warning: infinite loop [CWE-835] [-Wanalyzer-
infinite-loop]
   30 |   while (n)
      |          ^
  ‘while_loop_missing_next’: events 1-3
   30 |   while (n)
      |          ^
      |          |
      |          (1) ⚠️  infinite loop here
      |          (2) when ‘n’ is non-NULL: always following ‘true’ branch... ─>
─┐
      |
│
      |
│
      |┌──────────────────────────────────────────────────────────────────────
──┘
   31 |│    {
   32 |│      sum += n->val;
      |│             ~~~~~~
      |│              |
      |└─────────────>(3) ...to here
  ‘while_loop_missing_next’: event 4
   32 |       sum += n->val;
      |       ~~~~^~~~~~~~~
      |           |
      |           (4) looping back... ─>─┐
      |                                  │
  ‘while_loop_missing_next’: event 5
      |                                  │
      |┌─────────────────────────────────┘
   30 |│  while (n)
      |│         ^
      |│         |
      |└────────>(5) ...to here

          + Interprocedural depth markers now use unicode box-drawing
            characters where the locale supports this, and they are
            eliminated for purely intraprocedural paths, such as in the
            example of [162]-Wanalyzer-infinite-loop above.
     * A new [163]-fanalyzer warning
       [164]-Wanalyzer-undefined-behavior-ptrdiff warns about pointer
       subtractions involving different chunks of memory. For example:
    demo.c: In function ‘test_invalid_calc_of_array_size’:
    demo.c:9:20: warning: undefined behavior when subtracting pointers [CWE-469]
 [-Wanalyzer-undefined-behavior-ptrdiff]
        9 |   return &sentinel - arr;
          |                    ^
      events 1-2
        │
        │    3 | int arr[42];
        │      |     ~~~
        │      |     |
        │      |     (2) underlying object for right-hand side of subtraction cr
eated here
        │    4 | int sentinel;
        │      |     ^~~~~~~~
        │      |     |
        │      |     (1) underlying object for left-hand side of subtraction cre
ated here
        │
        └──> ‘test_invalid_calc_of_array_size’: event 3
               │
               │    9 |   return &sentinel - arr;
               │      |                    ^
               │      |                    |
               │      |                    (3) ⚠️  subtraction of pointers has u
ndefined behavior if they do not point into the same array object
               │

Other significant improvements

  [165]libgdiagnostics

   GCC's code for emitting diagnostics is now available to other
   GPL3-compatible projects as a shared library, [166]libgdiagnostics.
   This covers such features as colorization, quoting lines of source
   code, labelling ranges of source, fix-it hints, execution paths, SARIF
   output, and so on. There is a C API, along with C++ and Python
   bindings.

[167]GCC 15.1

   This is the [168]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 15.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

[169]GCC 15.2

   This is the [170]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 15.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).


    For questions related to the use of GCC, please consult these web
    pages and the [171]GCC manuals. If that fails, the
    [172]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [173]gcc@gcc.gnu.org. All of [174]our lists have public
    archives.

   Copyright (C) [175]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [176]maintained by the GCC team. Last modified
   2026-04-13.

References

   1. https://gcc.gnu.org/gcc-15/porting_to.html
   2. https://gcc.gnu.org/onlinedocs/index.html#current
   3. https://gcc.gnu.org/pipermail/gcc/2022-December/240322.html
   4. https://gcc.gnu.org/backends.html
   5. https://gcc.gnu.org/onlinedocs/gcc/Static-Analyzer-Options.html
   6. https://gcc.gnu.org/onlinedocs/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-format
   7. https://gcc.gnu.org/wiki/SARIF
   8. https://gcc.gnu.org/gcc-15/changes.html#general
   9. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/Optimize-Options.html#index-flto-incremental
  10. https://gcc.gnu.org/onlinedocs/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-add-output
  11. https://gcc.gnu.org/onlinedocs/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-add-output
  12. https://gcc.gnu.org/wiki/SARIF
  13. https://gcc.gnu.org/onlinedocs/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-set-output
  14. https://gcc.gnu.org/onlinedocs/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-format
  15. https://gcc.gnu.org/gcc-15/changes.html#languages
  16. https://gcc.gnu.org/gcc-15/changes.html#openmp
  17. https://gcc.gnu.org/projects/gomp/
  18. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/libgomp/Offload-Target-Specifics.html
  19. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/libgomp/OMP_005fALLOCATOR.html
  20. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/libgomp/nvptx.html
  21. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/libgomp/Foreign-runtime-support-for-Nvidia-GPUs.html
  22. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/libgomp/Foreign-runtime-support-for-AMD-GPUs.html
  23. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/libgomp/omp_005fget_005fdevice_005ffrom_005fuid.html
  24. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/libgomp/omp_005fget_005fuid_005ffrom_005fdevice.html
  25. https://gcc.gnu.org/gcc-15/changes.html#cobol
  26. https://www.cobolworx.com/
  27. https://gcc.gnu.org/gcc-15/changes.html#ada
  28. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gnat_rm/Attribute-Round.html#index-Round
  29. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gnat_rm/Attribute-Super.html#index-Super
  30. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gnat_rm/Mutably-Tagged-Types-with-Size_2019Class-Aspect.html
  31. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gnat_rm/Generalized-Finalization.html
  32. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gnat_rm/No_005fRaise-aspect.html
  33. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gnat_rm/External_005fInitialization-Aspect.html
  34. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gnat_rm/Pragma-Exit_005fCases.html#index-Exit_005fCases
  35. https://docs.adacore.com/spark2014-docs/html/lrm/subprograms.html#program-exit-aspects
  36. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gnat_rm/Experimental-Language-Extensions.html
  37. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gnat_ugn/Info-message-Control.html
  38. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gnat_ugn/Warning-Message-Control.html#index--gnatw_002en-_0028gcc_0029
  39. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gnat_ugn/Warning-Message-Control.html#index--gnatw_005fl-_0028gcc_0029
  40. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gnat_ugn/Warning-Message-Control.html#index--gnatw_002ev-_0028gcc_0029
  41. https://gcc.gnu.org/git/?p=gcc.git;a=blob;f=gcc/ada/debug.adb
  42. https://docs.adacore.com/spark2014-docs/html/ug/en/source/spark_libraries.html
  43. https://gcc.gnu.org/onlinedocs/gnat_rm/Finally-construct.html
  44. https://github.com/AdaCore/ada-spark-rfcs/blob/master/features/rfc-finally.md
  45. https://gcc.gnu.org/onlinedocs/gnat_rm/String-interpolation.html
  46. https://github.com/AdaCore/ada-spark-rfcs/blob/master/features/rfc-string-interpolation.md
  47. https://gcc.gnu.org/gcc-15/changes.html#c-family
  48. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/Statement-Attributes.html#index-musttail-statement-attribute
  49. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/Extended-Asm.html
  50. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/Common-Function-Attributes.html#index-nonnull_005fif_005fnonzero-function-attribute
  51. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/Warning-Options.html#index-Wtrailing-whitespace_003d
  52. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/Warning-Options.html#index-Wleading-whitespace_003d
  53. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/Warning-Options.html#index-Wheader-guard
  54. https://gcc.gnu.org/gcc-15/changes.html#c
  55. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/C-Dialect-Options.html#index-std-1
  56. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/C-Dialect-Options.html#index-std-1
  57. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/C-Dialect-Options.html#index-std-1
  58. https://gcc.gnu.org/gcc-15/porting_to.html#c23
  59. https://gcc.gnu.org/gcc-15/changes.html#cxx
  60. https://wg21.link/P2558R2
  61. https://gcc.gnu.org/PR110343
  62. https://wg21.link/P2552R3
  63. https://gcc.gnu.org/PR110345
  64. https://wg21.link/P2662R3
  65. https://gcc.gnu.org/PR113798
  66. https://wg21.link/P0609R3
  67. https://gcc.gnu.org/PR114456
  68. https://wg21.link/P2573R2
  69. https://gcc.gnu.org/PR114458
  70. https://wg21.link/P2893R3
  71. https://gcc.gnu.org/PR114459
  72. https://wg21.link/P3034R1
  73. https://gcc.gnu.org/PR114461
  74. https://wg21.link/P2747R2
  75. https://gcc.gnu.org/PR115744
  76. https://wg21.link/P0963R3
  77. https://gcc.gnu.org/PR115745
  78. https://wg21.link/P3144R2
  79. https://gcc.gnu.org/PR115747
  80. https://wg21.link/P3176R0
  81. https://gcc.gnu.org/PR117786
  82. https://wg21.link/P2865R5
  83. https://gcc.gnu.org/PR117788
  84. https://wg21.link/P1967R14
  85. https://gcc.gnu.org/PR119065
  86. https://wg21.link/P3247R2
  87. https://gcc.gnu.org/PR117787
  88. https://wg21.link/P2615R1
  89. https://gcc.gnu.org/PR107688
  90. https://wg21.link/P2718R0
  91. https://gcc.gnu.org/PR107637
  92. https://wg21.link/cwg36
  93. https://wg21.link/cwg882
  94. https://wg21.link/cwg1363
  95. https://wg21.link/cwg1496
  96. https://wg21.link/cwg2387
  97. https://wg21.link/cwg2521
  98. https://wg21.link/cwg2627
  99. https://wg21.link/cwg2819
 100. https://wg21.link/cwg2867
 101. https://wg21.link/cwg2918
 102. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/Asm-constexprs.html
 103. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/C_002b_002b-Dialect-Options.html#index-fassume-sane-operators-new-delete
 104. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/Warning-Options.html#index-Wself-move
 105. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wtemplate-body
 106. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/Common-Type-Attributes.html#index-flag_005fenum-type-attribute
 107. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wdangling-reference
 108. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wdefaulted-function-deleted
 109. https://wg21.link/cwg2789
 110. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/New_002fDelete-Builtins.html
 111. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=12de1942a0a673f9f2f1c2bfce4279a666061ffc
 112. https://gcc.gnu.org/onlinedocs/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-set-output
 113. https://godbolt.org/z/K4jGrhao1
 114. https://gcc.gnu.org/gcc-15/changes.html#libstdcxx
 115. https://gcc.gnu.org/gcc-15/changes.html#d
 116. https://dlang.org/changelog/2.111.0.html
 117. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gdc/Runtime-Options.html#index-finclude-imports
 118. https://gcc.gnu.org/gcc-15/changes.html#fortran
 119. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gfortran/Unsigned-integers.html
 120. https://j3-fortran.org/doc/year/24/24-116.txt
 121. https://gcc.gnu.org/gcc-15/changes.html#modula2
 122. https://gcc.gnu.org/gcc-15/changes.html#rust
 123. https://gcc.gnu.org/gcc-15/changes.html#targets
 124. https://gcc.gnu.org/gcc-15/changes.html#aarch64
 125. https://github.com/ARM-software/acle
 126. https://gcc.gnu.org/gcc-15/changes.html#amdgcn
 127. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/AMD-GCN-Options.html
 128. https://gcc.gnu.org/install/specific.html#amdgcn-x-amdhsa
 129. https://gcc.gnu.org/gcc-15/changes.html#avr
 130. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/AVR-Function-Attributes.html#index-signal_0028num_0029-function-attribute_002c-AVR
 131. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/AVR-Built-in-Functions.html#index-_005f_005fbuiltin_005favr_005fmask1
 132. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/Named-Address-Spaces.html#AVR-Named-Address-Spaces-1
 133. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/AVR-Options.html#index-mcvt
 134. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/AVR-Options.html#index-mno-call-main
 135. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/AVR-Options.html#index-mfuse-move
 136. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/AVR-Options.html#index-msplit-ldst
 137. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/AVR-Options.html#index-msplit-bit-shift
 138. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/AVR-Options.html#index-muse-nonzero-bits
 139. https://gcc.gnu.org/gcc-15/changes.html#x86
 140. https://gcc.gnu.org/gcc-15/changes.html#loongarch
 141. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/LoongArch-Function-Attributes.html#LoongArch-Function-Attributes-1
 142. https://gcc.gnu.org/onlinedocs/gcc-15.1.0/gcc/LoongArch-Options.html#index-mannotate-tablejump
 143. https://gcc.gnu.org/gcc-15/changes.html#nvptx
 144. https://gcc.gnu.org/install/specific.html#nvptx-x-none
 145. https://gcc.gnu.org/gcc-15/changes.html#s390
 146. https://gcc.gnu.org/gcc-15/changes.html#sh
 147. https://gcc.gnu.org/gcc-15/changes.html#os
 148. https://gcc.gnu.org/gcc-15/changes.html#sarif
 149. https://gcc.gnu.org/wiki/SARIF
 150. https://docs.oasis-open.org/sarif/sarif/v2.1.0/errata01/os/sarif-v2.1.0-errata01-os-complete.html#_Toc141790978
 151. https://docs.oasis-open.org/sarif/sarif/v2.1.0/errata01/os/sarif-v2.1.0-errata01-os-complete.html#_Toc141790709
 152. https://docs.oasis-open.org/sarif/sarif/v2.1.0/errata01/os/sarif-v2.1.0-errata01-os-complete.html#_Toc141790717
 153. https://docs.oasis-open.org/sarif/sarif/v2.1.0/errata01/os/sarif-v2.1.0-errata01-os-complete.html#_Toc141790819
 154. https://docs.oasis-open.org/sarif/sarif/v2.1.0/errata01/os/sarif-v2.1.0-errata01-os-complete.html#_Toc141790824
 155. https://docs.oasis-open.org/sarif/sarif/v2.1.0/errata01/os/sarif-v2.1.0-errata01-os-complete.html#_Toc141790836
 156. https://docs.oasis-open.org/sarif/sarif/v2.1.0/errata01/os/sarif-v2.1.0-errata01-os-complete.html#_Toc141790867
 157. https://gcc.gnu.org/onlinedocs/gcc/Warning-Options.html#index-Wbidi-chars
 158. https://docs.oasis-open.org/sarif/sarif/v2.1.0/errata01/os/sarif-v2.1.0-errata01-os-complete.html#_Toc141790676
 159. https://gcc.gnu.org/onlinedocs/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-add-output
 160. https://gcc.gnu.org/wiki/libgdiagnostics
 161. https://gcc.gnu.org/gcc-15/changes.html#analyzer
 162. https://gcc.gnu.org/onlinedocs/gcc/Static-Analyzer-Options.html#index-Wanalyzer-infinite-loop
 163. https://gcc.gnu.org/onlinedocs/gcc/Static-Analyzer-Options.html
 164. https://gcc.gnu.org/onlinedocs/gcc/Static-Analyzer-Options.html#index-Wanalyzer-undefined-behavior-ptrdiff
 165. https://gcc.gnu.org/gcc-15/changes.html#libgdiagnostics
 166. https://gcc.gnu.org/wiki/libgdiagnostics
 167. https://gcc.gnu.org/gcc-15/changes.html#15.1
 168. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=15.0
 169. https://gcc.gnu.org/gcc-15/changes.html#15.2
 170. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=15.2
 171. https://gcc.gnu.org/onlinedocs/
 172. mailto:gcc-help@gcc.gnu.org
 173. mailto:gcc@gcc.gnu.org
 174. https://gcc.gnu.org/lists.html
 175. https://www.fsf.org/
 176. https://gcc.gnu.org/about.html
======================================================================
http://gcc.gnu.org/gcc-14/index.html
                             GCC 14 Release Series

   May 23, 2025

   The GCC developers are pleased to announce the release of GCC 14.3.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 14.2 relative to previous releases of GCC.

Release History

   GCC 14.3
          May 23, 2025 ([1]changes, [2]documentation)

   GCC 14.2
          Aug 1, 2024 ([3]changes, [4]documentation)

   GCC 14.1
          May 7, 2024 ([5]changes, [6]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [7]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [8]GCC project
   web site or contact the [9]GCC development mailing list.

   To obtain GCC please use [10]our mirror sites or [11]our version
   control system.


    For questions related to the use of GCC, please consult these web
    pages and the [12]GCC manuals. If that fails, the
    [13]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [14]gcc@gcc.gnu.org. All of [15]our lists have public
    archives.

   Copyright (C) [16]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [17]maintained by the GCC team. Last modified
   2025-05-23.

References

   1. https://gcc.gnu.org/gcc-14/changes.html
   2. https://gcc.gnu.org/onlinedocs/14.3.0/
   3. https://gcc.gnu.org/gcc-14/changes.html
   4. https://gcc.gnu.org/onlinedocs/14.2.0/
   5. https://gcc.gnu.org/gcc-14/changes.html
   6. https://gcc.gnu.org/onlinedocs/14.1.0/
   7. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Contributors.html
   8. https://gcc.gnu.org/index.html
   9. mailto:gcc@gcc.gnu.org
  10. https://gcc.gnu.org/mirrors.html
  11. https://gcc.gnu.org/git.html
  12. https://gcc.gnu.org/onlinedocs/
  13. mailto:gcc-help@gcc.gnu.org
  14. mailto:gcc@gcc.gnu.org
  15. https://gcc.gnu.org/lists.html
  16. https://www.fsf.org/
  17. https://gcc.gnu.org/about.html
======================================================================
http://gcc.gnu.org/gcc-14/changes.html
                             GCC 14 Release Series
                        Changes, New Features, and Fixes

   This page is a "brief" summary of some of the huge number of
   improvements in GCC 14. You may also want to check out our [1]Porting
   to GCC 14 page and the [2]full GCC documentation.

Caveats

     * C: Support for the GCC extension, a structure containing a C99
       flexible array member, or a union containing such a structure, is
       not the last field of another structure, is deprecated. Refer to
       [3]Zero Length Arrays. Any code relying on this extension should be
       modified to ensure that C99 flexible array members only end up at
       the ends of structures. Please use the warning option
       [4]-Wflex-array-member-not-at-end to identify all such cases in the
       source code and modify them.
     * C: Certain warnings about are now errors, see [5]Porting to GCC 14
       for details.
     * [6]-fcf-protection=[full|branch|return|none|check] has been
       refactored. To override -fcf-protection with a more specific
       setting, add -fcf-protection=none followed by a specific
       -fcf-protection=xxx.
     * Support for the ia64*-*- target ports which have been unmaintained
       for quite a while has been declared obsolete in GCC 14. The next
       release of GCC will have their sources permanently removed.
     * Support for the nios2*-*- target ports has also been declared
       obsolete in GCC 14, and the sources will also be removed in the
       next release of GCC.
     * [7]-fanalyzer is still only suitable for analyzing C code. In
       particular, using it on C++ is unlikely to give meaningful output.

[8]General Improvements

     * For offload-device code generated via OpenMP and OpenACC, the math
       and the Fortran runtime libraries will now automatically be linked,
       when the user or compiler links them on the host side. Thus, it is
       no longer required to explicitly pass -lm and/or -lgfortran to the
       offload-device linker using the [9]-foffload-options= flag.
     * New configure options: --enable-host-pie, to build the compiler
       executables as PIE; and --enable-host-bind-now, to link the
       compiler executables with -Wl,-z,now in order to enable additional
       hardening.
     * New option [10]-fhardened, an umbrella option that enables a set of
       hardening flags. The options it enables can be displayed using the
       --help=hardened option.
     * New option [11]-fharden-control-flow-redundancy, to verify, at the
       end of functions, that the visited basic blocks correspond to a
       legitimate execution path, so as to detect and prevent attacks that
       transfer control into the middle of functions.
     * New type attribute [12]hardbool, for C and Ada. Hardened booleans
       take user-specified representations for true and false, presumably
       with higher hamming distance than standard booleans, and get
       verified at every use, detecting memory corruption and some
       malicious attacks.
     * New type attribute [13]strub to control stack scrubbing properties
       of functions and variables. The stack frame used by functions
       marked with the attribute gets zeroed-out upon returning or
       exception escaping. Scalar variables marked with the attribute
       cause functions containing or accessing them to get stack scrubbing
       enabled implicitly.
     * New option [14]-finline-stringops, to force inline expansion of
       memcmp, memcpy, memmove and memset, even when that is not an
       optimization, to avoid relying on library implementations.
     * New option [15]-ftrampoline-impl=, to choose the placement of
       generated trampolines. The default remains the stack for almost all
       targets. To override the default, -ftrampoline-impl=heap can be
       passed on supported ABIs (x86_64 Darwin, x86_64 and aarch64 Linux).
     * New function attribute [16]null_terminated_string_arg(PARAM_IDX)
       for indicating parameters that are expected to be null-terminated
       strings.
     * The vectorizer now supports vectorizing loops which contain any
       number of early breaks. This means loops such as:
            int z[100], y[100], x[100];
            int foo (int n)
            {
              int res = 0;
              for (int i = 0; i < n; i++)
                {
                   y[i] = x[i] * 2;
                   res += x[i] + y[i];

                   if (x[i] > 5)
                     break;

                   if (z[i] > 5)
                     break;

                }
              return res;
            }

       can now be vectorized on a number of targets. In this first version
       any input data sources must either have a statically known size at
       compile time or the vectorizer must be able to determine based on
       auxiliary information that the accesses are aligned.

[17]New Languages and Language specific improvements

     * [18]OpenMP
          + The [19]GNU Offloading and Multi Processing Runtime Library
            Manual has been updated and extended, improving especially the
            description of ICVs, memory allocation, environment variables
            and OpenMP routines.
          + The requires directive's unified_address requirement is now
            fulfilled by both AMD GCN and nvptx devices. AMD GCN and nvptx
            devices now support low-latency allocators as [20]detailed in
            the manual. Initial support for pinned-memory allocators has
            been added and, on Linux, [21]libnuma is now used for
            allocators requesting the nearest-partition trait (both is
            described in the [22]memory allocation section of the manual).
          + OpenMP 5.0: The allocate directive is now supported for stack
            variables in C and Fortran, including the OpenMP 5.1 align
            modifier. In C and C++ the map clause now accepts lvalue
            expressions. For Fortran, OpenMP allocators can now be used
            for allocatables and pointers using the allocate directive and
            its OpenMP 5.2 replacement, the allocators directive; files
            using this allocator and all files that might directly or
            indirectly (intrinsic assignment, intent(out), ...) de- or
            reallocate such-allocated variables must be compiled with the
            [23]-fopenmp-allocators option.
          + OpenMP 5.1: Support was added for collapsing imperfectly
            nested loops and using present as map-type modifier and in
            defaultmap. The indirect clause is now supported. The
            performance of copying strided data from or to nvptx and AMD
            GPU devices using the OpenMP 5.1 routine
            omp_target_memcpy_rect has been improved.
          + OpenMP 5.2: The OMP_TARGET_OFFLOAD=mandatory handling has been
            updated for the clarifications and changes of the 5.2
            specification. For Fortran, the list of directives permitted
            in Fortran pure procedures was extended. Additionally, the
            spec change has been implemented for default implicit mapping
            of C/C++ pointers pointing to unmapped storage. The destroy
            clause now optionally accepts the depend object as argument.
          + OpenMP 6.0 preview (TR11/TR12): The decl attribute is now
            supported in C++ 11 and the directive, sequence and decl
            attributes are now supported in C 23.
     * [24]OpenACC
          + OpenACC 2.7: The self clause was added to be used on compute
            constructs and the default clause for data constructs.
            Additionally, the readonly modifier is now handled in the
            copyin clause and cache directive.
          + OpenACC 3.2: The following API routines are now available in
            Fortran using the openacc module or the openacc_lib.h header
            file: acc_malloc, acc_free, acc_map_data, acc_unmap_data,
            acc_deviceptr, acc_hostptr, acc_memcpy_to_device,
            acc_memcpy_to_device_async, acc_memcpy_from_device, and
            acc_memcpy_from_device_async.

  [25]Ada

     * New implementation-defined aspects and pragmas:
          + [26]Local_Restrictions, which specifies that a particular
            subprogram does not violate one or more local restrictions,
            nor can it call a subprogram that is not subject to the same
            requirements.
          + [27]User_Aspect_Definition and [28]User_Aspect, which provide
            a mechanism for avoiding textual duplication if some set of
            aspect specifications is needed in multiple places.
     * New implementation-defined aspects and pragmas for verification of
       the SPARK 2014 subset of Ada:
          + [29]Always_Terminates, which provides a condition for a
            subprogram to necessarily complete (either return normally or
            raise an exception).
          + [30]Ghost_Predicate, which introduces a subtype predicate that
            can reference Ghost entities.
          + [31]Exceptional_Cases, which lists exceptions that might be
            propagated by the subprogram with side effects in the context
            of its precondition and associates them with a specific
            postcondition.
          + [32]Side_Effects, which indicates that a function should be
            handled like a procedure with respect to parameter modes,
            Global contract, exceptional contract and termination: it may
            have output parameters, write global variables, raise
            exceptions and not terminate.
     * The new attributes and contracts have been applied to the relevant
       parts of the Ada runtime library, which has been subsequently
       proven to be correct with SPARK 2014.
     * Support for the LoongArch architecture.
     * Support for VxWorks 7 Cert RTP has been removed.
     * Additional hardening improvements. For more information related to
       hardening options, refer to the [33]GCC Instrumentation Options and
       the [34]GNAT Reference Manual, Security and Hardening Features.
     * Improve style checking for redundant parentheses with [35]-gnatyz
     * New switch [36]-gnateH to force reverse Bit_Order threshold to 64.
     * Experimental features:
          + [37]Storage Model: this feature proposes to redesign the
            concepts of Storage Pools into a more efficient model allowing
            higher performance and easier integration with low footprint
            embedded runtimes.
          + [38]String Interpolation: allows for easier string formatting.
     * [39]Fixed lower bound [40][RFC] : Unconstrained array types and
       subtypes can be specified with a lower bound that is fixed to a
       certain value, by writing an index range that uses the syntax
       <lower-bound-expression> .. <>. This guarantees that all objects of
       the type or subtype will have the specified lower bound.
     * Further clean up and improvements to the GNAT code.

  [41]C family

     * The Clang language extensions __has_feature and __has_extension
       have been implemented in GCC. These are available from C, C++, and
       Objective-C(++). This is primarily intended to aid the portability
       of code written against Clang.
     * GCC supports a new pragma #pragma GCC novector to indicate to the
       vectorizer not to vectorize the loop annotated with the pragma.

  [42]C

     * Some more C23 features have been implemented:
          + Bit-precise integer types (_BitInt (N) and unsigned _BitInt
            (N)): integer types with a specified number of bits. These are
            only supported on IA-32, x86-64 and AArch64 (little-endian) at
            present.
          + Structure, union and enumeration types may be defined more
            than once in the same scope with the same contents and the
            same tag; if such types are defined with the same contents and
            the same tag in different scopes, the types are compatible.
          + The <stdckdint.h> header for checked integer arithmetic.
     * In addition to those C23 features, there are new command-line
       options -std=c23, -std=gnu23 and -Wc11-c23-compat. These are
       equivalent to the previous options -std=c2x, -std=gnu2x and
       -Wc11-c2x-compat, which are deprecated but remain supported.

  [43]C++

     * Several C++26 features have been implemented:
          + [44]P1854R4, Making non-encodable string literals ill-formed
            ([45]PR110341)
          + [46]P2752R3, Static storage for braced initializers
            ([47]PR110346)
          + [48]P2361R6, Unevaluated strings ([49]PR110342)
          + [50]P2738R1, constexpr cast from void* ([51]PR110344)
          + [52]P2741R3, User-generated static_assert messages
            ([53]PR110348)
          + [54]P2169R4, Placeholder variables with no name ([55]PR110349)
          + [56]P2864R2, Removing deprecated arithmetic conversion on
            enumerations
          + [57]P2748R5, Disallow binding a returned reference to a
            temporary ([58]PR114455)
          + [59]P2809R3, Trivial infinite loops are not undefined behavior
            ([60]PR114462)
     * Several C++23 features have been implemented:
          + [61]P0847R7, Deducing this ([62]PR102609)
          + [63]P2280R4, Using unknown references in constant expressions
            ([64]PR106650)
          + [65]P2564R3, consteval needs to propagate up ([66]PR107687)
          + [67]P2582R1, Class template argument deduction from inherited
            constructors ([68]PR106653)
     * Several C++ Defect Reports have been resolved, e.g.:
          + [69]DR 532, Member/nonmember operator template partial
            ordering
          + [70]DR 976, Deduction for const T& conversion operators
          + [71]DR 2262, Attributes for asm-definition
          + [72]DR 2359, Unintended copy initialization with designated
            initializers
          + [73]DR 2386, tuple_size requirements for structured binding
          + [74]DR 2406, [[fallthrough]] attribute and iteration
            statements
          + [75]DR 2543, constinit and optimized dynamic initialization
          + [76]DR 2586, Explicit object parameter for assignment and
            comparison
          + [77]DR 2735, List-initialization and conversions in overload
            resolution
          + [78]DR 2799, Inheriting default constructors
     * When a diagnostic occurs involving a C++ template, GCC will now
       quote the source code of the context at which the template is
       instantiated ("required from here"), rather than just print
       filename and line/column numbers.
     * New built-in __type_pack_element to speed up traits such as
       std::tuple_element ([79]PR100157)
     * goto can cross the initialization of a trivially initialized object
       with a non-trivial destructor ([80]DR 2256)
     * -Wdangling-reference false positives have been reduced. The warning
       does not warn about std::span-like classes; there is also a new
       attribute gnu::no_dangling to suppress the warning. See [81]the
       manual for more info.
     * noexcept(expr) is now mangled as per the Itanium ABI
     * the named return value optimization can now be performed even for
       variables declared in an inner block of a function, see the
       [82]test
     * New -Wnrvo warning, to warn if the named return value optimization
       is not performed although it is allowed by [class.copy.elision].
       See [83]the manual for more info.
     * The backing array for std::initializer_list has been made static,
       allowing combining multiple equivalent initializer-lists ([84]git)
     * New -Welaborated-enum-base warning, to warn if an additional
       enum-base is used in an elaborated-type-specifier
     * Better #include hints for missing headers ([85]PR110164)
     * The arguments of a variable template-id are coerced earlier than
       before, so various problems are detected earlier ([86]PR89442)
     * -Wmissing-field-initializers is no longer emitted for empty classes
       ([87]PR110064)
     * The constexpr code now tracks lifetimes in constant evaluation;
       this change helps to detect bugs such as accessing a variable whose
       lifetime has ended ([88]PR70331, [89]PR96630, [90]PR98675)
     * Array destruction can now be devirtualized
     * In-class member variable template partial specializations are now
       accepted ([91]PR71954)
     * Improved diagnostic for explicit conversion functions: when a
       conversion doesn't work out only because the conversion function
       necessary to do the conversion couldn't be used because it was
       marked explicit, explain that to the user ([92]git)
     * Corrected mangling of static/thread_local structured bindings at
       function/block scope ([93]PR111069)
     * [basic.scope.block]/2 violations are detected even in compound-stmt
       of function-try-block and for block-scope external variables
       ([94]PR52953)
     * Improved "not a constant expression" diagnostic when taking the
       address of a non-static constexpr variable ([95]PR91483)
     * Non-dependent simple assignments are checked even in templates
       ([96]PR18474)
     * Attributes hot and cold can be applied to classes as well. See
       [97]the manual for more info.
     * Function template constraints, as well as CTAD placeholders, are
       now mangled
     * Various decltype fixes: [98]PR79620, [99]PR79378, [100]PR83167,
       [101]PR96917
     * New option -fdiagnostics-all-candidates to note all candidates
       during overload resolution failure
     * -Walloc-size and -Wcalloc-transposed-args warnings are enabled for
       C++ as well
     * The DR 2237 code no longer gives an error, it emits a
       -Wtemplate-id-cdtor warning instead
     * C++ module scanning for named modules is now available, based on
       the format described in [102]P1689R5, Format for describing
       dependencies of source files. The -fdeps-format=, -fdeps-file=, and
       -fdeps-target= flags may be used to generate dependency
       information. In GCC 14 p1689r5 is the only valid argument for
       -fdeps-format=.

    [103]Runtime Library (libstdc++)

     * The libstdc++exp.a library now includes all the Filesystem TS
       symbols from the libstdc++fs.a library. The experimental symbols
       for the C++23 std::stacktrace class are also in libstdc++exp.a,
       replacing the libstdc++_libbacktrace.a library that GCC 13
       provides. This means that -lstdc++exp is the only library needed
       for all experimental libstdc++ features.
     * Improved experimental support for C++20, including:
          + std::chrono::parse.
          + Unicode-aware string handling in std::format.
     * Improved experimental support for C++23, including:
          + The std::ranges::to function for converting ranges to
            containers.
          + The std::generator view for getting results from coroutines.
          + The <stacktrace> header is supported by default.
          + std::print and std::println (requires linking with -lstdc++exp
            on Windows).
          + Formatters for std::thread::id and std::stacktrace.
          + Smart pointer adaptors, std::out_ptr and std::inout_ptr.
          + Some range adaptors now support move-only types.
     * Experimental support for C++26, including:
          + Native handles for filebuf, fstream, etc.
          + Functions for saturation arithmetic on integers.
          + std::to_string now uses std::format.
          + Enhanced formatting of pointers with std::format.
          + The std::runtime_format function to allow using non-literal
            format strings with std::format.
          + Testable result types for <charconv> functions.
          + The std::text_encoding class for identifying character sets
            (requires linking with -lstdc++exp for some member functions).
     * Faster numeric conversions using std::to_string and
       std::to_wstring.
     * Updated parallel algorithms that are compatible with oneTBB.
     * std::numeric_limits<_Float32> and std::numeric_limits<_Float64> are
       now defined for all standard modes, not only for C++23.
     * Added missing functions for float and long double to <cmath>.
     * Using the std::setfill manipulator with std::istream is deprecated.

  [104]D

     * Support for the D programming language has been updated to version
       2.108.1 of the language and run-time library. Full changelog for
       this release and previous releases can be found on the
       [105]dlang.org website.

  [106]Fortran

     * The compiler now accepts the -std=f2023 option, which has been
       added in preparation of support of Fortran 2023. This option
       increases the line-length limit for source in free-form to 10000,
       and statements may have up to 1 million characters.
     * With the -save-temps option, preprocessed files with the .fii
       extension will be generated from free-form source files such as
       .F90 and .fi from fixed-form files such as .F.

  [107]Modula-2

     * The automatic dependency generation options: -M, -MD, -MF, -MMD,
       -MP, -MQ and -MT have been implemented in the compiler.
     * The -Wcase-enum and -Wuninit-variable-checking= options have been
       implemented to provide compile-time warnings against missing case
       clauses and uninitialized variables respectively.

  [108]Rust

     * Experimental support for the Rust programming language has been
       added. The compiler is incomplete, but already supports a subset of
       the Rust programming language. The frontend does not support
       compiling the Rust standard library, so it cannot be used for most
       real-world Rust code yet. However, you can experiment with the
       compiler to run Rust code on #[no_core] targets.

[109]libgccjit

     * The libgccjit API gained 6 new entry points:
          + [110]gcc_jit_type_get_restrict for adding restrict to types
            ([111]LIBGCCJIT_ABI_25).
          + 4 functions for setting attributes on functions and variables
            ([112]LIBGCCJIT_ABI_26):
               o gcc_jit_function_add_attribute
               o gcc_jit_function_add_string_attribute
               o gcc_jit_function_add_integer_array_attribute
               o gcc_jit_lvalue_add_string_attribute
          + [113]gcc_jit_context_new_sizeof for accessing the size of a
            type ([114]LIBGCCJIT_ABI_27).

[115]New Targets and Target Specific Improvements

  [116]AArch64

     * A number of new CPUs are supported through the -mcpu and -mtune
       options (GCC identifiers in parentheses).
          + Ampere-1B (ampere1b).
          + Arm Cortex-A520 (cortex-a520).
          + Arm Cortex-A720 (cortex-a720).
          + Arm Cortex-X4 (cortex-x4).
          + Microsoft Cobalt-100 (cobalt-100).
     * Additionally, the identifiers generic, generic-armv8-a and
       generic-armv9-a can be used to optimize code generation for a good
       blend of CPUs of a particular architecture version. These tunings
       are also used as the default optimization targets when compiling
       with the -march=armv8-a or -march=armv9-a options and their point
       releases e.g. -march=armv8.2-a or -march=armv9.3-a.
     * New features in the Arm architecture are supported in a number of
       ways:
          + Support is added for the Arm Streaming Matrix Extensions SME
            and SME2 through the +sme and +sme2 extensions to -march=. In
            particular, this includes support for the Beta state of the
            [117]SME ACLE in the form of a new intrinsics arm_sme.h
            intrinsics header and a number of new keyword attributes to
            manage use of the new Streaming SVE state. For more
            information please refer to the ACLE documentation.
          + Libatomic is updated to implement 128-bit atomic operations
            locklessly on systems with FEAT_LSE2.
          + Support for FEAT_LRCPC3 is added through ACLE intrinsics in
            arm_neon.h header and enabled through the +rcpc3 extension to
            -march=.
     * As well as numerous AArch64 code generation improvements, the
       following optimization enhancements are noteworthy:
          + A new AArch64-specific register allocation pass is added. It
            runs in addition to standard register allocation. The pass's
            main purpose is to make use of strided vector register
            operands in SME instructions. However, it can also remove
            redundant moves in normal Advanced SIMD and SVE code. The pass
            is controlled by the new option -mearly-ra= that takes the
            arguments all, strided, none. -mearly-ra=all is enabled by
            default at optimization levels -O2 and above.
          + A new optimization pass to fuse loads and stores to adjacent
            memory locations into load and store-pair AArch64
            instructions. The pass is enabled by default when compiling
            with optimization and runs twice in the optimization pipeline:
            before and after register allocation. This can be controlled
            with the options -mearly-ldp-fusion and -mlate-ldp-fusion.
     * Conformance with the ACLE specification is improved and a number of
       features aimed at helping developers deploy Arm architecture
       features are added:
          + Support for the Beta version of the [118]Function
            Multiversioning Specification. This feature provides
            facilities to annotate functions with attributes that allow
            the compiler to generate multiple versions of the function,
            selected at runtime based on the architecture features
            available in the system. Please refer to the ACLE
            specification for more details.
          + Support for more ACLE intrinsics in the arm_acle.h header,
            including the [119]Memory prefetch intrinsics and the
            [120]Special register intrinsics. This also includes
            intrinsics for the extension to 128-bit system registers,
            enabled through the +d128 extension to -march=.
          + Intrinsics enabled by the +dotprod, +fp16, +fp16fml, +i8mm,
            +sha3 and +sm4 extensions to -march= no longer require
            -march=armv8.2-a or higher to be specified. Likewise, the
            intrinsics enabled by +memtag no longer require
            -march=armv8.5-a.
          + Support for the [121]NEON-SVE Bridge intrinsics. These are
            intrinsics that allow conversions between NEON and SVE
            vectors, enabled through the inclusion of the
            arm_neon_sve_bridge.h header.
     * The option -mtp= is now supported for changing the TPIDR register
       used for TLS accesses. For more details please refer to the
       [122]documentation.

  [123]AMD Radeon (GCN)

     * Initial support for the AMD Radeon gfx90c (GCN5), gfx1030, gfx1036
       (RDNA2), gfx1100 and gfx1103 (RDNA3) devices has been added. LLVM
       15+ (assembler and linker) is [124]required to support GFX11.
     * Improved register usage and performance on CDNA Instinct MI100 and
       MI200 series devices.
     * The default device architecture is now gfx900 (Vega).
     * Fiji (gfx803) device support is now deprecated and will be removed
       from a future release. The default compiler configuration no longer
       uses Fiji as the default device, and no longer includes the Fiji
       libraries. Both can be restored by configuring with
       [125]--with-arch=fiji .

  [126]arm

     * The Cortex-M52 CPU is now supported through the cortex-m52 argument
       to the -mcpu and -mtune options.

  [127]AVR

     * On AVR64* and AVR128* devices, read-only data is now located in
       program memory per default and no longer in RAM.
          + Only a 32 KiB block of program memory can be used to store and
            access .rodata in that way. Which block is used can be
            selected by defining the symbol __flmap. As an alternative,
            the byte address of the block can be specified by the symbol
            __RODATA_FLASH_START__ which takes precedence over __flmap.
            For example, linking with
            -Wl,--defsym,__RODATA_FLASH_START__=32k chooses the second
            32 KiB block.
          + The default uses the last 32 KiB block, which is also the
            hardware default for bit-field NVMCTRL_CTRLB.FLMAP.
          + When a non-default block is used, then NVMCTRL_CTRLB.FLMAP
            must be initialized accordingly by hand, or AVR-LibC v2.2 that
            implements [128]#931 can be used. The latter initializes
            NVMCTRL_CTRLB.FLMAP in the startup code and according to the
            value of __flmap or __RODATA_FLASH_START__.
          + When AVR-LibC with #931 is used, then defining the symbol
            __flmap_lock to a non-zero value will set bit
            NVMCTRL_CTRLB.FLMAPLOCK. This will protect NVMCTRL_CTRLB.FLMAP
            from any further changes — which would be Undefined Behaviour
            in C/C++. If you prefer to define the symbol in a C/C++ file,
            an asm statement can be used:
__asm (".global __flmap_lock"  "\n\t"
       "__flmap_lock = 1");
          + When you do not want the code from #931, then define a global
            symbol __do_flmap_init and the linker will not pull in that
            code from libmcu.a any more.
          + In order to return to the old placement of read-only data in
            RAM, the new compiler option -mrodata-in-ram can be used. This
            is required on devices where the hardware revision is affected
            by a silicon bug concerning the FLMAP functionality.
          + Read-only data is located in output section .rodata, whereas
            it is part of .text when located in RAM.
          + The feature is only available when the compiler is configured
            with a version of Binutils that implements [129]PR31124, which
            is the case for Binutils v2.42 and up.
          + The implementation consists of two parts:
              1. Binutils supports new emulations avrxmega2_flmap and
                 avrxmega4_flmap. The sole purpose of these emulations is
                 to provide adjusted default linker description files.
                 Apart from that, these emulations behave exactly the same
                 like avrxmega2 resp. avrxmega4.
              2. The compiler uses a [130]device-specs file which links
                 the program with -mavrxmega2_flmap or -mavrxmega2
                 depending on -m[no-]rodata-in-ram; and similar for
                 -mavrxmega4[_flmap].
            This means the feature can be used with older compiler or
            Binutils versions; all what's needed is an adjusted linker
            script and a custom device-specs file.
     * A new compiler option -m[no-]rodata-in-ram has been added. The
       default is to locate read-only data in program memory for devices
       that support it, e.g. for AVR64* and AVR128* devices as explained
       above, and for devices from the [131]avrxmega3 and [132]avrtiny
       families.
     * The new built-in macro __AVR_RODATA_IN_RAM__ is supported on all
       devices. It's defined to 0 or 1.
     * A new optimization tries to improve code generation for indirect
       memory accesses on [133]Reduced Tiny devices. It can be controlled
       by the new compiler option -mfuse-add=level where level may be 0, 1
       or 2.
     * On the Reduced Tiny devices, the meaning of register constraint "w"
       has been changed. It now constrains the registers R24…R31 as is the
       case for all the other devices.
     * Support for the following devices has been added in GCC 14.3:
          + AVR32SD20, AVR32SD28, AVR32SD32, AVR64SD28, AVR64SD32,
            AVR64SD48.
     * Support for the following devices has been added in GCC 14.4:
          + AVR32DA28S, AVR32DA32S, AVR32DA48S, AVR64DA28S, AVR64DA32S,
            AVR64DA48S AVR64DA64S, AVR128DA28S, AVR128DA32S, AVR128DA48S,
            AVR128DA64S, AVR32EB14, AVR32EB20, AVR32EB28, AVR32EB32,
            AVR16LA14, AVR16LA20, AVR16LA28, AVR16LA32, AVR32LA14,
            AVR32LA20, AVR32LA28, AVR32LA32.

  [134]IA-32/x86-64

     * New compiler option -m[no-]evex512 was added. The compiler switch
       enables/disables 512-bit vector. It will be default on if AVX512F
       is enabled.
     * Part of new feature support for Intel APX was added, including
       EGPR, NDD, PPX and PUSH2POP2. APX support is available via the
       -mapxf compiler switch.
     * For inline asm support with APX, by default the EGPR feature was
       disabled to prevent potential illegal instruction with EGPR occurs.
       To invoke egpr usage in inline asm, use new compiler option
       -mapx-inline-asm-use-gpr32 and user should ensure the instruction
       supports EGPR.
     * New ISA extension support for Intel AVX10.1 was added. AVX10.1
       intrinsics are available via the -mavx10.1-256 compiler switch with
       256-bit vector support. 512-bit vector support for AVX10.1
       intrinsics are available via the -mavx10.1-512 compiler switch.
       -mavx10.1 enables AVX10.1 intrinsics with 256-bit vector support in
       GCC 14.1 and GCC 14.2. Since GCC 14.3, it enables AVX10.1
       intrinsics with 512-bit vector support (and emits a warning due to
       this behavior change).
     * New ISA extension support for Intel AVX-VNNI-INT16 was added.
       AVX-VNNI-INT16 intrinsics are available via the -mavxvnniint16
       compiler switch.
     * New ISA extension support for Intel SHA512 was added. SHA512
       intrinsics are available via the -msha512 compiler switch.
     * New ISA extension support for Intel SM3 was added. SM3 intrinsics
       are available via the -msm3 compiler switch.
     * New ISA extension support for Intel SM4 was added. SM4 intrinsics
       are available via the -msm4 compiler switch.
     * New ISA extension support for Intel USER_MSR was added. USER_MSR
       intrinsics are available via the -muser_msr compiler switch.
     * GCC now supports the Intel CPU named Clearwater Forest through
       -march=clearwaterforest. Based on Sierra Forest, the switch in
       addition enables the AVX-VNNI-INT16, PREFETCHI, SHA512, SM3, SM4
       and USER_MSR ISA extensions. Since GCC 14.4, KL and WIDEKL are not
       enabled any longer.
     * GCC now supports the Intel CPU named Gracemont through
       -march=gracemont. Gracemont is based on Alder Lake. Since GCC 14.4,
       CLDEMOTE is not enabled any longer.
     * GCC now supports the Intel CPU named Arrow Lake through
       -march=arrowlake. Based on Alder Lake, the switch in addition
       enables the AVX-IFMA, AVX-NE-CONVERT, AVX-VNNI-INT8 and CMPccXADD
       ISA extensions. Since GCC 14.4, CLDEMOTE is not enabled any longer.
     * GCC now supports the Intel CPU named Arrow Lake S through
       -march=arrowlake-s. Based on Arrow Lake, the switch in addition
       enables the AVX-VNNI-INT16, SHA512, SM3 and SM4 ISA extensions.
       Since GCC 14.4, CLDEMOTE is not enabled any longer.
     * GCC now supports the Intel CPU named Lunar Lake through
       -march=lunarlake. Lunar Lake is based on Arrow Lake S. Since GCC
       14.4, CLDEMOTE is not enabled any longer.
     * GCC now supports the Intel CPU named Panther Lake through
       -march=pantherlake. Based on Arrow Lake S, the switch in addition
       further enables the PREFETCHI ISA extensions. Since GCC 14.4,
       CLDEMOTE, KL, PREFETCHI and WIDEKL are not enabled any longer.
     * Since GCC 14.4, CLDEMOTE is not enabled through the compiler
       switches -march=alderlake, -march=meteorlake and -march=raptorlake
       any longer.
     * Xeon Phi CPUs support (a.k.a. Knight Landing and Knight Mill) are
       marked as deprecated. GCC will emit a warning when using the
       -mavx5124fmaps, -mavx5124vnniw, -mavx512er, -mavx512pf,
       -mprefetchwt1, -march=knl, -march=knm, -mtune=knl or -mtune=knm
       compiler switches. Support will be removed in GCC 15.
     * [135]Hardware-assisted AddressSanitizer now works for the x86-64
       target with LAM_U57. -fsanitize=hwaddress will enable -mlam=u57 by
       default.
     * GCC now supports AMD CPUs based on the znver5 core via
       -march=znver5. In addition to the ISA extensions enabled on a
       znver4 core, this switch further enables the AVX512VP2INTERSECT,
       AVXVNNI, MOVDIR64B, MOVDIRI, and PREFETCHI ISA extensions.
     * The _Float16 and __bf16 type are supported independent of SSE2. W/o
       SSE2, these types are storage-only, compiler will issue an error
       when they're used in conversion, unary operation, binary operation,
       parameter passing or value return. Please use __SSE2__ to detect
       arithmetic support of these types instead of __FLT16_MAX__(or other
       similar Macros).

  [136]MCore

     * Bitfields are now signed by default per GCC policy. If you need
       bitfields to be unsigned, use -funsigned-bitfields.

  [137]LoongArch

     * Support for the following [138]-march parameters has been added:
          + la64v1.0
          + la64v1.1
          + la664
       It is now recommended to use -march=la64v1.0 as the only compiler
       option to describe the target ISA when building binaries for
       distribution. For more information on LoongArch ISA versions, see
       [139]Toolchain Conventions of the LoongArch™ Architecture.
     * Support for the following [140]-mtune parameters has been added:
          + generic
          + la664
     * New ISA Extension
          + LSX (Loongson SIMD Extension): Support 128-bit vector
            instructions and the intrinsics.
          + LASX (Loongson Advanced SIMD Extension): Support 256-bit
            vector instructions and the intrinsics.
          + FRECIPE: Support frecipe.{s/d} and frsqrte.{s/d} instructions
            and the intrinsics.
          + DIV32: Support div.w[u] and mod.w[u] instructions with inputs
            not sign-extended.
          + LAM_BH: Support am{swap/add}[_db].{b/h} instructions.
          + LAMCAS: Support amcas[_db].{b/h/w/d} instructions.
     * New Built-in Macros
          + __loongarch_arch: Target ISA preset as specified by -march=.
            For example, compiling with -march=la64v1.0, the value of
            __loongarch_arch is "la64v1.0".
          + __loongarch_tune: Processor model as specified by -mtune or
            its default value.
          + __loongarch_{simd,sx,asx}: These macros are not defined, or
            defined as 1.
          + __loongarch_simd_width: The maximum SIMD bit-width enabled by
            the compiler. (128 for lsx, and 256 for lasx).
          + __loongarch_frecipe: It's defined to 1 or undefined.
          + __loongarch_div32: It's defined to 1 or undefined.
          + __loongarch_lam_bh: It's defined to 1 or undefined.
          + __loongarch_lamcas: It's defined to 1 or undefined.
          + __loongarch_ld_seq_sa: It's defined to 1 or undefined.
          + __loongarch_version_major: The minimally required LoongArch
            ISA version (major) to run the compiled program, defined to 1
            or undefined (iff no such version is known to the compiler).
          + __loongarch_version_minor: The minimally required LoongArch
            ISA version (minor) to run the compiled program, defined to 0
            1 or undefined (iff __loongarch_version_major is undefined).
          + __FLOAT128_TYPE: It's defined to 1.
     * New Intrinsics
          + [141]__builtin_thread_pointer
          + [142]__lsx_*
          + [143]__lasx_*
          + [144]__frecipe_{s/d} and __frsqrte_{s/d}
     * New Compiler Option
          + [145]-m[no-]lsx
          + [146]-m[no-]lasx
          + [147]-m[no-]frecipe
          + [148]-m[no-]div32
          + [149]-m[no-]lam-bh
          + [150]-m[no-]lamcas
          + [151]-m[no-]ld-seq-sa
          + [152]-mrecip=
          + [153]-m[no-]recip
          + [154]-mexplicit-relocs={none,always,auto}
          + [155]-m[no-]relax
          + [156]-m[no-]pass-mrelax-to-as
          + [157]-mtls-dialect={trad,desc}
     * Support for Ada and D.
     * Support for libffi.
     * Enable -free by default at -O2 or higher.
     * Enable -fsched-pressure by default at -O1 or higher.
     * Support the extreme code model using macro instructions (under
       -mno-explicit-relocs).
     * Support call36.
     * Optimizing built-in functions for memory-model-aware atomic
       operations using hierarchical dbar instructions.
     * TLS descriptors support. It is not enabled by default, and can be
       enabled with [158]-mtls-dialect=desc. The default behavior can be
       configured with --with-tls=[trad|desc].

  [159]RISC-V

     * The SLP and loop vectorizer are now enabled for RISC-V when the
       vector extension is enabled, thanks to Ju-Zhe Zhong from
       [160]RiVAI, Pan Li from Intel, and Robin Dapp from [161]Ventana
       Micro for contributing most of the implementation.
     * The -mrvv-max-lmul= option has been introduced for performance
       tuning of the loop vectorizer. The default value is
       -mrvv-max-lmul=m1, which limits the maximum LMUL to 1. The
       -mrvv-max-lmul=dynamic setting can dynamically select the maximum
       LMUL value based on register pressure.
     * Atomic code generation has been improved and is now in conformance
       with the latest psABI specification, thanks to Patrick O'Neill from
       [162]Rivos.
     * Support for the vector intrinsics as specified in [163]version 1.0
       of the RISC-V vector intrinsic specification.
     * Support for the experimental vector crypto intrinsics as specified
       in [164]RISC-V vector intrinsic specification, thanks to Feng Wang
       et al. from [165]ESWIN Computing
     * Support for the T-head vector intrinsics.
     * Support for the scalar bitmanip and scalar crypto intrinsics,
       thanks to Liao Shihua from [166]PLCT.
     * Support for the large code model via option -mcmodel=large, thanks
       to Kuan-Lin Chen from [167]Andes Technology.
     * Support for the standard vector calling convention variant, thanks
       to Lehua Ding from [168]RiVAI.
     * Supports the target attribute, which allows users to compile a
       function with specific extensions.
     * The -march= option no longer requires the architecture string to be
       in canonical order, with only a few constraints remaining: the
       architecture string must start with rv[32|64][i|g|e], and must use
       an underscore as the separator after a multi-letter extension.
     * -march=help has been introduced to list all supported extensions.
     * Added experimental support for the -mrvv-vector-bits=zvl option and
       the riscv_rvv_vector_bits attribute, which specify a fixed length
       for scalable vector types. This option is optimized for specific
       vector core implementations; however, the code generated with this
       option is NOT portable between the core with different VLEN, thanks
       to Pan Li from Intel.
     * Support for TLS descriptors has been introduced. It can be enabled
       by the -mtls-dialect=desc option. The default behavior can be
       configured with --with-tls=[trad|desc]. This feature requires glibc
       2.40. Thanks to Tatsuyuki Ishi from [169]Blue Whale Systems.
     * Support for the following standard extensions has been added:
          + Vector crypto extensions:
               o Zvbb
               o Zvkb
               o Zvbc
               o Zvkg
               o Zvkned
               o Zvkhna
               o Zvkhnb
               o Zvksed
               o Zvksh
               o Zvkn
               o Zvknc
               o Zvkng
               o Zvks
               o Zvksc
               o Zvksg
               o Zvkt
          + Code size reduction extensions:
               o Zca
               o Zcb
               o Zce
               o Zcf
               o Zcd
               o Zcmp
               o Zcmt
          + Zicond
          + Zfa
          + Ztso
          + Zvfbfmin
          + Zvfhmin
          + Zvfh
          + Za64rs
          + Za128rs
          + Ziccif
          + Ziccrse
          + Ziccamoa
          + Zicclsm
          + Zic64b
          + Smaia
          + Smepmp
          + Smstateen
          + Ssaia
          + Sscofpmf
          + Ssstateen
          + Sstc
          + Svinval
          + Svnapot
          + Svpbmt
     * Support for the following vendor extensions has been added:
          + T-Head:
               o XTheadVector
          + CORE-V:
               o XCVmac
               o XCValu
               o XCVelw
               o XCVsimd
               o XCVbi
          + Ventana Micro:
               o XVentanaCondops
     * The following new CPUs are supported through the -mcpu option (GCC
       identifiers in parentheses).
          + SiFive's X280 (sifive-x280).
          + SiFive's P450 (sifive-p450).
          + SiFive's P670 (sifive-p670).
     * The following new CPUs are supported through the -mtune option (GCC
       identifiers in parentheses).
          + Generic out-of-order core (generic-ooo).
          + SiFive's P400 series (sifive-p400-series).
          + SiFive's P600 series (sifive-p600-series).
          + XiangShan's Nanhu microarchitecture (xiangshan-nanhu).

  [170]SPARC

     * The implementation of calling conventions for small structures
       containing arrays of floating-point components has been changed in
       64-bit mode for the Solaris port to match the implementation of the
       vendor compiler (and the ABI). As a result, the code generated will
       not be binary compatible with earlier releases in these cases.

Documentation improvements

     * GCC's ability to provide clickable hyperlinks to the documentation
       has been extended, so that whenever GCC refers to a command-line
       option in quotes in a diagnostic message, the option is a clickable
       hyperlink (assuming a suitably capable terminal).

[171]Improvements to Static Analyzer

     * New warnings:
          + [172]-Wanalyzer-infinite-loop warns about paths through the
            code which appear to lead to an infinite loop.
          + [173]-Wanalyzer-overlapping-buffers warns for paths through
            the code in which overlapping buffers are passed to an API for
            which the behavior on such buffers is undefined.
          + [174]-Wanalyzer-undefined-behavior-strtok warns for paths
            through the code in which a call is made to strtok with
            undefined behavior.
     * Previously, the analyzer's "taint" tracking to be explicitly
       enabled via [175]-fanalyzer-checker=taint (along with
       [176]-fanalyzer). This is now enabled by default when
       [177]-fanalyzer is selected, thus also enabling the 6 taint-based
       warnings:
          + [178]-Wanalyzer-tainted-allocation-size
          + [179]-Wanalyzer-tainted-array-index
          + [180]-Wanalyzer-tainted-assertion
          + [181]-Wanalyzer-tainted-divisor
          + [182]-Wanalyzer-tainted-offset
          + [183]-Wanalyzer-tainted-size
     * The analyzer will now simulate API calls that expect
       null-terminated string arguments, and will warn about code paths in
       which such a call is made with a buffer that isn't properly
       terminated, either due to a read of an uninitialized byte or an
       out-of-range accesses seen before any zero byte is seen. This
       applies to functions that use the new
       [184]null_terminated_string_arg(PARAM_IDX) attribute, functions
       that use the [185]format attribute, and to the library functions
       error (parameter 3), error_at_line (parameter 5), putenv, strchr
       (parameter 1), and strcpy (parameter 2).
     * The analyzer now makes use of the function attribute
       [186]alloc_size allowing [187]-fanalyzer to emit
       [188]-Wanalyzer-allocation-size, [189]-Wanalyzer-out-of-bounds, and
       [190]-Wanalyzer-tainted-allocation-size on execution paths
       involving allocations using such functions.
     * The analyzer's knowledge about the behavior of the standard library
       has been extended to cover fopen, strcat, strncpy, and strstr. The
       analyzer will also more precisely model the behavior of memcpy,
       memmove, strcpy, strdup, strlen, and of various atomic built-in
       functions.
     * The warning [191]-Wanalyzer-out-of-bounds has been extended so
       that, where possible, it will emit a text-based diagram visualizing
       the spatial relationship between
         1. the memory region that the analyzer predicts would be
            accessed, versus
         2. the range of memory that is valid to access
       whether they overlap, are touching, are close or far apart; which
       one is before or after in memory, the relative sizes involved, the
       direction of the access (read vs write), and, in some cases, the
       values of data involved.
       Such "text art" diagrams can be controlled (or suppressed) via a
       new [192]-fdiagnostics-text-art-charset= option.
       For example, given the out-of-bounds write in strcat in:
void test (void)
{
   char buf[10];
   strcpy (buf, "hello");
   strcat (buf, " world!");
}

       it emits:
                                 ┌────┬────┬────┬────┬────┐┌─────┬─────┬─────┐
                                 │[0] │[1] │[2] │[3] │[4] ││ [5] │ [6] │ [7] │
                                 ├────┼────┼────┼────┼────┤├─────┼─────┼─────┤
                                 │' ' │'w' │'o' │'r' │'l' ││ 'd' │ '!' │ NUL │
                                 ├────┴────┴────┴────┴────┴┴─────┴─────┴─────┤
                                 │     string literal (type: 'char[8]')      │
                                 └───────────────────────────────────────────┘
                                   │    │    │    │    │      │     │     │
                                   │    │    │    │    │      │     │     │
                                   v    v    v    v    v      v     v     v
      ┌─────┬────────────────────┬────┬──────────────┬────┐┌─────────────────┐
      │ [0] │        ...         │[5] │     ...      │[9] ││                 │
      ├─────┼────┬────┬────┬────┬┼────┼──────────────┴────┘│                 │
      │ 'h' │'e' │'l' │'l' │'o' ││NUL │                    │after valid range│
      ├─────┴────┴────┴────┴────┴┴────┴───────────────────┐│                 │
      │             'buf' (type: 'char[10]')              ││                 │
      └───────────────────────────────────────────────────┘└─────────────────┘
      ├─────────────────────────┬─────────────────────────┤├────────┬────────┤
                                │                                   │
                      ╭─────────┴────────╮                ╭─────────┴─────────
╮
                      │capacity: 10 bytes│                │overflow of 3 bytes
│
                      ╰──────────────────╯                ╰───────────────────
╯

       showing that the overflow occurs partway through the second string
       fragment.
     * The analyzer will now attempt to track execution paths involving
       computed gotos, whereas previously it gave up on such paths.

[193]Improvements to SARIF support

     * The SARIF output from [194]-fdiagnostics-format= now adds
       indentation and newlines to reflect the logical JSON structure of
       the data. The previous compact behavior can be restored via the new
       option [195]-fno-diagnostics-json-formatting. This also applies to
       the older output format named "json".
     * If profiling information about the compiler itself is requested via
       [196]-ftime-report, and a SARIF output format is requested via
       [197]-fdiagnostics-format=, then the timing and memory usage data
       is now written in JSON form into the SARIF output, rather than as
       plain text to stderr.

[198]Improvements for plugin authors

     * GCC diagnostics have been able to have execution paths associated
       with them since GCC 10, but previously these were required to be
       single-threaded. As of GCC 14, these execution paths can have
       multiple named threads associated with them, with each event being
       associated with one of the threads. No existing GCC diagnostics
       take advantage of this, but GCC plugins may find this useful for
       their own diagnostics; an [199]example is provided in the
       testsuite.
     * GCC's diagnostics can now optionally add per-diagnostic property
       bags to the SARIF output, allowing plugins to capture custom data
       as needed with their diagnostics.

[200]GCC 14.1

   This is the [201]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 14.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

[202]GCC 14.2

   This is the [203]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 14.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

[204]GCC 14.3

   This is the [205]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 14.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).


    For questions related to the use of GCC, please consult these web
    pages and the [206]GCC manuals. If that fails, the
    [207]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [208]gcc@gcc.gnu.org. All of [209]our lists have public
    archives.

   Copyright (C) [210]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [211]maintained by the GCC team. Last modified
   2026-04-13.

References

   1. https://gcc.gnu.org/gcc-14/porting_to.html
   2. https://gcc.gnu.org/onlinedocs/index.html#current
   3. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Zero-Length.html
   4. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Warning-Options.html#index-Wflex-array-member-not-at-end
   5. https://gcc.gnu.org/gcc-14/porting_to.html#warnings-as-errors
   6. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Instrumentation-Options.html
   7. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html
   8. https://gcc.gnu.org/gcc-14/changes.html#general
   9. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/C-Dialect-Options.html#index-foffload-options
  10. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Instrumentation-Options.html#index-fhardened
  11. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Instrumentation-Options.html#index-fharden-control-flow-redundancy
  12. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Common-Type-Attributes.html#index-hardbool-type-attribute
  13. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Common-Type-Attributes.html#index-strub-type-attribute
  14. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Optimize-Options.html#index-finline-stringops
  15. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Code-Gen-Options.html#index-ftrampoline-impl
  16. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Common-Function-Attributes.html#index-null_005fterminated_005fstring_005farg-function-attribute
  17. https://gcc.gnu.org/gcc-14/changes.html#languages
  18. https://gcc.gnu.org/projects/gomp/
  19. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/libgomp/
  20. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/libgomp/Offload-Target-Specifics.html
  21. https://github.com/numactl/numactl
  22. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/libgomp/Memory-allocation.html
  23. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gfortran/Fortran-Dialect-Options.html#index-fopenmp-allocators
  24. https://gcc.gnu.org/wiki/OpenACC
  25. https://gcc.gnu.org/gcc-14/changes.html#ada
  26. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gnat_rm/Aspect-Local_005fRestrictions.html
  27. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gnat_rm/Pragma-User_005fAspect_005fDefinition.html
  28. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gnat_rm/Aspect-User_005fAspect.html
  29. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gnat_rm/Aspect-Always_005fTerminates.html
  30. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gnat_rm/Aspect-Ghost_005fPredicate.html
  31. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gnat_rm/Aspect-Exceptional_005fCases.html
  32. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gnat_rm/Aspect-Side_005fEffects.html
  33. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Instrumentation-Options.html#index-fharden-compares
  34. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gnat_rm/Security-Hardening-Features.html
  35. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gnat_ugn/Style-Checking.html#index--gnatyz-_0028gcc_0029
  36. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gnat_ugn/Alphabetical-List-of-All-Switches.html#index--gnateH-_0028gcc_0029
  37. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gnat_rm/Pragma-Storage_005fModel.html
  38. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gnat_rm/String-interpolation.html
  39. https://gcc.gnu.org/onlinedocs/gnat_rm/Fixed-lower-bounds-for-array-types-and-subtypes.html
  40. https://github.com/AdaCore/ada-spark-rfcs/blob/master/features/rfc-fixed-lower-bound.rst
  41. https://gcc.gnu.org/gcc-14/changes.html#c-family
  42. https://gcc.gnu.org/gcc-14/changes.html#c
  43. https://gcc.gnu.org/gcc-14/changes.html#cxx
  44. https://wg21.link/P1854R4
  45. https://gcc.gnu.org/PR110341
  46. https://wg21.link/P2752R3
  47. https://gcc.gnu.org/PR110346
  48. https://wg21.link/P2361R6
  49. https://gcc.gnu.org/PR110342
  50. https://wg21.link/P2738R1
  51. https://gcc.gnu.org/PR110344
  52. https://wg21.link/P2741R3
  53. https://gcc.gnu.org/PR110348
  54. https://wg21.link/P2169R4
  55. https://gcc.gnu.org/PR110349
  56. https://wg21.link/P2864R2
  57. https://wg21.link/P2748R5
  58. https://gcc.gnu.org/PR114455
  59. https://wg21.link/P2809R3
  60. https://gcc.gnu.org/PR114462
  61. https://wg21.link/P0847R7
  62. https://gcc.gnu.org/PR102609
  63. https://wg21.link/P2280R4
  64. https://gcc.gnu.org/PR106650
  65. https://wg21.link/P2564R3
  66. https://gcc.gnu.org/PR107687
  67. https://wg21.link/P2582R1
  68. https://gcc.gnu.org/PR106653
  69. https://wg21.link/cwg532
  70. https://wg21.link/cwg976
  71. https://wg21.link/cwg2262
  72. https://wg21.link/cwg2359
  73. https://wg21.link/cwg2386
  74. https://wg21.link/cwg2406
  75. https://wg21.link/cwg2543
  76. https://wg21.link/cwg2586
  77. https://wg21.link/cwg2735
  78. https://wg21.link/cwg2799
  79. https://gcc.gnu.org/PR100157
  80. https://cplusplus.github.io/CWG/issues/2256.html
  81. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wdangling-reference
  82. https://gcc.gnu.org/git/?p=gcc.git;a=blob;f=gcc/testsuite/g++.dg/opt/nrv23.C;h=9e1253cd830a84ad4de5ff3076a07c543afe344f;hb=7e0b65b239c3a0d68ce94896b236b03de666ffd6
  83. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Warning-Options.html#index-Wnrvo
  84. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=4d935f52b0d5c00fcc154461b87415ebd8791a94
  85. https://gcc.gnu.org/PR110164
  86. https://gcc.gnu.org/PR89442
  87. https://gcc.gnu.org/PR110064
  88. https://gcc.gnu.org/PR70331
  89. https://gcc.gnu.org/PR96630
  90. https://gcc.gnu.org/PR98675
  91. https://gcc.gnu.org/PR71954
  92. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=85ad41a494e31311f8a6b2dbe930a128c5e85840
  93. https://gcc.gnu.org/PR111069
  94. https://gcc.gnu.org/PR52953
  95. https://gcc.gnu.org/PR91483
  96. https://gcc.gnu.org/PR18474
  97. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/C_002b_002b-Attributes.html#index-cold-type-attribute
  98. https://gcc.gnu.org/PR79620
  99. https://gcc.gnu.org/PR79378
 100. https://gcc.gnu.org/PR83167
 101. https://gcc.gnu.org/PR96917
 102. https://wg21.link/P1689R5
 103. https://gcc.gnu.org/gcc-14/changes.html#libstdcxx
 104. https://gcc.gnu.org/gcc-14/changes.html#d
 105. https://dlang.org/changelog/2.108.1.html
 106. https://gcc.gnu.org/gcc-14/changes.html#fortran
 107. https://gcc.gnu.org/gcc-14/changes.html#modula2
 108. https://gcc.gnu.org/gcc-14/changes.html#rust
 109. https://gcc.gnu.org/gcc-14/changes.html#jit
 110. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/jit/topics/types.html#c.gcc_jit_type_get_restrict
 111. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/jit/topics/compatibility.html#libgccjit-abi-25
 112. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/jit/topics/compatibility.html#libgccjit-abi-26
 113. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/jit/topics/expressions.html#c.gcc_jit_context_new_sizeof
 114. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/jit/topics/compatibility.html#libgccjit-abi-27
 115. https://gcc.gnu.org/gcc-14/changes.html#targets
 116. https://gcc.gnu.org/gcc-14/changes.html#aarch64
 117. https://github.com/ARM-software/acle/blob/main/main/acle.md#sme-language-extensions-and-intrinsics
 118. https://github.com/ARM-software/acle/blob/main/main/acle.md#function-multi-versioning
 119. https://github.com/ARM-software/acle/blob/main/main/acle.md#memory-prefetch-intrinsics
 120. https://github.com/ARM-software/acle/blob/main/main/acle.md#special-register-intrinsics
 121. https://github.com/ARM-software/acle/blob/main/main/acle.md#neon-sve-bridge
 122. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/AArch64-Options.html
 123. https://gcc.gnu.org/gcc-14/changes.html#amdgcn
 124. https://gcc.gnu.org/install/specific.html#amdgcn-x-amdhsa
 125. https://gcc.gnu.org/install/specific.html#amdgcn-x-amdhsa
 126. https://gcc.gnu.org/gcc-14/changes.html#arm
 127. https://gcc.gnu.org/gcc-14/changes.html#avr
 128. https://github.com/avrdudes/avr-libc/issues/931
 129. https://sourceware.org/PR31124
 130. https://gcc.gnu.org/wiki/avr-gcc#spec-files
 131. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/AVR-Options.html#avrxmega3
 132. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/AVR-Options.html#avrtiny
 133. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/AVR-Options.html#avrtiny
 134. https://gcc.gnu.org/gcc-14/changes.html#x86
 135. https://gcc.gnu.org/gcc-11/changes.html
 136. https://gcc.gnu.org/gcc-14/changes.html#mcore
 137. https://gcc.gnu.org/gcc-14/changes.html#loongarch
 138. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Options.html#index-march-7
 139. https://github.com/loongson/la-toolchain-conventions/
 140. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Options.html#index-mtune-8
 141. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Base-Built-in-Functions.html
 142. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-SX-Vector-Intrinsics.html
 143. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-ASX-Vector-Intrinsics.html
 144. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Base-Built-in-Functions.html
 145. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Options.html#index-ml_005ba_005dsx
 146. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Options.html#index-ml_005ba_005dsx
 147. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Options.html#index-mfrecipe
 148. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Options.html#index-mdiv32
 149. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Options.html#index-mlam-bh
 150. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Options.html#index-mlamcas
 151. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Options.html#index-mld-seq-sa
 152. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Options.html#index-mrecip_003dopt
 153. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Options.html#index-mrecip
 154. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Options.html#index-mexplicit-relocs-1
 155. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Options.html#index-mrelax-2
 156. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Options.html#index-mpass-mrelax-to-as
 157. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Options.html#index-mtls-dialect-1
 158. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/LoongArch-Options.html#index-mtls-dialect-1
 159. https://gcc.gnu.org/gcc-14/changes.html#riscv
 160. https://rivai-ic.com.cn/
 161. https://www.ventanamicro.com/
 162. https://www.rivosinc.com/
 163. https://github.com/riscv-non-isa/rvv-intrinsic-doc/tree/v1.0.x
 164. https://github.com/riscv-non-isa/rvv-intrinsic-doc/pull/234
 165. https://eswincomputing.com/
 166. https://plctlab.org/
 167. https://www.andestech.com/
 168. https://rivai-ic.com.cn/
 169. https://bluewhale.systems/
 170. https://gcc.gnu.org/gcc-14/changes.html#sparc
 171. https://gcc.gnu.org/gcc-14/changes.html#analyzer
 172. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-infinite-loop
 173. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-overlapping-buffers
 174. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-undefined-behavior-strtok
 175. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-fanalyzer-checker
 176. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-fanalyzer
 177. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-fanalyzer
 178. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-allocation-size
 179. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-array-index
 180. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-assertion
 181. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-divisor
 182. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-offset
 183. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-size
 184. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Common-Function-Attributes.html#index-null_005fterminated_005fstring_005farg-function-attribute
 185. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Common-Function-Attributes.html#index-format-function-attribute
 186. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Common-Function-Attributes.html#index-alloc_005fsize-function-attribute
 187. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-fanalyzer
 188. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-allocation-size
 189. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-out-of-bounds
 190. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-allocation-size
 191. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-out-of-bounds
 192. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-text-art-charset
 193. https://gcc.gnu.org/gcc-14/changes.html#sarif
 194. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-format
 195. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fno-diagnostics-json-formatting
 196. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Developer-Options.html#index-ftime-report
 197. https://gcc.gnu.org/onlinedocs/gcc-14.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-format
 198. https://gcc.gnu.org/gcc-14/changes.html#plugins
 199. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=3a1e9f3ed7aa49adad02190ace0614e0b37fc089
 200. https://gcc.gnu.org/gcc-14/changes.html#14.1
 201. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=14.0
 202. https://gcc.gnu.org/gcc-14/changes.html#14.2
 203. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=14.2
 204. https://gcc.gnu.org/gcc-14/changes.html#14.3
 205. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=14.3
 206. https://gcc.gnu.org/onlinedocs/
 207. mailto:gcc-help@gcc.gnu.org
 208. mailto:gcc@gcc.gnu.org
 209. https://gcc.gnu.org/lists.html
 210. https://www.fsf.org/
 211. https://gcc.gnu.org/about.html
======================================================================
http://gcc.gnu.org/gcc-13/index.html
                             GCC 13 Release Series

   June 5, 2025

   The GCC developers are pleased to announce the release of GCC 13.4.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 13.3 relative to previous releases of GCC.

Release History

   GCC 13.4
          June 5, 2025 ([1]changes, [2]documentation)

   GCC 13.3
          May 21, 2024 ([3]changes, [4]documentation)

   GCC 13.2
          July 27, 2023 ([5]changes, [6]documentation)

   GCC 13.1
          April 26, 2023 ([7]changes, [8]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [9]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [10]GCC
   project web site or contact the [11]GCC development mailing list.

   To obtain GCC please use [12]our mirror sites or [13]our version
   control system.


    For questions related to the use of GCC, please consult these web
    pages and the [14]GCC manuals. If that fails, the
    [15]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [16]gcc@gcc.gnu.org. All of [17]our lists have public
    archives.

   Copyright (C) [18]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [19]maintained by the GCC team. Last modified
   2025-06-05.

References

   1. https://gcc.gnu.org/gcc-13/changes.html
   2. https://gcc.gnu.org/onlinedocs/13.4.0/
   3. https://gcc.gnu.org/gcc-13/changes.html
   4. https://gcc.gnu.org/onlinedocs/13.3.0/
   5. https://gcc.gnu.org/gcc-13/changes.html
   6. https://gcc.gnu.org/onlinedocs/13.2.0/
   7. https://gcc.gnu.org/gcc-13/changes.html
   8. https://gcc.gnu.org/onlinedocs/13.1.0/
   9. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Contributors.html
  10. https://gcc.gnu.org/index.html
  11. mailto:gcc@gcc.gnu.org
  12. https://gcc.gnu.org/mirrors.html
  13. https://gcc.gnu.org/git.html
  14. https://gcc.gnu.org/onlinedocs/
  15. mailto:gcc-help@gcc.gnu.org
  16. mailto:gcc@gcc.gnu.org
  17. https://gcc.gnu.org/lists.html
  18. https://www.fsf.org/
  19. https://gcc.gnu.org/about.html
======================================================================
http://gcc.gnu.org/gcc-13/changes.html
                             GCC 13 Release Series
                        Changes, New Features, and Fixes

   This page is a "brief" summary of some of the huge number of
   improvements in GCC 13. You may also want to check out our [1]Porting
   to GCC 13 page and the [2]full GCC documentation.

Caveats

     * OpenMP offloading to Intel MIC has been removed.
     * The support for the cr16-elf, tilegx*-linux, tilepro*-linux,
       hppa[12]*-*-hpux10*, hppa[12]*-*-hpux11* and m32c-rtems
       configurations has been removed.
     * Support for Solaris 11.3 (*-*-solaris2.11.3) has been declared
       obsolete. The next release of GCC will have corresponding code
       permanently removed. Details can be found in the [3]announcement.
     * Support for emitting the STABS debugging format (including the
       -gstabs and -gxcoff options) has been removed. (This means the dbx
       debugger is no longer supported, either.)
     * Legacy debug info compression option -gz=zlib-gnu was removed and
       the option is ignored right now.
     * [4]-Warray-bounds=2 will no longer issue warnings for out of bounds
       accesses to trailing struct members of one-element array type
       anymore. Instead it diagnoses accesses to trailing arrays according
       to [5]-fstrict-flex-arrays.
     * [6]-fanalyzer is still only suitable for analyzing C code. In
       particular, using it on C++ is unlikely to give meaningful output.
     * In the arm port, support for the iWMMXt extensions, enabled through
       -mcpu=iwmmxt, has been deprecated and will be removed in a future
       release. This includes support for the [7]iWMMXt built-in
       functions.
     * For C++, construction of the global iostream objects std::cout,
       std::cin, etc. is now done inside the standard library, instead of
       in every source file that includes the <iostream> header. This
       change improves the start-up performance of C++ programs, but it
       means that code compiled with GCC 13.1 will crash if the correct
       version of libstdc++.so is not used at run time. See the
       [8]documentation about using the right libstdc++.so at run time.
       Future GCC releases will mitigate the problem so that the program
       cannot be run at all with an older libstdc++.so.

[9]General Improvements

     * [10]OpenMP
          + Reverse offload is now supported with AMD GCN and nvptx
            devices. Additionally, the requires handling has been improved
            and all clauses are now accepted. If a requirement cannot be
            fulfilled for an accessible device, this device is excluded
            from the list of available devices. This may imply that the
            only device left is the host (the initial device). In
            particular, unified_address and unified_shared_memory are
            unsupported by all non-host devices.
          + OpenMP 5.0: Fortran now supports some non-rectangular loop
            nests; for C/C++, the support was added in GCC 11.
          + The following OpenMP 5.1 features have been added: the
            omp_all_memory reserved locator, the inoutset modifier to the
            depend clause, the nowait clause for the taskwait directive
            and the omp_target_is_accessible, omp_target_memcpy_async,
            omp_target_memcpy_rect_async and omp_get_mapped_ptr API
            routines. The assume and assumes directives, the begin/end
            declare target syntax in C/C++ and device-specific ICV
            settings with environment variables are now supported.
          + Initial support for OpenMP 5.2 features has been added:
            firstprivate and allocate clauses on the scope construct; the
            OpenMP 5.2 syntax of the linear clause; new enum/constants
            omp_initial_device and omp_invalid_device; and optionally
            omitting the map-type in target enter/exit data. The enter
            clause (as alias for to) has been added to the declare target
            directive. Also added have been the omp_in_explicit_task
            routine and the doacross clause as alias for depend with
            source/sink modifier.
          + The _ALL suffix to the device-scope environment variables
            added in Technical Report (TR11) is already handled.
          + For user defined allocators requesting high bandwidth or large
            capacity memspaces or interleaved partitioning, the
            [11]memkind library is used, if available at run time.
     * AddressSanitizer defaults to detect_stack_use_after_return=1 on
       GNU/Linux targets. For compatibility, it can be disabled with env
       ASAN_OPTIONS=detect_stack_use_after_return=0.
     * New debug info compression option value -gz=zstd has been added.
     * Link-time optimization improvements:
          + LTO supports the newly added jobserver of GNU make jobserver
            that uses named pipes (--jobserver-style=fifo) by default.
          + If make's jobserver is active, parallel LTO WPA streaming
            communicates with it and thus avoids system overcommitting.
     * -Ofast, -ffast-math and -funsafe-math-optimizations will no longer
       add startup code to alter the floating-point environment when
       producing a shared object with -shared.
     * GCC can now emit its diagnostics using [12]SARIF. This is a
       JSON-based format suited for capturing the results of static
       analysis tools (like GCC's [13]-fanalyzer), but it can also be used
       to capture other GCC warnings and errors in a machine-readable
       format. Specifically, the [14]-fdiagnostics-format= option has been
       extended to support these new values:
          + -fdiagnostics-format=sarif-stderr
          + -fdiagnostics-format=sarif-file
          + -fdiagnostics-format=json-stderr, a synonym for the existing
            -fdiagnostics-format=json
          + -fdiagnostics-format=json-file
       where the json-prefixed variants refer to GCC's own JSON diagnostic
       format.
     * Support for profiling and test coverage in freestanding
       environments has been added, see also [15]Profiling and Test
       Coverage in Freestanding Environments.
     * New options -fharden-compares and -fharden-conditional-branches to
       verify compares and conditional branches, to detect some
       power-deprivation hardware attacks, using reversed conditions.

[16]New Languages and Language specific improvements

  [17]Ada

     * Traceback support added in RTEMS for the PPC ELF and ARM
       architectures.
     * Support for versions older than VxWorks 7 has been removed.
     * General improvements to the contracts in the standard libraries.
     * Addition of GNAT.Binary_Search.
     * Further additions and fixes for the Ada 2022 specification.
     * The Pragma SPARK_Mode=>Auto is now accepted. Contract analysis has
       been further improved.
     * Documentation improvements.

  [18]C family

     * New warnings:
          + [19]-Wxor-used-as-pow warns about uses of ^, the exclusive or
            operator, where it appears the user meant exponentiation
            ([20]PR90885)
     * Three new function attributes for documenting int arguments that
       are file descriptors:
          + [21]__attribute__((fd_arg(N)))
          + [22]__attribute__((fd_arg_read(N)))
          + [23]__attribute__((fd_arg_write(N)))
       These are used by [24]-fanalyzer to detect misuses of file
       descriptors.
     * A new statement attribute for C++23 [25]P1774R8 Portable
       assumptions support also in C or older C++:
       [26]__attribute__((assume(EXPR)));
     * GCC can now control when to treat the trailing array of a structure
       as a flexible array member for the purpose of accessing the
       elements of such an array. By default, all trailing arrays in
       aggregates are treated as flexible array members. Use the new
       command-line option [27]-fstrict-flex-arrays to control which array
       members are treated as flexible arrays.

  [28]C

     * Several C23 features have been implemented:
          + [29]N3042, Introduce the nullptr constant
          + [30]N2963, Enhanced Enumerations (fixed underlying types)
          + [31]N2975, Relax requirements for variadic parameter lists
          + [32]N3007, Type inference for object definitions (auto)
          + [33]N3018, The constexpr specifier for object definitions
          + [34]N3038, Introduce storage-class specifiers for compound
            literals
          + typeof (previously supported as an extension) and
            typeof_unqual
          + New keywords alignas, alignof, bool, false, static_assert,
            thread_local, true
          + [35]N2764, The noreturn attribute
          + Support for empty initializer braces
          + __STDC_VERSION_*_H__ header version macros
          + Removal of ATOMIC_VAR_INIT
          + unreachable macro in <stddef.h>
          + Removal of trigraphs
          + Removal of unprototyped functions
          + printf and scanf format checking with [36]-Wformat for %wN and
            %wfN format length modifiers
          + [37]N2836, Identifier Syntax using Unicode Standard Annex 31
     * In addition to those C23 features, existing features adopted in C23
       have been adjusted to follow C23 requirements and are not diagnosed
       with -std=c2x -Wpedantic.
     * New warnings:
          + [38]-Wenum-int-mismatch warns about mismatches between an
            enumerated type and an integer type ([39]PR105131)

  [40]C++

     * Excess precision support (which has been available in C since GCC
       4.5) has been implemented for C++ as well. It is enabled by default
       in strict standard modes like -std=c++17, where it defaults to
       -fexcess-precision=standard, while in GNU standard modes like
       -std=gnu++20 it defaults to -fexcess-precision=fast. The option
       mainly affects IA-32/x86-64 using x87 math and in some cases on
       Motorola 68000, where float and double expressions are evaluated in
       long double precision and S/390, System z, IBM z Systems where
       float expressions are evaluated in double precision. Also, on
       several architectures where std::float16_t or std::bfloat16_t types
       are supported those are evaluated in float precision.
       -fexcess-precision=fast restores previous behavior.
     * Several C++23 features have been implemented:
          + [41]P2324R1, Labels at the end of compound statements
            ([42]PR103539)
          + [43]P2255R2, A type trait to detect reference binding to
            temporary ([44]PR104477)
          + [45]P2327R1, De-deprecating volatile compound operations
          + [46]P2437R1, Support for #warning ([47]PR106646)
          + [48]P2290R3, Delimited escape sequences ([49]PR106645)
          + [50]P2071R2, Named universal character escapes ([51]PR106648)
          + [52]P2513R3, char8_t Compatibility and Portability Fix
            ([53]PR106656)
          + [54]P1169R4, static operator() ([55]PR106651)
          + [56]P2266R3, Simpler implicit move ([57]PR101165)
          + [58]P2468R2, The Equality Operator You Are Looking For
            ([59]PR106644)
          + [60]P2362R3, Remove non-encodable wide character literals and
            multicharacter wide character literals ([61]PR106647)
          + [62]P2448R2, Relaxing some constexpr restrictions
            ([63]PR106649)
          + [64]P1467R9, Extended floating-point types and standard names
            ([65]PR106652)
          + [66]P1774R8, Portable assumptions ([67]PR106654)
          + [68]P2295R6, Support for UTF-8 as a portable source file
            encoding ([69]PR106655)
          + [70]P2589R1, static operator[] ([71]PR107684)
     * New warnings:
          + [72]-Wself-move warns when a value is moved to itself with
            std::move ([73]PR81159)
          + [74]-Wdangling-reference warns when a reference is bound to a
            temporary whose lifetime has ended ([75]PR106393)
     * The [76]-Wpessimizing-move and [77]-Wredundant-move warnings have
       been extended to warn in more contexts.
     * The [78]-nostdlib++ option has been added, to enable linking with
       g++ without implicitly linking in the C++ standard library.

    [79]Runtime Library (libstdc++)

     * Improved experimental support for C++20, including:
          + <format> header and std::format.
          + std::chrono::utc_clock and other clocks, time zones, and
            std::format support in the <chrono> header.
     * Improved experimental support for C++23, including:
          + Additions to the <ranges> header: views::zip,
            views::zip_transform, views::adjacent,
            views::adjacent_transform views::pairwise, views::slide,
            views::chunk, views::chunk_by, views::repeat, views::chunk_by,
            views::cartesian_product, views::as_rvalue, views::enumerate,
            views::as_const.
          + Additions to the <algorithm> header: ranges::contains,
            ranges::contains_subrange, ranges::iota, ranges::find_last,
            ranges::find_last_if, ranges::find_last_if_not,
            ranges::fold_left, ranges::fold_left_first,
            ranges::fold_right, ranges::fold_right_last,
            ranges::fold_left_with_iter,
            ranges::fold_left_first_with_iter.
          + Monadic operations for std::expected.
          + Constexpr std::bitset, std::to_chars and std::from_chars.
          + Library support for extended floating-point types.
     * Support for the <experimental/scope> header from v3 of the Library
       Fundamentals Technical Specification.
     * Support for the <experimental/synchronized_value> header from v2 of
       the Concurrency Technical Specification.
     * Support for many previously unavailable features in freestanding
       mode, thanks to Arsen Arsenović. For example, std::tuple is now
       available for freestanding compilation. The freestanding subset
       contains all the components made freestanding by [80]P1642, and
       libstdc++ adds more components such as std::array and
       std::string_view. Additionally, libstdc++ now respects the
       -ffreestanding compiler option and so it is not necessary to build
       a separate freestanding installation of libstdc++. Compiling with
       -ffreestanding restricts the available features to the freestanding
       subset, even if libstdc++ was built as a full, hosted
       implementation.

  [81]D

     * Support for the D programming language has been updated to version
       2.103.1 of the language and run-time library. Full changelog for
       this release and previous releases can be found on the
       [82]dlang.org website.
     * The following GCC attributes are now recognized and available from
       the gcc.attributes module with short-hand aliases for convenience:
          + @attribute("no_sanitize", arguments) or
            @no_sanitize(arguments).
          + @attribute("register") or @register.
          + @attribute("simd") or @simd.
          + @attribute("simd_clones", mask) or @simd_clones(mask).
          + @attribute("visibility", arguments) or @visibility(arguments).
     * New aliases have been added to gcc.attributes for compatibility
       with ldc.attributes.
          + The @hidden attribute is an alias for @attribute("visibility",
            "hidden").
          + The @noSanitize attribute is an alias for
            @attribute("no_sanitize").
     * Vector operation intrinsics prefetch, loadUnaligned,
       storeUnaligned, shuffle, shufflevector, extractelement,
       insertelement, convertvector, and blendvector have been added to
       the gcc.simd module.
     * New warnings:
          + [83]-Wbuiltin-declaration-mismatch= warns when a built-in
            function is declared with the wrong signature.
          + [84]-Wmismatched-special-enum warns when a special enum is
            declared with the wrong base type.
     * New version identifier D_Optimized is now predefined when the -O
       option, or any higher optimization level is used.
     * The predefinition of version D_Exceptions can now by controlled by
       the option -fexception.
     * The predefinition of version D_TypeInfo can now by controlled by
       the option -frtti.
     * The -fdebug= and -fversion= compiler switches no longer accept an
       integer argument.

  [85]Fortran

     * Finalization is now fully supported.

  [86]Go

     * GCC 13, like GCC 12, provides a complete implementation of the Go
       1.18 user packages.
     * Although Go 1.18 includes support for generic programming, that
       support is not yet available in GCC.

  [87]Modula-2

     * Support for the language Modula-2 has been added. This includes
       support for the ISO/IEC 10514-1, PIM2, PIM3, PIM4 dialects together
       with a complete set of ISO/IEC 10514-1 and PIM libraries.
     * The <* noreturn *> attribute is supported with the -Wreturn-type
       [88]option.

[89]New Targets and Target Specific Improvements

  [90]AArch64

     * The AArch64 target now supports Decimal Floating-point in the BID
       format through the libbid library.
     * A number of new CPUs are supported through the -mcpu and -mtune
       options (GCC identifiers in parentheses).
          + Ampere-1A (ampere1a).
          + Arm Cortex-A715 (cortex-a715).
          + Arm Cortex-X1C (cortex-x1c).
          + Arm Cortex-X3 (cortex-x3).
          + Arm Neoverse V2 (neoverse-v2).
     * Support has been added for the armv9.1-a, armv9.2-a and armv9.3-a
       arguments to the -march= option.
     * The FEAT_LRCPC feature is now supported by generating the LDAPR
       instructions for C and C++ atomic loads with an acquire memory
       model. This is enabled when compiling with the +rcpc extension to
       -march or a CPU target that supports this feature.
     * The FEAT_CSSC feature from the 2022 Arm Architecture extensions is
       supported through the +cssc extension option. When enabled, scalar
       operations like integer minimum, maximum, absolute value, count
       trailing zeroes (__builtin_ctz), population count
       (__builtin_popcount) can be implemented in a single instruction.
     * The FEAT_LSE2 feature is now supported through libatomic and
       provides lockless 16-byte atomics on systems that implement it.

  [91]AMD Radeon (GCN)

     * Support for the Instinct MI200 series devices ([92] gfx90a) has
       been added.
     * SIMD vectorization support has been improved; this and
       stack-handling changes [93]require newlib 4.3.0 (or newer).

  [94]arm

     * A number of new CPUs are supported through the -mcpu and -mtune
       options (GCC identifiers in parentheses).
          + STAR-MC1 (star-mc1).
          + Arm Cortex-X1C (cortex-x1c).
          + Arm Cortex-M85 (cortex-m85).
     * Support has been added for the M-profile PACBTI extension that can
       help harden the generated code against return-oriented and
       jump-oriented attacks. It can be enabled through the
       -mbranch-protection= option.

  [95]AVR

     * Support for the following devices has been added in GCC 13.3:
          + ATtiny102, ATtiny104, ATtiny424, ATtiny426, ATtiny427,
            ATtiny824, ATtiny826, ATtiny827, ATtiny1624, ATtiny1626,
            ATtiny1627, ATtiny3224, ATtiny3226, ATtiny3227, AVR32DD14,
            AVR32DD20, AVR32DD28, AVR32DD32, AVR32DU14, AVR32DU20,
            AVR32DU28, AVR32DU32, AVR32EA28, AVR32EA32, AVR32EA48,
            AVR64DD14, AVR64DD20, AVR64DD28, AVR64DD32, AVR64DU28,
            AVR64DU32, AVR64EA28, AVR64EA32, AVR64EA48, ATA5787, ATA5835,
            ATA5700M322.
     * Support for the following devices has been added in GCC 13.4:
          + AVR32SD20, AVR32SD28, AVR32SD32, AVR64SD28, AVR64SD32,
            AVR64SD48.
     * Support for the following devices has been added in GCC 13.5:
          + AVR32DA28S, AVR32DA32S, AVR32DA48S, AVR64DA28S, AVR64DA32S,
            AVR64DA48S AVR64DA64S, AVR128DA28S, AVR128DA32S, AVR128DA48S,
            AVR128DA64S, AVR32EB14, AVR32EB20, AVR32EB28, AVR32EB32,
            AVR16LA14, AVR16LA20, AVR16LA28, AVR16LA32, AVR32LA14,
            AVR32LA20, AVR32LA28, AVR32LA32.

  [96]IA-32/x86-64

     * For both C and C++ the __bf16 type is supported on x86 systems with
       SSE2 and above enabled.
     * Use this __bf16 type for AVX512BF16 intrinsics instead of
       __bfloat16 which is typedef for short. __bf16 is now part of the
       x86 psABI. Users need to adjust their AVX512BF16-related source
       code when upgrading to GCC 13.
     * New ISA extension support for Intel AMX-COMPLEX was added.
       AMX-COMPLEX intrinsics are available via the -mamx-complex compiler
       switch.
     * New ISA extension support for Intel AMX-FP16 was added. AMX-FP16
       intrinsics are available via the -mamx-fp16 compiler switch.
     * New ISA extension support for Intel AVX-IFMA was added. AVX-IFMA
       intrinsics are available via the -mavxifma compiler switch.
     * New ISA extension support for Intel AVX-NE-CONVERT was added.
       AVX-NE-CONVERT intrinsics are available via the -mavxneconvert
       compiler switch.
     * New ISA extension support for Intel AVX-VNNI-INT8 was added.
       AVX-VNNI-INT8 intrinsics are available via the -mavxvnniint8
       compiler switch.
     * New ISA extension support for Intel CMPccXADD was added. CMPccXADD
       intrinsics are available via the -mcmpccxadd compiler switch.
     * New ISA extension support for Intel PREFETCHI was added. PREFETCHI
       intrinsics are available via the -mprefetchi compiler switch.
     * New ISA extension support for Intel RAO-INT was added. RAO-INT
       intrinsics are available via the -mraoint compiler switch.
     * GCC now supports the Intel CPU named Raptor Lake through
       -march=raptorlake. Raptor Lake is based on Alder Lake. Since GCC
       13.5, CLDEMOTE is not enabled any longer.
     * GCC now supports the Intel CPU named Meteor Lake through
       -march=meteorlake. Meteor Lake is based on Alder Lake. Since GCC
       13.5, CLDEMOTE is not enabled any longer.
     * GCC now supports the Intel CPU named Sierra Forest through
       -march=sierraforest. Based on ISA extensions enabled on Alder Lake,
       the switch in addition enables the AVX-IFMA, AVX-NE-CONVERT,
       AVX-VNNI-INT8 and CMPccXADD ISA extensions. Since GCC 13.2, ENQCMD
       and UINTR are further enabled.
     * GCC now supports the Intel CPU named Grand Ridge through
       -march=grandridge. Based on Sierra Forest, the switch in addition
       enables the RAO-INT ISA extensions. Since GCC 13.2, ENQCMD and
       UINTR are further enabled. Since GCC 13.3, RAO-INT is not enabled
       any longer.
     * GCC now supports the Intel CPU named Emerald Rapids through
       -march=emeraldrapids. Emerald Rapids is based on Sapphire Rapids.
     * GCC now supports the Intel CPU named Granite Rapids through
       -march=graniterapids. Based on Sapphire Rapids, the switch in
       addition enables the AMX-FP16 and PREFETCHI ISA extensions.
     * GCC now supports the Intel CPU named Granite Rapids D through
       -march=graniterapids-d. Based on Granite Rapids, the switch in
       addition enables the AMX-COMPLEX ISA extensions.
     * Since GCC 13.5, CLDEMOTE is not enabled through the compiler switch
       -march=alderlake any longer.
     * GCC now supports AMD CPUs based on the znver4 core via
       -march=znver4. The switch makes GCC consider using 512-bit vectors
       when auto-vectorizing.

  [97]LoongArch

     * New features
          + The new command-line option -mexplicit-relocs decides whether
            to use the assembler relocation operator when dealing with
            symbolic addresses. It is enabled by default if a compatible
            assembler (binutils 2.40 or later) is present at GCC build
            time.
          + The new command-line option -mdirect-extern-access can be used
            to prevent accessing external symbols through GOT.
          + The new variable attribute [98]model has been added.
     * Built-in functions
          + The rint and copysign mathematical builtins (and their float
            variants) are now implemented as inline LoongArch intrinsics.
          + The lrint, logb, scalbln, scalbn and ldexp mathematical
            builtins (and their float variants) are now implemented as
            inline LoongArch intrinsics when using -fno-math-errno.
          + The lceil and lfloor mathematical builtins (and their float
            variants) are now implemented as inline LoongArch intrinsics
            when using -ffp-int-builtin-inexact.
     * Subprojects Support
          + libvtv now supports LoongArch.
          + libitm now supports LoongArch.
          + Address sanitizers other than HWASan and TSan are now
            supported on LoongArch.

  [99]NVPTX

     * The default value for the [100]-march option can be now changed
       when [101]building GCC using the [102]--with-arch= configure
       option. GCC's target libraries are then build both with sm_30 and
       the specified target architecture. If not specified, GCC defaults
       to sm_30.

  [103]RISC-V

     * Support for vector intrinsics as specified in [104]version 0.11 of
       the RISC-V vector intrinsic specification, thanks Ju-Zhe Zhong from
       [105]RiVAI for contributing most of implementation.
     * Support for the following standard extensions has been added:
          + Zawrs
          + Zbkb
          + Zbkc
          + Zbkx
          + Zdinx
          + Zfinx
          + Zfh
          + Zfhmin
          + Zhinx
          + Zhinxmin
          + Zicbom
          + Zicbop
          + Zicboz
          + Zknd
          + Zkne
          + Zksed
          + Zksh
          + Zmmul
     * Support for the following vendor extensions has been added:
          + XTheadBa
          + XTheadBb
          + XTheadBs
          + XTheadCmo
          + XTheadCondMov
          + XTheadFMemIdx
          + XTheadFmv
          + XTheadInt
          + XTheadMac
          + XTheadMemIdx
          + XTheadMemPair
          + XTheadSync
     * The following new CPUs are supported through the -mcpu option (GCC
       identifiers in parentheses).
          + T-Head's XuanTie C906 (thead-c906).
     * Improves the multi-lib selection mechanism for the bare-metal
       toolchain (riscv*-elf*). GCC will now automatically select the
       best-fit multi-lib candidate instead of requiring all possible
       reuse rules to be listed at build time.

[106]Operating Systems

  [107]Windows

     * The GNU threads library used by the win32 thread model has been
       reimplemented using direct Win32 API calls, except for the
       Objective-C specific subset. It requires Windows XP/Server 2003 or
       later. The new implementation also adds the support needed for the
       C++11 threads, using again direct Win32 API calls; this additional
       layer requires Windows Vista/Server 2008 or later. It is
       recommended to use a recent version of MinGW-W64 in conjunction
       with the win32 thread model.

[108]Improvements to Static Analyzer

     * The analyzer has gained 20 new warnings:
          + [109]-Wanalyzer-allocation-size
          + [110]-Wanalyzer-deref-before-check
          + [111]-Wanalyzer-exposure-through-uninit-copy
          + Seven new warnings relating to misuse of file descriptors:
               o [112]-Wanalyzer-fd-access-mode-mismatch
               o [113]-Wanalyzer-fd-double-close
               o [114]-Wanalyzer-fd-leak
               o [115]-Wanalyzer-fd-phase-mismatch (e.g. calling accept on
                 a socket before calling listen on it)
               o [116]-Wanalyzer-fd-type-mismatch (e.g. using a stream
                 socket operation on a datagram socket)
               o [117]-Wanalyzer-fd-use-after-close
               o [118]-Wanalyzer-fd-use-without-check
            along with special-casing handling of the behavior of open,
            close, creat, dup, dup2, dup3, pipe, pipe2, read, and write.
          + [119]-Wanalyzer-imprecise-fp-arithmetic
          + [120]-Wanalyzer-infinite-recursion
          + [121]-Wanalyzer-jump-through-null
          + [122]-Wanalyzer-out-of-bounds
          + [123]-Wanalyzer-putenv-of-auto-var
          + [124]-Wanalyzer-tainted-assertion
          + Four new warnings for misuses of <stdarg.h>:
               o [125]-Wanalyzer-va-list-leak for complaining about
                 missing va_end after a va_start or va_copy
               o [126]-Wanalyzer-va-list-use-after-va-end for complaining
                 about va_arg or va_copy used on a va_list that's had
                 va_end called on it
               o [127]-Wanalyzer-va-arg-type-mismatch for type-checking of
                 va_arg usage in interprocedural execution paths against
                 the types of the parameters that were actually passed to
                 the variadic call
               o [128]-Wanalyzer-va-list-exhausted for complaining in
                 interprocedural execution paths if va_arg is used too
                 many times on a va_list
       along with numerous other improvements.

[129]Improvements for plugin authors

     * GCC diagnostics can now be [130]associated with rules such as from
       coding standards documents, or specifications. Such rules have a
       code name and can have a URL, which GCC can print in text form or
       capture in its [131]SARIF output when emitting diagnostics.

Other significant improvements

[132]GCC 13.1

   This is the [133]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 13.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

[134]GCC 13.2

   This is the [135]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 13.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

[136]GCC 13.3

   This is the [137]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 13.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

  Language Specific Changes

  C++

     * The libstdc++exp.a library now includes all the Filesystem TS
       symbols from the libstdc++fs.a library, and the experimental
       symbols for the C++23 std::stacktrace class from the
       libstdc++_libbacktrace.a library. This means that -lstdc++exp is
       the only library needed for all experimental libstdc++ features.

[138]GCC 13.4

   This is the [139]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 13.4 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).


    For questions related to the use of GCC, please consult these web
    pages and the [140]GCC manuals. If that fails, the
    [141]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [142]gcc@gcc.gnu.org. All of [143]our lists have public
    archives.

   Copyright (C) [144]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [145]maintained by the GCC team. Last modified
   2026-03-15.

References

   1. https://gcc.gnu.org/gcc-13/porting_to.html
   2. https://gcc.gnu.org/onlinedocs/index.html#current
   3. https://gcc.gnu.org/pipermail/gcc/2022-December/240322.html
   4. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Warning-Options.html#index-Warray-bounds
   5. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/C-Dialect-Options.html#index-fstrict-flex-arrays
   6. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html
   7. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/ARM-iWMMXt-Built-in-Functions.html
   8. https://gcc.gnu.org/onlinedocs/libstdc++/manual/using_dynamic_or_shared.html#manual.intro.using.linkage.dynamic
   9. https://gcc.gnu.org/gcc-13/changes.html#general
  10. https://gcc.gnu.org/projects/gomp/
  11. http://memkind.github.io/memkind/
  12. https://sarifweb.azurewebsites.net/
  13. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html
  14. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-format
  15. https://gcc.gnu.org/onlinedocs/gcc/Freestanding-Environments.html
  16. https://gcc.gnu.org/gcc-13/changes.html#languages
  17. https://gcc.gnu.org/gcc-13/changes.html#ada
  18. https://gcc.gnu.org/gcc-13/changes.html#c-family
  19. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Warning-Options.html#index-Wxor-used-as-pow
  20. https://gcc.gnu.org/PR90885
  21. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Common-Function-Attributes.html#index-fd_005farg-function-attribute
  22. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Common-Function-Attributes.html#index-fd_005farg_005fread-function-attribute
  23. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Common-Function-Attributes.html#index-fd_005farg_005fwrite-function-attribute
  24. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html
  25. https://wg21.link/p1774r8
  26. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Statement-Attributes.html#index-assume-statement-attribute
  27. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/C-Dialect-Options.html#index-fstrict-flex-arrays
  28. https://gcc.gnu.org/gcc-13/changes.html#c
  29. https://www.open-std.org/jtc1/sc22/wg14/www/docs/n3042.htm
  30. https://www.open-std.org/jtc1/sc22/wg14/www/docs/n2963.htm
  31. https://www.open-std.org/jtc1/sc22/wg14/www/docs/n2975.pdf
  32. https://www.open-std.org/jtc1/sc22/wg14/www/docs/n3007.htm
  33. https://www.open-std.org/jtc1/sc22/wg14/www/docs/n3018.htm
  34. https://www.open-std.org/jtc1/sc22/wg14/www/docs/n3038.htm
  35. https://www.open-std.org/jtc1/sc22/wg14/www/docs/n2764.pdf
  36. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Warning-Options.html#index-Wformat
  37. https://www.open-std.org/jtc1/sc22/wg14/www/docs/n2836.pdf
  38. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Warning-Options.html#index-Wenum-int-mismatch
  39. https://gcc.gnu.org/PR105131
  40. https://gcc.gnu.org/gcc-13/changes.html#cxx
  41. https://wg21.link/p2324
  42. https://gcc.gnu.org/PR103539
  43. https://wg21.link/p2255
  44. https://gcc.gnu.org/PR104477
  45. https://wg21.link/p2327
  46. https://wg21.link/p2437
  47. https://gcc.gnu.org/PR106646
  48. https://wg21.link/p2290
  49. https://gcc.gnu.org/PR106645
  50. https://wg21.link/p2071
  51. https://gcc.gnu.org/PR106648
  52. https://wg21.link/p2513
  53. https://gcc.gnu.org/PR106656
  54. https://wg21.link/p1169r4
  55. https://gcc.gnu.org/PR106651
  56. https://wg21.link/p2266r3
  57. https://gcc.gnu.org/PR101165
  58. https://wg21.link/p2468r2
  59. https://gcc.gnu.org/PR106644
  60. https://wg21.link/p2362r3
  61. https://gcc.gnu.org/PR106647
  62. https://wg21.link/p2448r2
  63. https://gcc.gnu.org/PR106649
  64. https://wg21.link/p1467r9
  65. https://gcc.gnu.org/PR106652
  66. https://wg21.link/p1774r8
  67. https://gcc.gnu.org/PR106654
  68. https://wg21.link/p2295r6
  69. https://gcc.gnu.org/PR106655
  70. https://wg21.link/p2589r1
  71. https://gcc.gnu.org/PR107684
  72. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Warning-Options.html#index-Wself-move
  73. https://gcc.gnu.org/PR81159
  74. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wdangling-reference
  75. https://gcc.gnu.org/PR106393
  76. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wpessimizing-move
  77. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wredundant-move
  78. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Link-Options.html#index-nostdlib_002b_002b
  79. https://gcc.gnu.org/gcc-13/changes.html#libstdcxx
  80. https://www.open-std.org/jtc1/sc22/wg21/docs/papers/2022/p1642r11.html
  81. https://gcc.gnu.org/gcc-13/changes.html#d
  82. https://dlang.org/changelog/2.103.1.html
  83. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gdc/Warnings.html#index-Wno-builtin-declaration-mismatch
  84. https://gcc.gnu.org/onlinedocs/gcc-13.2.0/gdc/Warnings.html#index-Wmismatched-special-enum
  85. https://gcc.gnu.org/gcc-13/changes.html#fortran
  86. https://gcc.gnu.org/gcc-13/changes.html#go
  87. https://gcc.gnu.org/gcc-13/changes.html#modula2
  88. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gm2/Compiler-options.html
  89. https://gcc.gnu.org/gcc-13/changes.html#targets
  90. https://gcc.gnu.org/gcc-13/changes.html#aarch64
  91. https://gcc.gnu.org/gcc-13/changes.html#amdgcn
  92. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/AMD-GCN-Options.html
  93. https://gcc.gnu.org/install/specific.html#amdgcn-x-amdhsa
  94. https://gcc.gnu.org/gcc-13/changes.html#arm
  95. https://gcc.gnu.org/gcc-13/changes.html#avr
  96. https://gcc.gnu.org/gcc-13/changes.html#x86
  97. https://gcc.gnu.org/gcc-13/changes.html#loongarch
  98. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/LoongArch-Variable-Attributes.html#LoongArch-Variable-Attributes
  99. https://gcc.gnu.org/gcc-13/changes.html#nvptx
 100. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Nvidia-PTX-Options.html
 101. https://gcc.gnu.org/install/
 102. https://gcc.gnu.org/install/specific.html#nvptx-x-none
 103. https://gcc.gnu.org/gcc-13/changes.html#riscv
 104. https://github.com/riscv-non-isa/riscv-rvv-intrinsic-doc/tree/v0.11.x
 105. https://rivai-ic.com.cn/
 106. https://gcc.gnu.org/gcc-13/changes.html#os
 107. https://gcc.gnu.org/gcc-13/changes.html#windows
 108. https://gcc.gnu.org/gcc-13/changes.html#analyzer
 109. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-allocation-size
 110. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-deref-before-check
 111. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-exposure-through-uninit-copy
 112. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-fd-access-mode-mismatch
 113. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-fd-double-close
 114. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-fd-leak
 115. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-fd-phase-mismatch
 116. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-fd-type-mismatch
 117. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-fd-use-after-close
 118. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-fd-use-without-check
 119. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-imprecise-fp-arithmetic
 120. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-infinite-recursion
 121. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-jump-through-null
 122. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-out-of-bounds
 123. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-putenv-of-auto-var
 124. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-assertion
 125. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-va-list-leak
 126. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-va-list-use-after-va-end
 127. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-va-arg-type-mismatch
 128. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-va-list-exhausted
 129. https://gcc.gnu.org/gcc-13/changes.html#plugins
 130. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=0b14f590e3e9d95b8211b77d992589d5ab4c25f0
 131. https://gcc.gnu.org/onlinedocs/gcc-13.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-format
 132. https://gcc.gnu.org/gcc-13/changes.html#13.1
 133. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=13.0
 134. https://gcc.gnu.org/gcc-13/changes.html#13.2
 135. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=13.2
 136. https://gcc.gnu.org/gcc-13/changes.html#13.3
 137. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=13.3
 138. https://gcc.gnu.org/gcc-13/changes.html#13.4
 139. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=13.4
 140. https://gcc.gnu.org/onlinedocs/
 141. mailto:gcc-help@gcc.gnu.org
 142. mailto:gcc@gcc.gnu.org
 143. https://gcc.gnu.org/lists.html
 144. https://www.fsf.org/
 145. https://gcc.gnu.org/about.html
======================================================================
http://gcc.gnu.org/gcc-12/index.html
                             GCC 12 Release Series

   (This release series is no longer supported.)

   July 11, 2025

   The GCC developers are pleased to announce the release of GCC 12.5.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 12.4 relative to previous releases of GCC.

Release History

   GCC 12.5
          July 11, 2025 ([1]changes, [2]documentation)

   GCC 12.4
          Jun 20, 2024 ([3]changes, [4]documentation)

   GCC 12.3
          May 8, 2023 ([5]changes, [6]documentation)

   GCC 12.2
          Aug 19, 2022 ([7]changes, [8]documentation)

   GCC 12.1
          May 6, 2022 ([9]changes, [10]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [11]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [12]GCC
   project web site or contact the [13]GCC development mailing list.

   To obtain GCC please use [14]our mirror sites or [15]our version
   control system.


    For questions related to the use of GCC, please consult these web
    pages and the [16]GCC manuals. If that fails, the
    [17]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [18]gcc@gcc.gnu.org. All of [19]our lists have public
    archives.

   Copyright (C) [20]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [21]maintained by the GCC team. Last modified
   2025-08-04.

References

   1. https://gcc.gnu.org/gcc-12/changes.html
   2. https://gcc.gnu.org/onlinedocs/12.5.0/
   3. https://gcc.gnu.org/gcc-12/changes.html
   4. https://gcc.gnu.org/onlinedocs/12.4.0/
   5. https://gcc.gnu.org/gcc-12/changes.html
   6. https://gcc.gnu.org/onlinedocs/12.3.0/
   7. https://gcc.gnu.org/gcc-12/changes.html
   8. https://gcc.gnu.org/onlinedocs/12.2.0/
   9. https://gcc.gnu.org/gcc-12/changes.html
  10. https://gcc.gnu.org/onlinedocs/12.1.0/
  11. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Contributors.html
  12. https://gcc.gnu.org/index.html
  13. mailto:gcc@gcc.gnu.org
  14. https://gcc.gnu.org/mirrors.html
  15. https://gcc.gnu.org/git.html
  16. https://gcc.gnu.org/onlinedocs/
  17. mailto:gcc-help@gcc.gnu.org
  18. mailto:gcc@gcc.gnu.org
  19. https://gcc.gnu.org/lists.html
  20. https://www.fsf.org/
  21. https://gcc.gnu.org/about.html
======================================================================
http://gcc.gnu.org/gcc-12/changes.html
                             GCC 12 Release Series
                        Changes, New Features, and Fixes

   This page is a "brief" summary of some of the huge number of
   improvements in GCC 12. You may also want to check out our [1]Porting
   to GCC 12 page and the [2]full GCC documentation.

Caveats

     * An ABI incompatibility between C and C++ when passing or returning
       by value certain aggregates containing zero width bit-fields has
       been discovered on various targets. As mentioned in [3]PR102024,
       since the [4]PR42217 fix in GCC 4.5 the C++ front-end has been
       removing zero width bit-fields from the internal representation of
       the aggregates after the layout of those aggregates, but the C
       front-end kept them, so passing e.g. struct S { float a; int : 0;
       float b; } or struct T { float c; int : 0; } by value could differ
       between C and C++. Starting with GCC 12 the C++ front-end no longer
       removes those bit-fields from the internal representation and per
       clarified psABI some targets have been changed, so that they either
       ignore those bit-fields in the argument passing by value decisions
       in both C and C++, or they always take them into account. x86-64,
       ARM and AArch64 will always ignore them (so there is a C ABI
       incompatibility between GCC 11 and earlier with GCC 12 or later),
       PowerPC64 ELFv2 and S/390 always take them into account (so there
       is a C++ ABI incompatibility, GCC 4.4 and earlier compatible with
       GCC 12 or later, incompatible with GCC 4.5 through GCC 11). RISC-V
       has changed the handling of these already starting with GCC 10. As
       the ABI requires, MIPS takes them into account handling function
       return values so there is a C++ ABI incompatibility with GCC 4.5
       through 11. For function arguments on MIPS, refer to [5]the MIPS
       specific entry. GCC 12 on the above targets will report such
       incompatibilities as warnings or other diagnostics unless
       -Wno-psabi is used.
     * C: Computed gotos require a pointer type now.
     * C++: Two non-standard std::pair constructors have been deprecated.
       These allowed the use of an rvalue and a literal 0 to construct a
       pair containing a move-only type and a pointer. The nullptr keyword
       should be used to initialize the pointer member instead of a
       literal 0, as this is portable to other C++ implementations.
     * The configuration option --enable-libstdcxx-allocator no longer
       supports the bitmap, mt, and pool arguments. Those configurations
       had been broken for some time.
     * D: Building and bootstrapping GDC, the D compiler, now requires a
       working GDC (GCC version 9.1 or later) and D runtime library,
       libphobos, as the D front end is written in D. On some targets,
       libphobos isn't enabled by default, but compiles and works if
       --enable-libphobos is used. Other targets may require a more recent
       version of GCC to bootstrap. Specifics are documented for affected
       targets in the [6]Installing GCC manual.
     * Fortran: OpenMP code using the omp_lib.h include file can no longer
       be compiled with -std=f95 but now requires at least -std=f2003.
       Alternatively, use the omp_lib module, which still supports
       -std=f95 and is recommended to be used instead in general.
     * OpenMP offloading to Intel MIC has been deprecated and will be
       removed in a future release.
     * The cr16 target with the cr16-*-* configuration has been obsoleted
       and will be removed in a future release.
     * The hppa[12]*-*-hpux10* and hppa[12]*-*-hpux11* configurations
       targeting 32-bit PA-RISC with HP-UX have been obsoleted and will be
       removed in a future release.
     * The m32c*-*-rtems* configuration has been obsoleted and will be
       removed in a future release.
     * The support for the m32r-*-linux*, m32rle-*-linux*,
       m68k*-*-openbsd* and vax-*-openbsd* configurations has been
       removed.
     * STABS: Support for emitting the STABS debugging format is
       deprecated and will be removed in the next release. All ports now
       default to emit DWARF (version 2 or later) debugging info or are
       obsoleted.
     * The optimization level -Ofast now implies
       -fno-semantic-interposition.

[7]General Improvements

     * Vectorization is enabled at -O2 which is now equivalent to what
       would have been -O2 -ftree-vectorize -fvect-cost-model=very-cheap
       in the past. Note that the default vectorizer cost model has been
       changed; it used to behave as if -fvect-cost-model=cheap had been
       specified.
     * GCC now supports the [8]ShadowCallStack sanitizer, which can be
       enabled using the command-line option
       [9]-fsanitize=shadow-call-stack. This sanitizer currently only
       works on AArch64 targets and it requires an environment in which
       all code has been compiled with -ffixed-r18. Its primary initial
       user is the Linux kernel.

[10]New Languages and Language specific improvements

     * OpenMP
          + OpenMP 5.0 support has been extended: The close map modifier
            and the affinity clause are now supported. In addition,
            Fortran gained the following features which were available in
            C and C++ before: declare variant is now available, depobj,
            mutexinoutset and iterator can now also be used with the
            depend clause, defaultmap has been updated for OpenMP 5.0, and
            the loop directive and combined directives involving the
            master directive have been added.
          + The following OpenMP 5.1 features have been added: support for
            expressing OpenMP directives as C++ 11 attributes, the masked
            and scope constructs, the nothing and error directives, and
            using primary with the proc_bind clause and OMP_PROC_BIND
            environment variable, the reproducible and unconstrained
            modifiers to the order clause, and, for C/C++ only, the align
            and allocator modifiers to the allocate clause and the atomic
            extensions are now available. The OMP_PLACE environment
            variable supports the OpenMP 5.1 features. In addition, the
            OMP_NUM_TEAMS and OMP_TEAMS_THREAD_LIMIT environment variables
            and their associated API routines are now supported as well as
            the memory-allocation routines added for Fortran and extended
            for C/C++ in OpenMP 5.1. In Fortran code, strictly structured
            blocks can be used.
          + The [11]OpenMP Implementation Status can be found in the
            libgomp manual.
     * Version 2.6 of the [12]OpenACC specification continues to be
       maintained and improved in the C, C++ and Fortran compilers. See
       the [13]implementation status section on the OpenACC wiki page and
       the [14]run-time library documentation for further information. In
       addition to general performance tuning and bug fixing, new features
       include:
          + OpenACC worker parallelism for [15]AMD GPUs (already for a
            long time supported for [16]Nvidia GPUs).
          + Data privatization/sharing at the OpenACC gang level.
          + Considerable improvements for the experimental OpenACC
            'kernels' decomposition ([17]--param
            openacc-kernels=decompose).
          + A new warning flag [18]-Wopenacc-parallelism to warn about
            potentially suboptimal choices related to OpenACC parallelism.
     * The offload target code generation for OpenMP and OpenACC can now
       be better adjusted using the new [19]-foffload-options= flag and
       the pre-existing but now documented [20]-foffload= flag.

  [21]Ada

     * Ada 2022
          + Added the -gnat2022 flag to indicate strict Ada 2022
            compliance. The old -gnat2020 flag is now deprecated.
          + Support for Big Numbers (Annex G) has seen continuous
            improvements. It is now considered complete. It is compatible
            with SPARK, i.e. can be used from SPARK code.
          + Continuous improvements to the Ada 2022 standard since GCC 11.
          + Greatly improved compile time support. More functions can now
            have the with Static aspect and can be used in more contexts.
     * Ada 2022 extensions. The use of the -gnatX flag is necessary to
       access these features as they are not considered stable or
       standard.
          + Fixed lower bound for unconstrained arrays.
               o type Matrix is array (Natural range 0 .. <>, Natural
                 range 0 .. <>) of Integer; is now valid.
               o Subtypes can also specify a lower bound: subtype String_1
                 is String (1 .. <>);. Boundaries from slices will "slide"
                 to the correct lower bound of the subtype.
          + Generalized Object.Operand notation. The following code is now
            valid V.Add_Element(42);, with V being a vector, for example.
          + Additional when constructs. Keywords return, goto and raise
            can now use when in addition to the existing exit when. The
            following expression is therefore now valid raise
            Constraint_Error with "Element is null" when Element = null;
          + Pattern matching
               o The case statement has been extended to cover records and
                 arrays as well as finer grained casing on scalar types.
                 In the future it is expected to provide more compile time
                 guarantees when accessing discriminated fields. Case
                 exhaustion is supported for pattern matching. An example
                 would be
type Sign is (Neg, Zero, Pos);

function Multiply (S1, S2 : Sign) return Sign is
  (case (S1, S2) is
     when (Neg, Neg) | (Pos, Pos) => Pos,
     when (Zero, <>) | (<>, Zero) => Zero,
     when (Neg, Pos) | (Pos, Neg) => Neg);

     * gnatfind and gnatxref, which were already deprecated, have been
       removed.
     * Greatly expanded code covered by contracts. Thanks to this work,
       there are now several Ada standard libraries fully proven in SPARK
       which means they have no runtime nor logical errors. They are
       mostly numeric and string handling libraries.
     * Enable return-slot optimization for Pure functions.
     * General optimizations, improvements and additions to the standard
       library. Performance, correctness and in some cases stability was
       improved. Memory pools have also seen some minor enhancements.
     * Improvements to embedded-RTOS targets such as RTEMS, VxWorks and
       QNX. Older targets were removed or cleaned.
     * Added some [22]hardening features.

  [23]C family

     * Support for __builtin_shufflevector compatible with the clang
       language extension was added.
     * Support for attribute unavailable was added.
     * A new built-in function, __builtin_assoc_barrier, was added. It can
       be used to inhibit re-association of floating-point expressions.
     * Support for __builtin_dynamic_object_size compatible with the clang
       language extension was added.
     * New warnings:
          + [24]-Wbidi-chars warns about potentially misleading UTF-8
            bidirectional control characters. The default is
            -Wbidi-chars=unpaired ([25]PR103026)
          + [26]-Warray-compare warns about comparisons between two
            operands of array type ([27]PR97573)
     * Enhancements to existing warnings:
          + [28]-Wattributes has been extended so that it's possible to
            use -Wno-attributes=ns::attr or -Wno-attributes=ns:: to
            suppress warnings about unknown scoped attributes (in C++11
            and C2X). Similarly, #pragma GCC diagnostic ignored_attributes
            "vendor::attr" can be used to achieve the same effect
            ([29]PR101940)

  [30]C

     * Some new features from the upcoming C2X revision of the ISO C
       standard are supported with -std=c2x and -std=gnu2x. Some of these
       features are also supported as extensions when compiling for older
       language versions. In addition to the features listed, some
       features previously supported as extensions and now added to the C
       standard are enabled by default in C2X mode and not diagnosed with
       -std=c2x -Wpedantic.
          + Digit separators (as in C++) are supported for C2X.
          + The #elifdef and #elifndef preprocessing directives are now
            supported.
          + The printf and scanf format checking with [31]-Wformat now
            supports the %b format specified by C2X for binary integers,
            and the %B format recommended by C2X for printf.

  [32]C++

     * Several C++23 features have been implemented:
          + [33]P1938R3, if consteval ([34]PR100974)
          + [35]P0849R8, auto(x): decay-copy in the language
            ([36]PR103049)
          + [37]P2242R3, Non-literal variables (and labels and gotos) in
            constexpr functions ([38]PR102612)
          + [39]P2334R1, Support for preprocessing directives elifdef and
            elifndef ([40]PR102616)
          + [41]P2360R0, Extend init-statement to allow alias-declaration
            ([42]PR102617)
          + [43]P2128R6, Multidimensional subscript operator
          + [44]DR 2397, auto specifier for pointers and references to
            arrays ([45]PR100975)
     * Several C++ Defect Reports have been resolved, e.g.:
          + [46]DR 960, Covariant functions and lvalue/rvalue references
          + [47]DR 1227, Mixing immediate and non-immediate contexts in
            deduction failure
          + [48]DR 1315, Restrictions on non-type template arguments in
            partial specializations
          + [49]DR 2082, Referring to parameters in unevaluated operands
            of default arguments
          + [50]DR 2351, void{}
          + [51]DR 2374, Overly permissive specification of enum
            direct-list-initialization
          + [52]DR 2397, auto specifier for pointers and references to
            arrays
          + [53]DR 2446, Questionable type-dependency of concept-ids
     * New command-line option -fimplicit-constexpr can be used to make
       inline functions implicitly constexpr ([54]git)
     * New command-line option -ffold-simple-inlines can be used to fold
       calls to certain trivial inline functions (currently std::move,
       std::forward, std::addressof and std::as_const). In contrast to
       inlining such calls, folding means that no intermediate code or
       debug information will be generated for them; this minimizes the
       abstraction penalty incurred for using these functions versus using
       the fundamental operations from which they're defined (e.g.
       std::move versus static_cast). This flag is enabled by default when
       -fno-inline is not active.
     * Deduction guides can be declared at class scope ([55]PR79501)
     * [56]-Wuninitialized warns about using uninitialized variables in
       member initializer lists ([57]PR19808)
     * [58]-Wint-in-bool-context is now disabled when instantiating a
       template ([59]git)
     * Stricter checking of attributes on friend declarations: if a friend
       declaration has an attribute, that declaration must be a
       definition. Moreover, a C++11 attribute cannot appear in the middle
       of the decl-specifier-seq. ([60]PR99032)
     * New warning options for C++ language mismatches:
       -Wc++11-extensions, -Wc++14-extensions, -Wc++17-extensions,
       -Wc++20-extensions, and -Wc++23-extensions. They are enabled by
       default and can be used to control existing pedwarns about
       occurrences of new C++ constructs in code using an old C++ standard
       dialect.
     * New warning [61]-Wmissing-requires warns about missing requires
       ([62]git)
     * The existing std::is_constant_evaluated in if warning was extended
       to warn in more cases ([63]PR100995)
     * [64]-Waddress has been enhanced so that it now warns about, for
       instance, comparing the address of a nonstatic member function to
       null ([65]PR102103)
     * Errors about narrowing are no longer hidden if they occur in system
       headers
     * Ordered comparison of null pointers is now rejected ([66]PR99701)
     * Anonymous structs with bases are now rejected ([67]git)
     * The compiler rejects taking the address of an immediate member
       function ([68]PR102753)
     * The compiler has support for C++20
       __cpp_lib_is_pointer_interconvertible and
       __cpp_lib_is_layout_compatible to help the C++ library implement
       [69]P0466, Layout-compatibility and Pointer-interconvertibility
       Traits ([70]PR101539)
     * Memory usage of constraint subsumption has been improved
       ([71]PR100828)
     * constinit thread_local variables are optimized better
       ([72]PR101786)
     * Support for C++17 std::hardware_destructive_interference_size was
       added, along with the [73]-Winterference-size warning ([74]git)
     * Many bugs in the CTAD handling have been fixed ([75]PR101344,
       [76]PR101883, [77]PR89062, [78]PR101233, [79]PR88252, [80]PR86439,
       [81]PR98832, [82]PR102933 ...)
     * Two-stage name lookup for dependent operator expressions has been
       corrected ([83]PR51577)
     * Several issues with constrained variable templates have been fixed
       ([84]PR98486)
     * The compiler performs less instantiating when doing speculative
       constant evaluation ([85]git)
     * Various diagnostic improvements; e.g., a more precise caret
       location for pointer-to-member expressions
     * The new -fconstexpr-fp-except flag allows IEC559 floating point
       exceptions in constant-expressions.

    [86]Runtime Library (libstdc++)

     * Improved experimental C++20 support, including:
          + std::vector, std::basic_string, std::optional, and
            std::variant can be used in constexpr functions.
          + std::make_shared for arrays with default initialization, and
            std::atomic<std::shared_ptr<T>>.
          + Layout-compatibility and pointer-interconvertibility traits.
     * Improved experimental C++23 support, including:
          + Monadic operations for std::optional.
          + std::expected
          + std::move_only_function
          + <spanstream>
          + std::basic_string::resize_and_overwrite
          + std::unique_ptr can be used in constexpr functions.
          + <stacktrace> (not built by default, requires linking to an
            extra library).
          + <stdatomic.h>
          + std::invoke_r
          + constexpr std::type_info::operator==

  [87]D

     * New features:
          + Support for the D programming language has been updated to
            version 2.100.1 of the language and run-time library. Full
            changelog for this release and previous releases can be found
            on the [88]dlang.org website.
          + On supported targets, the __traits(compiles) expression can
            now be used to determine whether a target-specific built-in is
            available without error during CTFE ([89]PR101127).
          + Functions annotated with pragma(inline, true) are now compiled
            into every module where they are used from ([90]PR106563).
          + Partial support for directly importing C99 sources into a D
            compilation ([91]ImportC) has been added to the language. A
            notable missing feature is support for preprocessing C
            imports, which can be worked around by preprocessing all C
            sources used for importing ahead of time.
     * New language options:
          + -fcheck=, enables or disables the code generation of specific
            run-time contract checks.
          + -fcheckaction=, controls the run-time behavior on an assert,
            array bounds check, or final switch contract failure. The
            default is -fcheckaction=throw.
          + -fdump-c++-spec=, dumps all compiled extern(C++) declarations
            as C++ code to the given file. The supplementary option
            -fdump-c++-spec-verbose turns on emission of comments for
            ignored declarations in the generated spec.
          + -fextern-std=, controls which C++ standard extern(C++)
            declarations are compiled to be compatible with. The default
            is -fextern-std=c++17.
          + -fpreview=, added to enable upcoming D language features in
            the compiler.
          + -frevert=, added to revert D language changes to support older
            D codebases that need more time to transition.
          + -fsave-mixins=, saves mixins expanded at compile-time to a
            file.
     * Deprecated and removed features:
          + The -Wtemplates compiler switch has been removed, as it had
            been superceded by -ftransition=templates, which more
            accurately reports on which templates have been instantiated.
          + The -ftransition=dip25 and -ftransition=dip1000 compiler
            switches have been renamed to -fpreview=dip25 and
            -fpreview=dip1000.

  [92]Fortran

     * WG5/N1942, "TS 29113 Further Interoperability of Fortran with C",
       is now fully supported. In addition to implementing previously
       missing functionality, such as support for character arguments of
       length greater than one in functions marked bind(c) and gaps in the
       handling for assumed-rank arrays, numerous other bugs have been
       fixed, and an extensive set of new conformance test cases has been
       added.
     * GCC 12 now uses OPERATION as the name of the function to the
       CO_REDUCE intrinsic for the pairwise reduction, thus conforming to
       the Fortran 2018 standard. Previous versions used OPERATOR which
       conforms to TS 18508.
     * On POWER systems which support it, the -mabi=ieeelongdouble option
       now selects the IEEE 128-bit floating point format for
       REAL(KIND=16). R16_IBM and R16_IEEE have been added to the
       -fconvert option, the CONVERT specifier of the OPEN statement and
       the GFORTRAN_CONVERT_UNIT environment variable.

  [93]Go

     * GCC 12 provides a complete implementation of the Go 1.18 user
       packages.
     * Although Go 1.18 includes support for generic programming, that
       support is not yet available in GCC.

[94]libgccjit

     * The libgccjit API gained 30 new entry points:
          + 17 new "reflection" entry points for querying functions and
            types ([95]LIBGCCJIT_ABI_16)
          + [96]gcc_jit_lvalue_set_tls_model for supporting thread-local
            variables ([97]LIBGCCJIT_ABI_17)
          + [98]gcc_jit_lvalue_set_link_section for setting the link
            section of global variables, analogous to
            [99]__attribute__((section(".section")))
            ([100]LIBGCCJIT_ABI_18)
          + 4 new entry points for initializing global variables and
            creating constructors for rvalues ([101]LIBGCCJIT_ABI_19)
          + Support for sized integer types, including 128-bit integers
            and helper functions for such types ([102]LIBGCCJIT_ABI_20)
          + [103]gcc_jit_context_new_bitcast for reinterpreting the bits
            of an rvalue as a different type ([104]LIBGCCJIT_ABI_21)
          + [105]gcc_jit_lvalue_set_register_name for setting a specific
            register for a variable ([106]LIBGCCJIT_ABI_22)
          + [107]gcc_jit_context_set_bool_print_errors_to_stderr
            ([108]LIBGCCJIT_ABI_23)
          + 2 new entry points for setting the alignment of a variable
            ([109]LIBGCCJIT_ABI_24)
     * libgccjit has gained support for the use of various atomic builtins
       ([110]PR96066, [111]PR96067)
     * [112]gcc_jit_context_new_cast is now able to handle truncation and
       extension between different integer types ([113]PR95498)

[114]New Targets and Target Specific Improvements

  [115]AArch64 & arm

     * Newer revisions of the Arm Architecture are supported as arguments
       to the -march option: armv8.7-a, armv8.8-a, armv9-a.
     * The Arm Cortex-A510 CPU is now supported through the cortex-a510
       argument to the -mcpu and -mtune options.
     * GCC can now auto-vectorize operations performing sign-differing
       dot-product operations, taking advantage of instructions in the
       Advanced SIMD (AArch64/AArch32) and SVE (AArch64) instruction sets.

  [116]AArch64

     * A number of new CPUs are supported through the -mcpu and -mtune
       options (GCC identifiers in parentheses).
          + Ampere-1 (ampere1).
          + Arm Cortex-A710 (cortex-a710).
          + Arm Cortex-X2 (cortex-x2).
     * The 64-byte atomic load/store intrinsics to accelerator memory from
       the [117]2020 Arm Architecture extensions are supported through the
       +ls64 option extension.
     * Initial code generation support is supported for hardware
       instructions used to accelerate the memcpy,memmove and memset
       standard functions. These instructions can be generated when
       compiling with the +mopsoption extension.
     * The ACLE Advanced SIMD intrinsics accessible through the arm_neon.h
       header have been significantly reimplemented and generate
       higher-performing code than previous GCC versions.
     * The option -mtune=neoverse-512tvb is added to tune for Arm Neoverse
       cores that have a total vector bandwidth of 512 bits. Please refer
       to the documentation for more details.

  [118]AMD Radeon (GCN)

     * Debug experience with ROCGDB has been improved.
     * Support for the type __int128_t/integer(kind=16) was added.
     * For offloading, the limitation of using only one wavefront per
       compute unit (CU) has been lifted. Up to 40 workgroups per CU and
       16 wavefronts per workgroup are supported (up to a limit of 40
       wavefronts in total, per CU). Additionally, the number of used
       wavefronts and workgroups was tuned for performance.

  [119]arm

     * Support is added for accessing the stack canary value via the TLS
       register through the -fstack-protector-guard=tls and
       -mstack-protector-guard-offset= options. This intended for use in
       Linux kernel development. Please refer to the documentation for
       more details.

  [120]BPF

     * Support for CO-RE (compile-once, run-everywhere) has been added to
       the BPF back end. CO-RE allows to compile portable BPF programs
       that are able to run among different versions of the Linux kernel.

  [121]IA-32/x86-64

     * New ISA extension support for Intel AVX512-FP16 was added.
       AVX512-FP16 intrinsics are available via the -mavx512fp16 compiler
       switch.
     * Since GCC 12.5, CLDEMOTE is not enabled through the compiler switch
       -march=alderlake any longer.
     * For both C and C++ the _Float16 type is supported on x86 systems
       with SSE2 enabled. Without {-mavx512fp16}, all operations will be
       emulated in software and float instructions.
     * Mitigation against straight line speculation (SLS) for function
       return and indirect jump is supported via
       -mharden-sls=[none|all|return|indirect-jmp].
     * Add CS prefix to call and jmp to indirect thunk with branch target
       in r8-r15 registers via -mindirect-branch-cs-prefix.
     * Always use global offset table (GOT) to access external data and
       function symbols when the new -mno-direct-extern-access
       command-line option is specified.

  [122]LoongArch

     * Support for the LoongArch architecture instruction set has been
       added.
     * The Loongson CPU codename LA464 and LoongArch 64-bit generic CPU
       codename loongarch64 are supported through the -march= and -mtune=
       options (GCC identifiers in parentheses).
          + Loongson LA464 core (la464).
          + LoongArch 64-bit generic core (loongarch64).

  [123]MIPS

     * The ABI passing arguments containing zero-width fields (for
       example, C/C++ zero-width bit-fields, GNU C/C++ zero-length arrays,
       and GNU C empty structs) has changed. Now a zero-width field will
       not prevent an aligned 64-bit floating-point field next to it from
       being passed through FPR. This is compatible with LLVM, but
       incompatible with previous GCC releases. GCC 12 on MIPS will report
       such incompatibilities as an inform unless -Wno-psabi is used.
     * The ABI returning values containing C++17 empty bases has changed.
       Now an empty base will not prevent an aggregate containing only one
       or two floating-point fields from being returned through FPR. This
       is compatible with GCC 6 and earlier, but incompatible with GCC 7
       through 11. GCC 12 on MIPS will report such incompatibilities as an
       inform unless -Wno-psabi is used.

  [124]NVPTX

     * The -march flag has been added. The -misa flag is now considered an
       alias of the -march flag.
     * Support for PTX ISA target architectures sm_53, sm_70, sm_75 and
       sm_80 has been added. These can be specified using the -march flag.
     * The default PTX ISA target architecture has been set back to sm_30,
       to fix support for sm_30 boards.
     * The -march-map flag has been added. The -march-map value will be
       mapped to an valid -march flag value. For instance,
       -march-map=sm_50 maps to -march=sm_35. This can be used to specify
       that generated code is to be executed on a board with at least some
       specific compute capability, without having to know the valid
       values for the -march flag.
     * The -mptx flag has been added to specify the PTX ISA version for
       the generated code; permitted values are 3.1 (matches previous GCC
       versions), 6.0, 6.3, and 7.0. If not specified, the used version is
       the minimal version required for -march but at least 6.0.
     * An mptx-3.1 multilib was added. This allows using older drivers
       which do not support PTX ISA version 6.0.
     * The new __PTX_SM__ predefined macro allows code to check the PTX
       ISA target architecture being targeted by the compiler.
     * The new __PTX_ISA_VERSION_MAJOR__ and __PTX_ISA_VERSION_MINOR__
       predefined macros allows code to check the PTX ISA version being
       targeted by the compiler.

  [125]PowerPC / PowerPC64 / RS6000

     * The internal implementation of Power's target-specific built-in
       functions has been rewritten to be easier and less error-prone to
       maintain. Every attempt has been made to ensure that the new
       behavior matches the old behavior, but inevitably some bugs can be
       expected. Please [126]report any problems.
     * The built-in functions __builtin_get_texasr, __builtin_get_texasru,
       __builtin_get_tfhar, __builtin_get_tfiar, __builtin_set_texasr,
       __builtin_set_texasru, __builtin_set_tfhar, and __builtin_set_tfiar
       now behave as documented in all supported configurations. On prior
       releases, the arguments and return values of these functions were
       treated as unsigned long long instead of as unsigned long, when the
       options -m32 -mpowerpc64 were in effect.
     * The overloaded built-in functions vec_cntlz_lsbb and vec_cnttz_lsbb
       now behave as documented. On prior releases, these built-in
       functions had incorrect semantics on little-endian targets.

  [127]PRU

     * The [128]__regio_symbol variable qualifier has been added. It
       allows easier access in C programs to the __R30 and __R31 CPU I/O
       registers.

  [129]RISC-V

     * The default ISA spec version was bumped to 20191213; see [130]this
       announcement for details.
     * New ISA extension support for zba, zbb, zbc, zbs was added.
     * New ISA extension support for vector and scalar crypto was added,
       only support architecture testing macro and -march= parsing.
     * The option -mtune=thead-c906 is added to tune for T-HEAD c906
       cores.
     * libstdc++ no longer attempts to detect built-in atomics.
       Distributions that have out-of-tree workarounds for -latomic should
       check their ABIs again.

[131]Operating Systems

[132]Improvements to Static Analyzer

     * The analyzer has gained a
       [133]-Wanalyzer-use-of-uninitialized-value warning, similar to
       [134]-Wuninitialized and [135]-Wmaybe-uninitialized, but based on
       an interprocedural path-sensitive analysis ([136]PR95006).
       Such warnings are not disabled by the new
       [137]-ftrivial-auto-var-init (see below), as the latter is
       considered a mitigation option.
     * [138]-Wanalyzer-write-to-const and
       [139]-Wanalyzer-write-to-string-literal will now check for
       [140]__attribute__ ((access, ....)) on calls to externally-defined
       functions, and complain about read-only regions pointed to by
       arguments marked with a write_only or read_write attribute
       ([141]PR104793).
     * The analyzer's "taint" mode, activated by
       [142]-fanalyzer-checker=taint (in addition to [143]-fanalyzer), has
       gained four new taint-based warnings:
          + [144]-Wanalyzer-tainted-allocation-size for e.g.
            attacker-controlled malloc and alloca,
          + [145]-Wanalyzer-tainted-divisor for detecting where an
            attacker can inject a divide-by-zero,
          + [146]-Wanalyzer-tainted-offset for attacker-controlled pointer
            offsets,
          + [147]-Wanalyzer-tainted-size for attacker-controlled values
            being used as a size parameter to calls to memset or to
            functions marked with [148]__attribute__ ((access, ....)).
       The existing [149]-Wanalyzer-tainted-array-index has been reworded
       to talk about "attacker-controlled" rather than "tainted" values,
       for consistency with the new warnings.
       A new [150]__attribute__ ((tainted_args)) has been added to the C
       and C++ front ends, usable on functions, and on function pointer
       callback fields in structs. The analyzer's taint mode will treat
       all parameters and buffers pointed to by parameters of such
       functions as being attacker-controlled, such as for annotating
       system calls in an operating system kernel as being an "attack
       surface".
     * The analyzer now respects [151]__attribute__((const)): it will
       treat such functions as returning the same value when given the
       same inputs ([152]PR104434), and as having no side effects
       ([153]PR104576).
     * The analyzer is now able to split its analysis into multiple
       execution paths in places where there isn't a split in the control
       flow graph. For example, it now handles realloc calls by splitting
       the execution path into three possible outcomes for the call:
          + failure, returning NULL
          + success, growing the buffer in-place without moving it
          + success, allocating a new buffer, copying the content of the
            old buffer to it, and freeing the old buffer
     * The analyzer's interprocedural path exploration logic is now able
       to track calls through function pointers.
     * The analyzer now makes the assumption that if we know PTR is
       non-NULL, then (PTR + OFFSET) is also non-NULL. This isn't strictly
       true, but eliminates false positives in practice ([154]PR101962).
     * The analyzer has gained some initial support for inline assembler
       code. This is extremely limited, and is purely to help suppress
       false positives when analyzing the Linux kernel, which makes heavy
       use of inline assembler ([155]PR101570).
     * The way the analyzer tracks the state of memory along an execution
       path has been improved in various ways for GCC 12:
          + An optimization for representing bulk updates to memory (e.g.
            zero fills) has been removed as it never worked well. In GCC
            12 it has been replaced with a simpler and more accurate
            approach, eliminating many false positives ([156]PR95006).
          + Various optimizations have been added, speeding up the
            analysis on a particularly problematic source file from 4
            minutes down to 17 seconds ([157]PR104943, [158]PR104954, and
            [159]PR104955).
          + The analyzer now tracks the sizes of dynamically-allocated
            regions, both on the heap (via malloc etc) and stack (via
            alloca), though none of the analyzer warnings make use of this
            yet in GCC 12.
     * The analyzer's handling of switch statements has been rewritten,
       fixing various bugs.

Other significant improvements

  [160]Eliminating uninitialized variables

     * GCC can now [161]initialize all stack variables implicitly,
       including padding. This is intended to eliminate all classes of
       uninitialized stack variable flaws. Lack of explicit initialization
       will still warn when [162]-Wuninitialized is active. For best
       debugging, use of the new command-line option
       [163]-ftrivial-auto-var-init=pattern can be used to fill variables
       with a repeated 0xFE pattern, which tends to illuminate many bugs
       (e.g. pointers receive invalid addresses, sizes and indices are
       very large). For best production results, the new command-line
       option [164]-ftrivial-auto-var-init=zero can be used to fill
       variables with 0x00, which tends to provide a safer state for bugs
       (e.g. pointers are NULL, strings are NUL filled, and sizes and
       indices are 0).

  [165]Debugging formats

     * GCC can now generate debugging information in CTF, a lightweight
       debugging format that provides information about C types and the
       association between functions and data symbols and types. This
       format is designed to be embedded in ELF files and to be very
       compact and simple. A new command-line option -gctf enables the
       generation of CTF.
     * GCC can now generate debugging information in BTF. This is a
       debugging format mainly used in BPF programs and the Linux kernel.
       The compiler can generate BTF for any target, when enabled with the
       command-line option -gbtf

[166]GCC 12.1

   This is the [167]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 12.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

[168]GCC 12.2

   This is the [169]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 12.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

  Target Specific Changes

    LoongArch

     * The default setting of -m[check|no-check]-zero-division is changed
       for optimized code. Now -mno-check-zero-division is the default for
       all optimization levels but -O0 and -Og. The old behavior can be
       obtained by explicitly passing -mcheck-zero-division to GCC.

[170]GCC 12.3

  Target Specific Changes

  x86-64

     * GCC now supports AMD CPUs based on the znver4 core via
       -march=znver4. The switch makes GCC consider using 512-bit vectors
       when auto-vectorizing.

   This is the [171]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 12.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

[172]GCC 12.4

   This is the [173]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 12.4 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

[174]GCC 12.5

   This is the [175]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 12.5 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).


    For questions related to the use of GCC, please consult these web
    pages and the [176]GCC manuals. If that fails, the
    [177]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [178]gcc@gcc.gnu.org. All of [179]our lists have public
    archives.

   Copyright (C) [180]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [181]maintained by the GCC team. Last modified
   2025-12-29.

References

   1. https://gcc.gnu.org/gcc-12/porting_to.html
   2. https://gcc.gnu.org/onlinedocs/index.html#current
   3. https://gcc.gnu.org/PR102024
   4. https://gcc.gnu.org/PR42217
   5. https://gcc.gnu.org/gcc-12/changes.html#mips_zero_width_fields
   6. https://gcc.gnu.org/install/specific.html
   7. https://gcc.gnu.org/gcc-12/changes.html#general
   8. https://clang.llvm.org/docs/ShadowCallStack.html
   9. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Instrumentation-Options.html#index-fsanitize_003dshadow-call-stack
  10. https://gcc.gnu.org/gcc-12/changes.html#languages
  11. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/libgomp/OpenMP-Implementation-Status.html
  12. https://www.openacc.org/
  13. https://gcc.gnu.org/wiki/OpenACC/Implementation Status#status-12
  14. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/libgomp/Enabling-OpenACC.html
  15. https://gcc.gnu.org/gcc-12/changes.html#amdgcn
  16. https://gcc.gnu.org/gcc-12/changes.html#nvptx
  17. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Optimize-Options.html#index-param
  18. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wopenacc-parallelism
  19. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/C-Dialect-Options.html#index-foffload-options
  20. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/C-Dialect-Options.html#index-foffload
  21. https://gcc.gnu.org/gcc-12/changes.html#ada
  22. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gnat_rm/Security-Hardening-Features.html#Security-Hardening-Features
  23. https://gcc.gnu.org/gcc-12/changes.html#c-family
  24. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wbidi-chars
  25. https://gcc.gnu.org/PR103026
  26. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Warray-compare
  27. https://gcc.gnu.org/PR97573
  28. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wattributes
  29. https://gcc.gnu.org/PR101940
  30. https://gcc.gnu.org/gcc-12/changes.html#c
  31. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wformat
  32. https://gcc.gnu.org/gcc-12/changes.html#cxx
  33. https://wg21.link/p1938
  34. https://gcc.gnu.org/PR100974
  35. https://wg21.link/p0849
  36. https://gcc.gnu.org/PR103049
  37. https://wg21.link/p2242
  38. https://gcc.gnu.org/PR102612
  39. https://wg21.link/p2334
  40. https://gcc.gnu.org/PR102616
  41. https://wg21.link/p2360
  42. https://gcc.gnu.org/PR102617
  43. https://wg21.link/p2128
  44. https://wg21.link/cwg2397
  45. https://gcc.gnu.org/PR100975
  46. https://wg21.link/cwg960
  47. https://wg21.link/cwg1227
  48. https://wg21.link/cwg1315
  49. https://wg21.link/cwg2082
  50. https://wg21.link/cwg2351
  51. https://wg21.link/cwg2374
  52. https://wg21.link/cwg2397
  53. https://wg21.link/cwg2446
  54. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=87c2080b
  55. https://gcc.gnu.org/PR79501
  56. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wuninitialized
  57. https://gcc.gnu.org/PR19808
  58. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wint-in-bool-context
  59. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=3a2b12bc
  60. https://gcc.gnu.org/PR99032
  61. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wmissing-requires
  62. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=e18e56c7
  63. https://gcc.gnu.org/PR100995
  64. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Waddress
  65. https://gcc.gnu.org/PR102103
  66. https://gcc.gnu.org/PR99701
  67. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=3ead06c1
  68. https://gcc.gnu.org/PR102753
  69. https://wg21.link/p0466
  70. https://gcc.gnu.org/PR101539
  71. https://gcc.gnu.org/PR100828
  72. https://gcc.gnu.org/PR101786
  73. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Winterference-size
  74. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=76b75018
  75. https://gcc.gnu.org/PR101344
  76. https://gcc.gnu.org/PR101883
  77. https://gcc.gnu.org/PR89062
  78. https://gcc.gnu.org/PR101233
  79. https://gcc.gnu.org/PR88252
  80. https://gcc.gnu.org/PR86439
  81. https://gcc.gnu.org/PR98832
  82. https://gcc.gnu.org/PR102933
  83. https://gcc.gnu.org/PR51577
  84. https://gcc.gnu.org/PR98486
  85. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=1595fe44
  86. https://gcc.gnu.org/gcc-12/changes.html#libstdcxx
  87. https://gcc.gnu.org/gcc-12/changes.html#d
  88. https://dlang.org/changelog/2.100.1.html
  89. https://gcc.gnu.org/PR101127
  90. https://gcc.gnu.org/PR106563
  91. https://dlang.org/spec/importc.html
  92. https://gcc.gnu.org/gcc-12/changes.html#fortran
  93. https://gcc.gnu.org/gcc-12/changes.html#go
  94. https://gcc.gnu.org/gcc-12/changes.html#jit
  95. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-16
  96. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/expressions.html#c.gcc_jit_lvalue_set_tls_model
  97. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-17
  98. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/expressions.html#c.gcc_jit_lvalue_set_link_section
  99. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Common-Variable-Attributes.html#index-section-variable-attribute
 100. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-18
 101. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-19
 102. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-20
 103. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/expressions.html#c.gcc_jit_context_new_bitcast
 104. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-21
 105. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/expressions.html#c.gcc_jit_lvalue_set_register_name
 106. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-22
 107. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/contexts.html#c.gcc_jit_context_set_bool_print_errors_to_stderr
 108. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-23
 109. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-24
 110. https://gcc.gnu.org/PR96066
 111. https://gcc.gnu.org/PR96067
 112. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/expressions.html#c.gcc_jit_context_new_cast
 113. https://gcc.gnu.org/PR95498
 114. https://gcc.gnu.org/gcc-12/changes.html#targets
 115. https://gcc.gnu.org/gcc-12/changes.html#arm-targets
 116. https://gcc.gnu.org/gcc-12/changes.html#aarch64
 117. https://developer.arm.com/community/arm-community-blogs/b/architectures-and-processors-blog/posts/arm-a-profile-architecture-developments-2020
 118. https://gcc.gnu.org/gcc-12/changes.html#amdgcn
 119. https://gcc.gnu.org/gcc-12/changes.html#arm
 120. https://gcc.gnu.org/gcc-12/changes.html#bpf
 121. https://gcc.gnu.org/gcc-12/changes.html#x86
 122. https://gcc.gnu.org/gcc-12/changes.html#loongarch
 123. https://gcc.gnu.org/gcc-12/changes.html#mips
 124. https://gcc.gnu.org/gcc-12/changes.html#nvptx
 125. https://gcc.gnu.org/gcc-12/changes.html#powerpc
 126. https://gcc.gnu.org/bugs/
 127. https://gcc.gnu.org/gcc-12/changes.html#pru
 128. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Named-Address-Spaces.html#PRU-Named-Address-Spaces
 129. https://gcc.gnu.org/gcc-12/changes.html#riscv
 130. https://groups.google.com/a/groups.riscv.org/g/sw-dev/c/aE1ZeHHCYf4
 131. https://gcc.gnu.org/gcc-12/changes.html#os
 132. https://gcc.gnu.org/gcc-12/changes.html#analyzer
 133. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-use-of-uninitialized-value
 134. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wuninitialized
 135. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wmaybe-uninitialized
 136. https://gcc.gnu.org/PR95006
 137. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Optimize-Options.html#index-ftrivial-auto-var-init
 138. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-write-to-const
 139. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-write-to-string-literal
 140. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Common-Function-Attributes.html
 141. https://gcc.gnu.org/PR104793
 142. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-fanalyzer-checker
 143. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-fanalyzer
 144. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-allocation-size
 145. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-divisor
 146. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-offset
 147. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-size
 148. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Common-Function-Attributes.html
 149. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-array-index
 150. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Common-Function-Attributes.html#index-tainted_005fargs-function-attribute
 151. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Common-Function-Attributes.html#index-const-function-attribute
 152. https://gcc.gnu.org/PR104434
 153. https://gcc.gnu.org/PR104576
 154. https://gcc.gnu.org/PR101962
 155. https://gcc.gnu.org/PR101570
 156. https://gcc.gnu.org/PR95006
 157. https://gcc.gnu.org/PR104943
 158. https://gcc.gnu.org/PR104954
 159. https://gcc.gnu.org/PR104955
 160. https://gcc.gnu.org/gcc-12/changes.html#uninitialized
 161. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Optimize-Options.html#index-ftrivial-auto-var-init
 162. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wuninitialized
 163. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Optimize-Options.html#index-ftrivial-auto-var-init
 164. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Optimize-Options.html#index-ftrivial-auto-var-init
 165. https://gcc.gnu.org/gcc-12/changes.html#debug
 166. https://gcc.gnu.org/gcc-12/changes.html#12.1
 167. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=12.0
 168. https://gcc.gnu.org/gcc-12/changes.html#12.2
 169. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=12.2
 170. https://gcc.gnu.org/gcc-12/changes.html#12.3
 171. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=12.3
 172. https://gcc.gnu.org/gcc-12/changes.html#12.4
 173. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=12.4
 174. https://gcc.gnu.org/gcc-12/changes.html#12.5
 175. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=12.5
 176. https://gcc.gnu.org/onlinedocs/
 177. mailto:gcc-help@gcc.gnu.org
 178. mailto:gcc@gcc.gnu.org
 179. https://gcc.gnu.org/lists.html
 180. https://www.fsf.org/
 181. https://gcc.gnu.org/about.html
======================================================================
http://gcc.gnu.org/gcc-11/index.html
                             GCC 11 Release Series

   (This release series is no longer supported.)

   July 19, 2024

   The GCC developers are pleased to announce the release of GCC 11.5.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 11.4 relative to previous releases of GCC.

Release History

   GCC 11.5
          July 19, 2024 ([1]changes, [2]documentation)

   GCC 11.4
          May 29, 2023 ([3]changes, [4]documentation)

   GCC 11.3
          April 21, 2022 ([5]changes, [6]documentation)

   GCC 11.2
          July 28, 2021 ([7]changes, [8]documentation)

   GCC 11.1
          April 27, 2021 ([9]changes, [10]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [11]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [12]GCC
   project web site or contact the [13]GCC development mailing list.

   To obtain GCC please use [14]our mirror sites or [15]our version
   control system.


    For questions related to the use of GCC, please consult these web
    pages and the [16]GCC manuals. If that fails, the
    [17]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [18]gcc@gcc.gnu.org. All of [19]our lists have public
    archives.

   Copyright (C) [20]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [21]maintained by the GCC team. Last modified
   2025-08-04.

References

   1. https://gcc.gnu.org/gcc-11/changes.html
   2. https://gcc.gnu.org/onlinedocs/11.5.0/
   3. https://gcc.gnu.org/gcc-11/changes.html
   4. https://gcc.gnu.org/onlinedocs/11.4.0/
   5. https://gcc.gnu.org/gcc-11/changes.html
   6. https://gcc.gnu.org/onlinedocs/11.3.0/
   7. https://gcc.gnu.org/gcc-11/changes.html
   8. https://gcc.gnu.org/onlinedocs/11.2.0/
   9. https://gcc.gnu.org/gcc-11/changes.html
  10. https://gcc.gnu.org/onlinedocs/11.1.0/
  11. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Contributors.html
  12. https://gcc.gnu.org/index.html
  13. mailto:gcc@gcc.gnu.org
  14. https://gcc.gnu.org/mirrors.html
  15. https://gcc.gnu.org/git.html
  16. https://gcc.gnu.org/onlinedocs/
  17. mailto:gcc-help@gcc.gnu.org
  18. mailto:gcc@gcc.gnu.org
  19. https://gcc.gnu.org/lists.html
  20. https://www.fsf.org/
  21. https://gcc.gnu.org/about.html
======================================================================
http://gcc.gnu.org/gcc-11/changes.html
                             GCC 11 Release Series
                        Changes, New Features, and Fixes

   This page is a "brief" summary of some of the huge number of
   improvements in GCC 11. You may also want to check out our [1]Porting
   to GCC 11 page and the [2]full GCC documentation.

Caveats

     * The default mode for C++ is now -std=gnu++17 instead of
       -std=gnu++14. Note that [3]C++17 changes to template template
       parameter matching can be disabled independently of other features
       with -fno-new-ttp-matching.
     * When building GCC itself, the host compiler must now support C++11,
       rather than C++98. In particular bootstrapping GCC 11 using an
       older version of GCC requires a binary of GCC 4.8 or later, rather
       than of GCC 3.4 or later as was the case for bootstrapping GCC 10.
     * Naming and location of auxiliary and dump output files changed. If
       you compile multiple input files in a single command, if you enable
       Link Time Optimization, or if you use -dumpbase, -dumpdir,
       -save-temps=*, and you expect any file other than the primary
       output file(s) to be created as a side effect, watch out for
       improvements and a few surprises. See [4]the patch, particularly
       its textual description, for more details about the changes.
     * -gsplit-dwarf no longer enables debug info generation on its own
       but requires a separate -g for this.
     * The libstdc++ configure option --enable-cheaders=c_std is
       deprecated and will be removed in a future release. It should be
       possible to use --enable-cheaders=c_global (the default) with no
       change in behaviour.
     * The front end for compiling BRIG format of Heterogeneous System
       Architecture Intermediate Language (HSAIL) has been deprecated and
       will likely be removed in a future release.
     * Some short options of the gcov tool have been renamed: -i to -j and
       -j to -H.

[5]General Improvements

     * [6]ThreadSanitizer improvements to support alternative runtimes and
       environments. The [7]Linux Kernel Concurrency Sanitizer (KCSAN) is
       now supported.
          + Add --param tsan-distinguish-volatile to optionally emit
            instrumentation distinguishing volatile accesses.
          + Add --param tsan-instrument-func-entry-exit to optionally
            control if function entries and exits should be instrumented.
     * In previous releases of GCC, the "column numbers" emitted in
       diagnostics were actually a count of bytes from the start of the
       source line. This could be problematic, both because of:
          + multibyte characters (requiring more than one byte to encode),
            and
          + multicolumn characters (requiring more than one column to
            display in a monospace font)
       For example, the character π ("GREEK SMALL LETTER PI (U+03C0)")
       occupies one column, and its UTF-8 encoding requires two bytes; the
       character 🙂 ("SLIGHTLY SMILING FACE (U+1F642)") occupies two
       columns, and its UTF-8 encoding requires four bytes.
       In GCC 11 the column numbers default to being column numbers,
       respecting multi-column characters. The old behavior can be
       restored using a new option [8]-fdiagnostics-column-unit=byte.
       There is also a new option [9]-fdiagnostics-column-origin=,
       allowing the pre-existing default of the left-hand column being
       column 1 to be overridden if desired (e.g. for 0-based columns).
       The output of [10]-fdiagnostics-format=json has been extended to
       supply both byte counts and column numbers for all source
       locations.
       Additionally, in previous releases of GCC, tab characters in the
       source would be emitted verbatim when quoting source code, but be
       prefixed with whitespace or line number information, leading to
       misalignments in the resulting output when compared with the actual
       source. Tab characters are now printed as an appropriate number of
       spaces, using the [11]-ftabstop option (which defaults to 8 spaces
       per tab stop).
     * Introduce [12]Hardware-assisted AddressSanitizer support. This
       sanitizer currently only works for the AArch64 target. It helps
       debug address problems similarly to [13]AddressSanitizer but is
       based on partial hardware assistance and provides probabilistic
       protection to use less RAM at run time. [14]Hardware-assisted
       AddressSanitizer is not production-ready for user space, and is
       provided mainly for use compiling the Linux Kernel.
       To use this sanitizer the command line arguments are:
          + -fsanitize=hwaddress to instrument userspace code.
          + -fsanitize=kernel-hwaddress to instrument kernel code.
     * For targets that produce DWARF debugging information GCC now
       defaults to [15]DWARF version 5 (with the exception of VxWorks and
       Darwin/Mac OS X which default to version 2 and AIX which defaults
       to version 4). This can produce up to 25% more compact debug
       information compared to earlier versions.
       To take full advantage of DWARF version 5 GCC needs to be built
       against binutils version 2.35.2 or higher. When GCC is built
       against earlier versions of binutils GCC will still emit DWARF
       version 5 for most debuginfo data, but will generate version 4
       debug line tables (even when explicitly given -gdwarf-5).
       The following debug information consumers can process DWARF version
       5:
          + GDB 8.0, or higher
          + valgrind 3.17.0
          + elfutils 0.172, or higher (for use with systemtap,
            dwarves/pahole, perf and libabigail)
          + dwz 0.14
       Programs embedding libbacktrace are urged to upgrade to the version
       shipping with GCC 11.
       To make GCC 11 generate an older DWARF version use -g together with
       -gdwarf-2, -gdwarf-3 or -gdwarf-4.
     * Vectorizer improvements:
          + The straight-line code vectorizer now considers the whole
            function when vectorizing and can handle opportunities
            crossing CFG merges and backedges.
     * A series of conditional expressions that compare the same variable
       can be transformed into a switch statement if each of them contains
       a comparison expression. Example:
        int IsHTMLWhitespace(int aChar) {
          return aChar == 0x0009 || aChar == 0x000A ||
                 aChar == 0x000C || aChar == 0x000D ||
                 aChar == 0x0020;
        }

       This statement can be transformed into a switch statement and then
       expanded into a bit-test.
     * New command-line options:
          + [16]-fbit-tests, enabled by default, can be used to enable or
            disable switch expansion using bit-tests.
     * Inter-procedural optimization improvements:
          + A new IPA-modref pass was added to track side effects of
            function calls and improve precision of points-to-analysis.
            The pass can be controlled by the [17]-fipa-modref option.
          + The identical code folding pass (controlled by [18]-fipa-icf)
            was significantly improved to increase the number of unified
            functions and to reduce compile-time memory use.
          + IPA-CP (Interprocedural constant propagation) heuristics
            improved its estimation of potential usefulness of known loop
            bounds and strides by taking the estimated frequency of these
            loops into account.
     * Link-time optimization improvements:
          + The LTO bytecode format was optimized for smaller object files
            and faster streaming.
          + Memory allocation of the linking stage was improved to reduce
            peak memory use.
     * Profile driven optimization improvements:
          + Using [19]-fprofile-values, was improved by tracking more
            target values for e.g. indirect calls.
          + GCOV data file format outputs smaller files by representing
            zero counters in a more compact way.

[20]New Languages and Language specific improvements

     * GCC 11 adds support for non-rectangular loop nests in OpenMP
       constructs and the allocator routines of [21]OpenMP 5.0, including
       initial allocate clause support in C/C++. The OMP_TARGET_OFFLOAD
       environment variable and the active-levels routines are now
       supported. For C/C++, the declare variant and map support has been
       extended. For Fortran, OpenMP 4.5 is now fully supported and OpenMP
       5.0 support has been extended, including the following features
       which were before only available in C and C++: order(concurrent),
       device_type, memorder-clauses for flush, lastprivate with
       conditional modifier, atomic construct and reduction clause
       extensions of OpenMP 5.0, if clause with simd and cancel modifiers,
       target data without map clause, and limited support for the
       requires construct.
     * Version 2.6 of the [22]OpenACC specification continues to be
       maintained and improved in the C, C++ and Fortran compilers. See
       the [23]implementation status section on the OpenACC wiki page and
       the [24]run-time library documentation for further information.

  [25]C family

     * New attributes:
          + The [26]no_stack_protector attribute has been added to mark
            functions which should not be instrumented with stack
            protection (-fstack-protector).
          + The existing [27]malloc attribute has been extended so that it
            can be used to identify allocator/deallocator API pairs. A
            pair of new [28]-Wmismatched-dealloc and
            [29]-Wmismatched-new-delete warnings will complain about
            mismatched calls, and [30]-Wfree-nonheap-object about
            deallocation calls with pointers not obtained from allocation
            functions. Additionally, the static analyzer will use these
            attributes when checking for leaks, double-frees,
            use-after-frees, and similar issues.
     * New warnings:
          + [31]-Wmismatched-dealloc, enabled by default, warns about
            calls to deallocation functions with pointers returned from
            mismatched allocation functions.
          + [32]-Wsizeof-array-div, enabled by -Wall, warns about
            divisions of two sizeof operators when the first one is
            applied to an array and the divisor does not equal the size of
            the array element.
          + [33]-Wstringop-overread, enabled by default, warns about calls
            to string functions reading past the end of the arrays passed
            to them as arguments. In prior GCC releases most instances of
            his warning are diagnosed by -Wstringop-overflow.
          + [34]-Wtsan, enabled by default, warns about unsupported
            features in ThreadSanitizer (currently
            std::atomic_thread_fence).
     * Enhancements to existing warnings:
          + [35]-Wfree-nonheap-object detects many more instances of calls
            to deallocation functions with pointers not returned from a
            dynamic memory allocation function.
          + [36]-Wmaybe-uninitialized diagnoses passing pointers or
            references to uninitialized memory to functions taking
            const-qualified arguments.
          + [37]-Wuninitialized detects reads from uninitialized
            dynamically allocated memory.
     * For ELF targets that support the GNU or FreeBSD OSABIs, the used
       attribute will now save the symbol declaration it is applied to
       from linker garbage collection.
       To support this behavior, used symbols that have not been placed in
       specific sections (e.g. with the section attribute, or the
       -f{function,data}-sections options) will be placed in new, unique
       sections.
       This functionality requires Binutils version 2.36 or later.

  [38]C

     * Several new features from the upcoming C2X revision of the ISO C
       standard are supported with -std=c2x and -std=gnu2x. Some of these
       features are also supported as extensions when compiling for older
       language versions. In addition to the features listed, some
       features previously supported as extensions and now added to the C
       standard are enabled by default in C2X mode and not diagnosed with
       -std=c2x -Wpedantic.
          + The BOOL_MAX and BOOL_WIDTH macros are provided in <limits.h>.
          + As in C++, function definitions no longer need to give names
            for unused function parameters.
          + The expansions of the true and false macros in <stdbool.h>
            have changed so that they have type bool.
          + The [[nodiscard]] standard attribute is now supported.
          + The __has_c_attribute preprocessor operator is now supported.
          + Macros INFINITY, NAN, FLT_SNAN, DBL_SNAN, LDBL_SNAN,
            DEC_INFINITY, DEC_NAN, and corresponding signaling NaN macros
            for _FloatN, _FloatNx and _DecimalN types, are provided in
            <float.h>. There are also corresponding built-in functions
            __builtin_nansdN for decimal signaling NaNs.
          + Macros FLT_IS_IEC_60559, DBL_IS_IEC_60559 and
            LDBL_IS_IEC_60559 are provided in <float.h>.
          + The feature test macro __STDC_WANT_IEC_60559_EXT__ is
            supported by <float.h>.
          + Labels may appear before declarations and at the end of a
            compound statement.
     * New warnings:
          + [39]-Warray-parameter, enabled by -Wall, warns about
            redeclarations of functions with ordinary array arguments
            declared using inconsistent forms. The warning also enables
            the detection of the likely out of bounds accesses in calls to
            such functions with smaller arrays.
          + [40]-Wvla-parameter, enabled by -Wall, warns redeclarations of
            functions with variable length array arguments declared using
            inconsistent forms or with mismatched bounds. The warning also
            enables the detection of the likely out of bounds accesses in
            calls to such functions with smaller arrays.

  [41]C++

     * The default mode has been changed to -std=gnu++17.
     * Several C++20 features have been implemented:
          + the compiler now supports consteval virtual functions
          + P2082R1, Fixing CTAD for aggregates
          + P0593R6, Pseudo-destructors end object lifetimes
          + P1907R1, Inconsistencies with non-type template parameters
            (complete implementation)
          + P1975R0, Fixing the wording of parenthesized
            aggregate-initialization
          + P1009R2, Array size deduction in new-expressions
          + P1099R5, using enum
          + Modules, Requires -fmodules-ts and some aspects are
            incomplete. Refer to [42]C++ 20 Status
     * The C++ front end has experimental support for some of the upcoming
       C++23 draft features with the -std=c++23, -std=gnu++23, -std=c++2b
       or -std=gnu++2b flags, including
          + P0330R8, Literal Suffix for (signed) size_t.
       For a full list of new features, see [43]the C++ status page.
     * Several C++ Defect Reports have been resolved, e.g.:
          + DR 625, Use of auto as a template-argument
          + DR 1512, Pointer comparison vs qualification conversions
          + DR 1722, Should lambda to function pointer conversion function
            be noexcept?
          + DR 1914, Duplicate standard attributes
          + DR 2032, Default template-arguments of variable templates
          + DR 2289, Uniqueness of decomposition declaration names
          + DR 2237, Can a template-id name a constructor?
          + DR 2303, Partial ordering and recursive variadic inheritance
          + DR 2369, Ordering between constraints and substitution
          + DR 2450, braced-init-list as a template-argument
     * G++ now performs better access checking in templates ([44]PR41437).
     * reinterpret_casts in constexpr evaluation are now checked more
       completely ([45]PR95307).
     * The diagnostic for static_assert has been improved: the compiler
       now shows the expression including its template arguments (if there
       were any), and can point to the failing clause if the condition
       comprised of any logical AND operators ([46]PR97518).
     * New warnings:
          + [47]-Wctad-maybe-unsupported, disabled by default, warns about
            performing class template argument deduction on a type with no
            deduction guides.
          + [48]-Wrange-loop-construct, enabled by -Wall, warns when a
            range-based for-loop is creating unnecessary and expensive
            copies.
          + [49]-Wdeprecated-enum-enum-conversion, enabled by default in
            C++20, warns about deprecated arithmetic conversions on
            operands of enumeration types, as outlined in
            [depr.arith.conv.enum].
          + [50]-Wdeprecated-enum-float-conversion, enabled by default in
            C++20, warns about deprecated arithmetic conversions on
            operands where one is of enumeration type and the other is of
            a floating-point type, as outlined in [depr.arith.conv.enum].
          + [51]-Wmismatched-new-delete, enabled by -Wall, warns about
            calls to C++ operator delete with pointers returned from
            mismatched forms of operator new or from other mismatched
            allocation functions.
          + [52]-Wvexing-parse, enabled by default, warns about the most
            vexing parse rule: the cases when a declaration looks like a
            variable definition, but the C++ language requires it to be
            interpreted as a function declaration.
     * Enhancements to existing warnings:
          + [53]-Wnonnull considers the implicit this argument of every
            C++ nonstatic member function to have been implicitly declared
            with attribute nonnull and triggers warnings for calls where
            the pointer is null.

    [54]Runtime Library (libstdc++)

     * Improved C++17 support, including:
          + std::from_chars and std::to_chars for floating-point types.
     * Improved experimental C++20 support, including:
          + Calendar additions to <chrono>. Thanks to Cassio Neri for
            optimizations.
          + std::bit_cast
          + std::source_location
          + Atomic wait and notify operations.
          + <barrier>, <latch>, and <semaphore>
          + <syncstream>
          + Efficient access to basic_stringbuf's buffer.
          + Heterogeneous lookup in unordered containers.
     * Experimental C++23 support, including:
          + contains member functions for strings, thanks to Paul Fee.
          + std::to_underlying, std::is_scoped_enum
     * Experimental support for Data-Parallel Types (simd) from the
       Parallelism 2 TS, thanks to Matthias Kretz.
     * Faster std::uniform_int_distribution, thanks to Daniel Lemire.

  [55]D

     * New features:
          + A new bottom type typeof(*null) has been added to represent
            run-time errors and non-terminating functions. This also
            introduces a new standard alias for the type named noreturn,
            and is implicitly imported into every module.
          + Printf-like and scanf-like functions are now detected by
            prefixing them with pragma(printf) for printf-like functions
            or pragma(scanf) for scanf-like functions.
          + The __traits() expression now supports the extensions
            isDeprecated, isDisabled, isFuture, isModule, isPackage,
            child, isReturnOnStack, isZeroInit, getTargetInfo,
            getLocation, hasPostblit, isCopyable, getVisibility, and
            totype.
          + An expression-based contract syntax has been added to the
            language.
          + Function literals can now return a value by reference with the
            ref keyword.
          + A new syntax is available to declare aliases to function types
            using the alias syntax based on the assignment operator.
          + New types __c_complex_float, __c_complex_double,
            __c_complex_real, and __c_wchar_t have been added for
            interfacing with C and C++ code, and are available from the
            core.stdc.config module.
          + User-defined attributes can now be used to annotate enum
            members, alias declarations, and function parameters.
          + Template alias parameters can now be instantiated with basic
            types such as int or void function().
          + The mixin construct can now be used as types in the form
            mixin(string) var.
          + The mixin construct can now take an argument list, same as
            pragma(msg).
     * New intrinsics:
          + Bitwise rotate intrinsics core.bitop.rol and core.bitop.ror
            have been added.
          + Byte swap intrinsic core.bitop.byteswap for swapping bytes in
            a 2-byte ushort has been added.
          + Math intrinsics available from core.math now have overloads
            for float and double types.
          + Volatile intrinsics core.volatile.volatileLoad and
            core.volatile.volatileStore have been moved from the
            core.bitop module.
     * New attributes:
          + The following GCC attributes are now recognized and available
            from the gcc.attributes module with short-hand aliases for
            convenience:
               o @attribute("alloc_size", arguments) or
                 @alloc_size(arguments).
               o @attribute("always_inline") or @always_inline.
               o @attribute("used") or @used.
               o @attribute("optimize", arguments) or
                 @optimize(arguments).
               o @attribute("cold") or @cold.
               o @attribute("noplt") or @noplt.
               o @attribute("target_clones", arguments) or
                 @target_clones(arguments).
               o @attribute("no_icf") or @no_icf.
               o @attribute("noipa") or @noipa.
               o @attribute("symver", arguments) or @symver(arguments).
          + New aliases have been added to gcc.attributes for
            compatibility with ldc.attributes.
               o The @allocSize(arguments) attribute is the same as
                 @alloc_size(arguments), but uses a 0-based index for
                 function arguments.
               o The @assumeUsed attribute is an alias for
                 @attribute("used").
               o The @fastmath attribute is an alias for
                 @optimize("Ofast").
               o The @naked attribute is an alias for @attribute("naked").
                 This attribute may not be available on all targets.
               o The @restrict attribute has been added to specify that a
                 function parameter is to be restrict-qualified in the C99
                 sense of the term.
               o The @optStrategy(strategy) attribute is an alias for
                 @optimize("O0") when the strategy is "none", otherwise
                 @optimize("Os") for the "optsize" and "minsize"
                 strategies.
               o The @polly attribute is an alias for
                 @optimize("loop-parallelize-all").
               o The @section(name) attribute is an alias for
                 @attribute("section", name).
               o The @target(arguments) attribute is an alias for
                 attribute("target", arguments).
               o The @weak attribute is an alias for @attribute("weak").
     * New language options:
          + -fweak-templates, added to control whether declarations that
            can be defined in multiple objects should be emitted as weak
            symbols. The default is to emit all symbols with extern
            linkage as weak, unless the target lacks support for weak
            symbols.
          + -Wdeprecated, this option is now enabled by default.
          + -Wextra, this option now turns on all warnings that are not
            part of the core D language front-end - -Waddress,
            -Wcast-result, -Wunknown-pragmas.
          + -Wvarargs, added to turn on warnings about questionable usage
            of the va_start intrinsic.
     * Deprecated and removed features:
          + Compiler-recognized attributes are now made available from the
            gcc.attributes module, the former module gcc.attribute has
            been deprecated and will be removed in a future release.
          + The @attribute("alias") attribute has been removed, as it had
            been superseded by pragma(mangle).
          + The @attribute("forceinline") attribute has been removed and
            renamed to @always_inline.
          + __vector types that are not supported in hardware are now
            rejected at compile-time. Previously all vector types were
            accepted by the compiler and emulated when target support was
            absent.
          + The extern(Pascal) linkage attribute has been removed.
          + The deprecation phase for -ftransition=import and
            -ftransition=checkimports is finished. These switches no
            longer have an effect and are now removed. Symbols that are
            not visible in a particular scope will no longer be found by
            the compiler.
          + It is now an error to use private variables selectively
            imported from other modules. Due to a bug, some imported
            private members were visible from other modules, violating the
            specification.
          + The -fweak compiler switch has been removed, as it existed
            only for testing.

  [56]Fortran

     * Added DEPRECATED to !GCC$'s attributes directive.

  [57]Go

     * GCC 11 provides a complete implementation of the Go 1.16.3 user
       packages.

[58]libgccjit

     * libgccjit was marked as merely "Alpha" quality when [59]originally
       added in GCC 5. Given that we have maintained [60]API and ABI
       compatibility since then and it is in use by various projects, we
       have removed that caveat.
     * libgccjit can now be built for MinGW
     * The libgccjit API gained 10 new entry points:
          + [61]gcc_jit_global_set_initializer
          + 9 entrypoints for [62]directly embedding asm statements into a
            compile, analogous to inline asm in the C front end

[63]New Targets and Target Specific Improvements

  [64]AArch64 & arm

     * A number of new CPUs are supported through arguments to the -mcpu
       and -mtune options in both the arm and aarch64 back ends (GCC
       identifiers in parentheses):
          + Arm Cortex-A78 (cortex-a78).
          + Arm Cortex-A78AE (cortex-a78ae).
          + Arm Cortex-A78C (cortex-a78c).
          + Arm Cortex-X1 (cortex-x1).
          + Arm Neoverse V1 (neoverse-v1).
          + Arm Neoverse N2 (neoverse-n2).
     * GCC can now auto-vectorize operations performing addition,
       subtraction, multiplication and the accumulate/subtract variants on
       complex numbers, taking advantage of the Advanced SIMD instructions
       in the Armv8.3-a (AArch64/AArch32), SVE (AArch64), SVE2 (AArch64)
       and MVE (AArch32 M-profile) instruction sets.

  [65]AArch64

     * In addition to the above, the following AArch64-only CPUs are now
       supported:
          + Fujitsu A64FX (a64fx).
          + Arm Cortex-R82 (cortex-r82).
     * The AArch64 Armv8-R architecture is now supported through the
       -march=armv8-r option.
     * Mitigation against the [66]Straight-line Speculation vulnerability
       is supported with the -mharden-sls= option. Please refer to the
       documentation for usage instructions.
     * The availability of Advanced SIMD intrinsics available through the
       arm_neon.h header is improved and GCC 11 supports the full set of
       intrinsics defined by ACLE Q3 2020.

  [67]AMD Radeon (GCN)

     * Initial support for gfx908 GPUs has been added.

  [68]arm

     * Initial auto-vectorization is now available when targeting the MVE
       instruction set.
     * GCC can now make use of the Low Overhead Branch instruction in
       Armv8.1-M to optimize loop counters and checks.
     * The -mcpu=cortex-m55 option now supports the extensions +nomve and
       +nomve.fp to control generation of MVE and MVE floating-point
       instructions.

  [69]IA-32/x86-64

     * New ISA extension support for Intel TSXLDTRK was added to GCC.
       TSXLDTRK intrinsics are available via the -mtsxldtrk compiler
       switch.
     * New ISA extension support for Intel SERIALIZE was added to GCC.
       SERIALIZE intrinsics are available via the -mserialize compiler
       switch.
     * New ISA extension support for Intel HRESET was added to GCC. HRESET
       intrinsics are available via the -mhreset compiler switch.
     * New ISA extension support for Intel UINTR was added to GCC. UINTR
       intrinsics are available via the -muintr compiler switch.
     * New ISA extension support for Intel KEYLOCKER was added to GCC.
       KEYLOCKER intrinsics are available via the -mkeylocker compiler
       switch.
     * New ISA extension support for Intel AMX-TILE, AMX-INT8, AMX-BF16
       was added to GCC. AMX-TILE, AMX-INT8, AMX-BF16 intrinsics are
       available via the -mamx-tile, -mamx-int8, -mamx-bf16 compiler
       switches.
     * New ISA extension support for Intel AVX-VNNI was added to GCC.
       AVX-VNNI intrinsics are available via the -mavxvnni compiler
       switch.
     * GCC now supports the Intel CPU named Sapphire Rapids through
       -march=sapphirerapids. The switch enables the MOVDIRI, MOVDIR64B,
       AVX512VP2INTERSECT, ENQCMD, CLDEMOTE, SERIALIZE, PTWRITE, WAITPKG,
       TSXLDTRK, AMT-TILE, AMX-INT8, AMX-BF16, and AVX-VNNI ISA
       extensions.
     * GCC now supports the Intel CPU named Alderlake through
       -march=alderlake. The switch enables the CLDEMOTE, PTWRITE,
       WAITPKG, SERIALIZE, KEYLOCKER, AVX-VNNI, and HRESET ISA extensions.
     * GCC now supports the Intel CPU named Rocketlake through
       -march=rocketlake. Rocket Lake is based on Icelake client and minus
       SGX.
     * GCC now supports AMD CPUs based on the znver3 core via
       -march=znver3.
     * GCC now supports micro-architecture levels defined in the x86-64
       psABI via -march=x86-64-v2, -march=x86-64-v3 and -march=x86-64-v4.

  [70]Nios II

     * The options -mcustom-insn=N no longer produce compiler warnings if
       the custom instruction is not generated due to missing optimization
       options such as -fno-math-errno, -ffinite-math-only, or
       -funsafe-math-optimizations. These warnings were not consistently
       emitted for all custom instructions.
     * The -mcustom-fpu-cfg=fph2 option has been added to enable the
       custom instructions supported by the Nios II Floating Point
       Hardware 2 Component.

  [71]NVPTX

     * The -misa default has changed from sm_30 to sm_35.
     * The -m32 compiler switch has been removed.
     * The -msoft-stack-reserve-local format has been fixed. Previously,
       it accepted -msoft-stack-reserve-local<n>. It now accepts
       -msoft-stack-reserve-local=<n>.

  [72]S/390, System z, IBM Z Systems

     * The behavior when compiling with -fexcess-precision=standard (e.g.,
       implied by -std=c99) on s390(x) targets can now be controlled at
       configure time with the flag --enable-s390-excess-float-precision.
       When enabled, GCC will maintain previous behavior and evaluate
       float expressions in double precision, which aligns with the
       definition of float_t as double. With the flag disabled, GCC will
       always evaluate float expressions in single precision. In native
       builds and cross compiles that have target libc headers, GCC will
       by default match the definition of float_t in the installed glibc.

  [73]RISC-V

     * Support address sanitizer for RISC-V.
     * Support big-endian for RISC-V, thanks to Marcus Comstedt.
     * Implement new style of architecture extension test macros: each
       architecture extension has a corresponding feature test macro,
       which can be used to test its existence and version information.
     * Legacy architecture extension test macros like __riscv_atomic are
       deprecated, but will still be supported for at least 2 release
       cycles.
     * Support IFUNC for riscv*-*-linux*.
     * Add new option -misa-spec=* to control ISA spec version. This
       controls the default version of each extensions. It defaults to
       2.2.
     * Introduce the --with-multilib-generator configure time option. This
       allows for flexible config multi-lib settings. Its syntax is the
       same as RISC-V's multilib-generator.
     * Extend the sytax for multilib-generator, support expansion operator
       * to reduce the complexity of complicated multi-lib re-use rules.
     * Support -mcpu=* option aligned with RISC-V clang/LLVM. It sets the
       pipeline model and architecture extensions, like -mtune=* plus
       -march=*.
     * Support for TLS stack protector canary access, thanks to Cooper Qu.
     * Support __builtin_thread_pointer for RISC-V.
     * Introduce shorten_memrefs optimization, which reduces the code size
       for memory access, thanks to Craig Blackmore.

[74]Operating Systems

  [75]AIX

     * GCC for AIX can be built as a 64-bit application and the runtime is
       built as FAT libraries containing both 32-bit and 64-bit objects.
     * Support AIX Vector Extended ABI with -mabi=vec-extabi.
     * Thread-Local uninitiated data placed in local common section.
     * Use thread-safe access in ctype.
     * Link with libc128.a when long-double-128 enabled.

[76]Improvements to Static Analyzer

     * The implementation of how program state is tracked within
       [77]-fanalyzer has been completely rewritten for GCC 11, fixing
       numerous bugs, and allowing for the analyzer to scale to larger C
       source files.
     * The analysis of allocations and deallocations has been generalized
       beyond malloc and free.
          + As preliminary work towards eventually supporting C++, the
            malloc/free checking will also check new/delete and
            new[]/delete[]. However, C++ is not yet properly supported by
            [78]-fanalyzer (for example, exception-handling is
            unimplemented).
          + As noted above, the existing [79]malloc attribute has been
            extended so that it can be used to identify
            allocator/deallocator API pairs. The analyzer will use these
            attributes when checking for leaks, double-frees,
            use-after-frees, and similar issues.
          + A new [80]-Wanalyzer-mismatching-deallocation warning has been
            added, covering such mismatches as using scalar delete rather
            vector delete[].
     * The analyzer has gained warnings
       [81]-Wanalyzer-shift-count-negative,
       [82]-Wanalyzer-shift-count-overflow, [83]-Wanalyzer-write-to-const,
       and [84]-Wanalyzer-write-to-string-literal, all enabled by default
       when [85]-fanalyzer is enabled.
     * The analyzer can now be extended by GCC plugins, allowing for
       domain-specific path-sensitive warnings. An example of using a
       [86]GCC plugin to check for misuses of CPython's global interpreter
       lock can be seen in the test suite
     * The analyzer has gained new debugging options
       [87]-fdump-analyzer-json and [88]-fno-analyzer-feasibility.

Other significant improvements

     * GCC has gained a new environment variable
       [89]GCC_EXTRA_DIAGNOSTIC_OUTPUT which can be used by IDEs to
       request machine-readable fix-it hints without needing to adjust
       build flags.

[90]GCC 11.1

   This is the [91]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 11.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

[92]GCC 11.2

   This is the [93]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 11.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

[94]GCC 11.3

   This is the [95]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 11.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

[96]GCC 11.4

   This is the [97]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 11.4 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

  Target Specific Changes

    x86-64

     * The x86-64 ABI of passing and returning structure with a 64-bit
       single precision vector changed in GCC 11.1 when 3DNOW is disabled.
       Disabling 3DNOW no longer changes how they are passed nor returned.
       This ABI change is now diagnosed with -Wpsabi.
     * Mitigation against straight line speculation (SLS) for function
       return and indirect jump is supported via
       -mharden-sls=[none|all|return|indirect-jmp].
     * Add CS prefix to call and jmp to indirect thunk with branch target
       in r8-r15 registers via -mindirect-branch-cs-prefix.

[98]GCC 11.5

   This is the [99]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 11.5 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

  Caveats

    aarch64

     * Due to a bug introduced a few weeks before the 11.5.0 release if
       the compiler is configured without explicit --with-arch=,
       --with=cpu= and/or --with-tune= configure options the compiler
       without explicit -march= etc. options might act as if asked for
       cortex-a34. This can be fixed by applying manually the
       [100]r12-8060 commit patch on top of GCC 11.5.0. See [101]PR116029
       for more details. GCC 11.4.0 or earlier releases are not affected.


    For questions related to the use of GCC, please consult these web
    pages and the [102]GCC manuals. If that fails, the
    [103]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [104]gcc@gcc.gnu.org. All of [105]our lists have public
    archives.

   Copyright (C) [106]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [107]maintained by the GCC team. Last modified
   2025-08-14.

References

   1. https://gcc.gnu.org/gcc-11/porting_to.html
   2. https://gcc.gnu.org/onlinedocs/index.html#current
   3. https://wg21.link/p0522r0
   4. https://gcc.gnu.org/pipermail/gcc-patches/2020-May/546494.html
   5. https://gcc.gnu.org/gcc-11/changes.html#general
   6. https://github.com/google/sanitizers/wiki/ThreadSanitizerCppManual
   7. https://www.kernel.org/doc/html/latest/dev-tools/kcsan.html
   8. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-column-unit
   9. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-column-origin
  10. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-format
  11. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Preprocessor-Options.html#index-ftabstop
  12. https://clang.llvm.org/docs/HardwareAssistedAddressSanitizerDesign.html
  13. https://github.com/google/sanitizers/wiki/AddressSanitizer
  14. https://clang.llvm.org/docs/HardwareAssistedAddressSanitizerDesign.html
  15. https://dwarfstd.org/doc/DWARF5.pdf
  16. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Code-Gen-Options.html#index-fno-bit-tests
  17. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Optimize-Options.html#index-fipa-modref
  18. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Optimize-Options.html#index-fipa-ocf
  19. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Optimize-Options.html#index-fprofile-values
  20. https://gcc.gnu.org/gcc-11/changes.html#languages
  21. https://www.openmp.org/specifications/
  22. https://www.openacc.org/
  23. https://gcc.gnu.org/wiki/OpenACC/Implementation Status#status-11
  24. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/libgomp/Enabling-OpenACC.html
  25. https://gcc.gnu.org/gcc-11/changes.html#c-family
  26. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Common-Function-Attributes.html#index-no_005fstack_005fprotector-function-attribute
  27. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Common-Function-Attributes.html#index-malloc-function-attribute
  28. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wmismatched-dealloc
  29. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wmismatched-new-delete
  30. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wfree-nonheap-object
  31. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wmismatched-dealloc
  32. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wsizeof-array-div
  33. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wstringop-overread
  34. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wtsan
  35. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wfree-nonheap-object
  36. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wmaybe-uninitialized
  37. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wuninitialized
  38. https://gcc.gnu.org/gcc-11/changes.html#c
  39. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Warray-parameter
  40. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wvla-parameter
  41. https://gcc.gnu.org/gcc-11/changes.html#cxx
  42. https://gcc.gnu.org/projects/cxx-status.html#cxx20
  43. https://gcc.gnu.org/projects/cxx-status.html#cxx23
  44. https://gcc.gnu.org/PR41437
  45. https://gcc.gnu.org/PR95307
  46. https://gcc.gnu.org/PR97518
  47. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wctad-maybe-unsupported
  48. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wrange-loop-construct
  49. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wdeprecated-enum-enum-conversion
  50. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wdeprecated-enum-float-conversion
  51. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wmismatched-new-delete
  52. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wvexing-parse
  53. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wnonnull
  54. https://gcc.gnu.org/gcc-11/changes.html#libstdcxx
  55. https://gcc.gnu.org/gcc-11/changes.html#d
  56. https://gcc.gnu.org/gcc-11/changes.html#fortran
  57. https://gcc.gnu.org/gcc-11/changes.html#go
  58. https://gcc.gnu.org/gcc-11/changes.html#jit
  59. https://gcc.gnu.org/gcc-5/changes.html#jit
  60. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/jit/topics/compatibility.html
  61. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/jit/topics/expressions.html#c.gcc_jit_global_set_initializer
  62. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/jit/topics/asm.html
  63. https://gcc.gnu.org/gcc-11/changes.html#targets
  64. https://gcc.gnu.org/gcc-11/changes.html#arm-targets
  65. https://gcc.gnu.org/gcc-11/changes.html#aarch64
  66. https://developer.arm.com/documentation/110280/latest
  67. https://gcc.gnu.org/gcc-11/changes.html#amdgcn
  68. https://gcc.gnu.org/gcc-11/changes.html#arm
  69. https://gcc.gnu.org/gcc-11/changes.html#x86
  70. https://gcc.gnu.org/gcc-11/changes.html#nios2
  71. https://gcc.gnu.org/gcc-11/changes.html#nvptx
  72. https://gcc.gnu.org/gcc-11/changes.html#s390
  73. https://gcc.gnu.org/gcc-11/changes.html#riscv
  74. https://gcc.gnu.org/gcc-11/changes.html#os
  75. https://gcc.gnu.org/gcc-11/changes.html#aix
  76. https://gcc.gnu.org/gcc-11/changes.html#analyzer
  77. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html
  78. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html
  79. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Common-Function-Attributes.html#index-malloc-function-attribute
  80. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-mismatching-deallocation
  81. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-shift-count-negative
  82. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-shift-count-overflow
  83. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-write-to-const
  84. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-write-to-string-literal
  85. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html
  86. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=66dde7bc64b75d4a338266333c9c490b12d49825
  87. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html#index-fdump-analyzer-json
  88. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html#index-fno-analyzer-feasibility
  89. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Environment-Variables.html#index-GCC_005fEXTRA_005fDIAGNOSTIC_005fOUTPUT
  90. https://gcc.gnu.org/gcc-11/changes.html#11.1
  91. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=11.0
  92. https://gcc.gnu.org/gcc-11/changes.html#11.2
  93. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=11.2
  94. https://gcc.gnu.org/gcc-11/changes.html#11.3
  95. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=11.3
  96. https://gcc.gnu.org/gcc-11/changes.html#11.4
  97. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=11.4
  98. https://gcc.gnu.org/gcc-11/changes.html#11.5
  99. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=11.5
 100. https://gcc.gnu.org/r12-8060
 101. https://gcc.gnu.org/PR116029
 102. https://gcc.gnu.org/onlinedocs/
 103. mailto:gcc-help@gcc.gnu.org
 104. mailto:gcc@gcc.gnu.org
 105. https://gcc.gnu.org/lists.html
 106. https://www.fsf.org/
 107. https://gcc.gnu.org/about.html
======================================================================
http://gcc.gnu.org/gcc-10/index.html
                             GCC 10 Release Series

   (This release series is no longer supported.)

   July, 7, 2023

   The [1]GNU project and the GCC developers are pleased to announce the
   release of GCC 10.5.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 10.4 relative to previous releases of GCC.

Release History

   GCC 10.5
          July 7, 2023 ([2]changes, [3]documentation)

   GCC 10.4
          June 28, 2022 ([4]changes, [5]documentation)

   GCC 10.3
          April 8, 2021 ([6]changes, [7]documentation)

   GCC 10.2
          July 23, 2020 ([8]changes, [9]documentation)

   GCC 10.1
          May 7, 2020 ([10]changes, [11]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [12]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [13]GCC
   project web site or contact the [14]GCC development mailing list.

   To obtain GCC please use [15]our mirror sites or [16]our version
   control system.


    For questions related to the use of GCC, please consult these web
    pages and the [17]GCC manuals. If that fails, the
    [18]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [19]gcc@gcc.gnu.org. All of [20]our lists have public
    archives.

   Copyright (C) [21]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [22]maintained by the GCC team. Last modified
   2024-05-30.

References

   1. http://www.gnu.org/
   2. https://gcc.gnu.org/gcc-10/changes.html
   3. https://gcc.gnu.org/onlinedocs/10.5.0/
   4. https://gcc.gnu.org/gcc-10/changes.html
   5. https://gcc.gnu.org/onlinedocs/10.4.0/
   6. https://gcc.gnu.org/gcc-10/changes.html
   7. https://gcc.gnu.org/onlinedocs/10.3.0/
   8. https://gcc.gnu.org/gcc-10/changes.html
   9. https://gcc.gnu.org/onlinedocs/10.2.0/
  10. https://gcc.gnu.org/gcc-10/changes.html
  11. https://gcc.gnu.org/onlinedocs/10.1.0/
  12. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Contributors.html
  13. https://gcc.gnu.org/index.html
  14. mailto:gcc@gcc.gnu.org
  15. https://gcc.gnu.org/mirrors.html
  16. https://gcc.gnu.org/git.html
  17. https://gcc.gnu.org/onlinedocs/
  18. mailto:gcc-help@gcc.gnu.org
  19. mailto:gcc@gcc.gnu.org
  20. https://gcc.gnu.org/lists.html
  21. https://www.fsf.org/
  22. https://gcc.gnu.org/about.html
======================================================================
http://gcc.gnu.org/gcc-10/changes.html
                             GCC 10 Release Series
                        Changes, New Features, and Fixes

   This page is a "brief" summary of some of the huge number of
   improvements in GCC 10. You may also want to check out our [1]Porting
   to GCC 10 page and the [2]full GCC documentation.

Caveats

     * An ABI incompatibility between C++14 and C++17 has been fixed. On
       some targets a class with a zero-sized subobject would be passed
       incorrectly when compiled as C++17 or C++20. See the [3]C++ notes
       below for more details.
     * The deprecated Profile Mode and array_allocator extensions have
       been removed from libstdc++.
     * The non-standard std::__is_nullptr_t type trait is deprecated and
       will be removed from libstdc++ in a future release. The standard
       trait std::is_null_pointer should be instead.
     * The minimum version of the [4]MPFR library required for building
       GCC has been increased to version 3.1.0 (released 2011-10-03).
     * The automatic template instantiation at link time (-frepo) has been
       removed.
     * The --param allow-store-data-races internal parameter has been
       removed in favor of a new official option -fallow-store-data-races.
       While default behavior is unchanged and the new option allows to
       correctly maintain a per compilation unit setting across link-time
       optimization, alteration of the default via --param
       allow-store-data-races will now be diagnosed and build systems have
       to be adjusted accordingly.
     * Offloading to Heterogeneous System Architecture Intermediate
       Language (HSAIL) has been deprecated and will likely be removed in
       a future release.
     * The type of the std::iterator base class of
       std::istreambuf_iterator was changed in C++98 mode to be consistent
       with C++11 and later standards. See the [5]libstdc++ notes below
       for more details.
